<?php
require_once "path.php";
$action = isset($_REQUEST["action"]) ? $_REQUEST["action"] : "";
if($action=="watch_logs" || $action=="scheduler_list_table" ){
	$_SESSION['updateSession']=false;
	session_write_close(); 	
}

if(!isset($_SESSION['validUser']) || $_SESSION['validUser'] !== true)
{
	header("Location:../index.php");
}

$arr = array();
switch($action) {
	case "update_job":
		try {	
			$job = isset($_REQUEST["job"]) ? $_REQUEST["job"] : "";
			$data = isset($_REQUEST["data"]) ? $_REQUEST["data"] : "";
			$weekday_selection = isset($_REQUEST["weekday_selection"]) ? $_REQUEST["weekday_selection"] : "";
			
			$start_immediately = $data['start_immediately'];			
			if($start_immediately!='') {
				$exp = explode($data["job_type"]."_",$job,2);
				$jobname = count($exp)>1?$exp[1]:$exp[0];
				$startPidPath  = Scheduler::$user_dir.$data["job_type"]."/".$jobname."/$startPid";
				if(file_exists($startPidPath)) {
					$arr["msg"] = "Job is already in progress. Please try again later";
					break;
				}
				
				Scheduler::Log('Starting ' . $data["job_type"] . ' Job: ' . $jobname);

				$path = Scheduler::$user_dir.$data["job_type"]."/".$jobname."/".ucfirst($data['job_type'])."setFileForDisplay.txt";
				if(filesize($path)>0){
					Scheduler::StartJobImmediately($job, $data["job_type"]);
					$exp = explode($data['job_type'],$job,2);
					if(count($exp)<=1){
						$job = $data['job_type'].'_'.$job;
					}					
					$updated_job = Scheduler::UpdateJobData($job, $data, $weekday_selection);		
					$arr["msg"] = "Job started successfully";
					$arr["jobs"] = $updated_job;
					Scheduler::Log(ucfirst($data["job_type"]) . 'Job Started Successfully: ' . $jobname);
				} else {
					$arr["msg"] = "Failed to start <b>".$jobname."</b>. Please add content to ".lcfirst($data['job_type'])." set and try again";
					Scheduler::Log('Failed to start ' . $data['job_type'] . ' job: ' . $jobname);
				}
			} else {
				$exp = explode($data['job_type'],$job,2);
				if(count($exp)<=1){
					$job = $data['job_type'].'_'.$job;
				}

				$updated_job = Scheduler::UpdateJobData($job, $data, $weekday_selection);
				$arr["msg"] = "Job updated successfully.";
				$arr["jobs"] = $updated_job;

				Scheduler::Log($data['job_type'] . 'Job: ' . $job . ' updated successfully.');
			}
		} catch (Exception $e) {
		    	$arr["msg"] = "Error in updating job";
		}

		break;

	case "delete_job":
		try {
			$job = isset($_REQUEST["job"]) ? $_REQUEST["job"] : "";
		    $updated_job = Scheduler::DeleteJob($job);
			$arr["msg"] = "Job deleted successfully.";
			$arr["jobs"] = $updated_job;

			Scheduler::Log('Job: ' . $job. ' deleted successfully.');
		} catch(Exception $e) {
		   	$arr["msg"] = "Error in deleting job";
		}		
		break;

	case "cancel_job":
		try {
			$job = isset($_REQUEST["job"]) ? $_REQUEST["job"] : "";
		    $cancel_job = Scheduler::CancelJob($job);
			$arr["msg"] = "Job cancelled successfully.";
			Scheduler::Log('Job: ' . $job. ' cancelled successfully.');
		} catch (Exception $e) {
		   	$arr["msg"] = "Error in cancelling job";
		}

		break;
	case "run_job_immediately":
		try {
			$job = isset($_REQUEST["job"]) ? $_REQUEST["job"] : "";
			$job_type = isset($_REQUEST["job_type"]) ? $_REQUEST["job_type"] : "";
		    Scheduler::StartJobImmediately($job, $job_type);
			$arr["msg"] = "Job Run successfully.";
			
			Scheduler::Log('Job: ' . $job. ' Run successfully.');
		} catch (Exception $e) {
		   	$arr["msg"] = "Error in running job";
		}

		break;
	case "cront_test":
		try {
			Scheduler::debug_Log("cront_test");
		} catch (Exception $e) {
		    	$arr["msg"] = "Error in cront_test";
		}		
		break;
	case "watch_logs":
		$updated_logs = Log::WatchLogs();
		$arr = $updated_logs;
		break;
	case "scheduler_list_table":
		$jobs = Scheduler::ReadJobs();
		$selected_job = isset($_REQUEST["selected_job"]) ? $_REQUEST["selected_job"] : "";
	?>
		
		<table width="100%" border="0" cellspacing="0" class="folderBackup jobs_table" cellpadding="6" align="center" >
        <?php 
		foreach($jobs as $k=>$job) {
			$job_type = $job["job_type"];
			$scheduler_selection = isset($job["scheduler"]["scheduler_selection"]) ? ucfirst($job["scheduler"]["scheduler_selection"]) : "";		
			if(isset($job["scheduler"]["weekday_selection"])) {
				$weekday_selection = json_decode($job["scheduler"]["weekday_selection"], true);

				if(($scheduler_selection == "Daily" || $scheduler_selection == "") && count($weekday_selection) < 7 && count($weekday_selection) > 0) {
					$scheduler_selection = "Weekly";
				}
				$weekday_selection = @implode(",", $weekday_selection);
				$weekday_selection = " - ".$weekday_selection;
			}else {
				$weekday_selection =  "";
			}
			if(isset($job["scheduler"]["start_minute"])) {
				$time = $job["scheduler"]["start_hour"].":".str_pad($job["scheduler"]["start_minute"], 2, '0', STR_PAD_LEFT)." ".strtoupper($job["scheduler"]["start_meridian"]);
			}else {
				$time = "";
			}
			if($scheduler_selection == "Hourly") {
				$time = "00:".str_pad($job["scheduler"]["start_minute"], 2, '0', STR_PAD_LEFT);
			}
			if($scheduler_selection == "Daily") {
				$weekday_selection =  "";
			}
			if($scheduler_selection == 'Monthly'){
				$weekday_selection =  " - ".$job["scheduler"]["day_of_month"].ordinal_suffix($job["scheduler"]["day_of_month"])." day";
			}
			if(isset($job["scheduler"]["start_immediately"])) {
				$scheduler_selection = "";
				$time = "";
			}
			
			$jobName = substr($k,(strlen($job["job_type"])+1));
			$selected_job = $selected_job==''?$k:$selected_job;
		?>
              <tr id="<?php print $k;?>" <?php if($selected_job == $k) {?> bgcolor="#EFF9FF" <?php }else {?>bgcolor="#FFFFFF" <?php }?>>
                <td class="action_jobname" title="<?php echo $jobName;?>" ><?php echo $jobName;?></td>
                <td class="action_jobtype" ><?php echo $job["job_type"];?></td>
                <td class="action_jobweekly" ><?php echo $scheduler_selection.$weekday_selection;?></td>
				<td class="action_jobtime" ><?php echo $time;?></td>
                <td class="action_cancel"><span <?php
					$jobInProgress = Scheduler::JobInProgress($jobName, $job_type);			
				if(!empty($jobInProgress)) {
					?>  class="ScheduledCancel_job"  <?php }else {?> class="DisableCancelJob"<?php }?> >Stop Job</span>
				</td>
				<td class="action_delete"> <span class="shdeuledDelete_job">Delete Job</span> </td>
              </tr>
			<?php
		} ?>
	
            </table>
	<?php

		break;
	case "log_list_table":
		$logs = Log::ReadLogs((isset($_GET['duration']) ? $_GET['duration'] : ''));
  		$no_logs = $logs["count"] == 0?' style="display:block"' : "";
		?>
		<script>
		IDrive.LogList = <?php echo json_encode($logs["logs"]);?>;
		</script>
		<div class="nfiles" <?php print $no_logs; ?> ><?php print NO_LOGS;?></div>
		<table width="100%" border="0" cellspacing="0" class="folderBackup logs_table" cellpadding="6" align="center" id="logRows">
		  
		</table>
		<?php

		break;
	case "rename":
		$oldPath = rawurldecode($_REQUEST["oldPath"]);
		$newPath = rawurldecode($_REQUEST["newPath"]);

		$oldPath = phpRealEscapeString($oldPath);
		$newPath = phpRealEscapeString($newPath);	

		$output = renamePath($oldPath, $newPath);
		$arr[] = $output;
		break;
	case "renameRestoreSetItems":
		$oldPath = rawurldecode($_REQUEST["oldPath"]);
		$newPath = rawurldecode($_REQUEST["newPath"]);
		
		$oldPath = phpRealEscapeString($oldPath);
		$newPath = phpRealEscapeString($newPath);
		
		$output = renameRestoreSetItems($oldPath, $newPath);
		$arr['backupLocation'] = renameBackupLocation($oldPath, $newPath);
		renameRestoreList($oldPath, $newPath);
		$remoteSearchDir = Scheduler::$user_dir."Restore/.+searchList/";
		systemCmdExecutionViaPerl("rm -r $remoteSearchDir");
		break;
	case "share":
		$userName = urlencode(rawurldecode($_SESSION['userName']));
		$password = urlencode(rawurldecode(base64_decode($_SESSION['password'])));
		$exp = explode("\n",$_REQUEST['sharedFiles']);
		
		$sharedFiles='';
		$itemPath = '';
		foreach($exp as $path){
			if(trim($path)!=''){
				$sharedFiles  .= "&PATHS=".urlencode($path);
				$itemPath .= $path."\n";
			}
		}
		
		$shareURL = SHARE_CGI_PATH;
		$shareURL .= "?USERNAME=$userName&PASSWORD=$password".$sharedFiles."&NEW=YES";
		$sharePage = getCurlOutput($shareURL);
		$xml = simplexml_load_string($sharePage);
		$output = (string)$xml->filehref['href'];
		
		$sharefiles = '';
		$itemName = '';
		$itemPath = rtrim($itemPath,"\n");
		$expItemPath = explode("\n",$itemPath);
		$inc=0;
		foreach($xml->filehref->item as $item){
			$currItemPath = rtrim($expItemPath[$inc],'/');
			$sharedPath = rtrim($currItemPath,$item);
			$sharefiles .= '<li class="f_name_view"><p>'.$item.'</p><div>Home'.$sharedPath.'</div><span></span></li>';
			$itemName .= $item."\n";	
			$inc++;
		}
		$itemName = rtrim($itemName,"\n");
		
		$sharefiles .= '<input type="hidden" name="itemName" id="itemName" value="'.htmlentities($itemName,ENT_QUOTES).'" />';
		$sharefiles .= '<input type="hidden" name="itemPath" id="itemPath" value="'.htmlentities($itemPath,ENT_QUOTES).'" />';
		
		$arr['shareLink'] = $output;
		$arr['sharePath'] = $sharefiles;
		break;
	case "sendShareEmail":
		$shareLinkDisp = $_REQUEST['shareLinkDisp'];
		$mailcontent  = rawurldecode($_REQUEST['mailcontent']);
		$emailAddress = $_REQUEST['emailAddress'];		
		
		$itemName  = rawurldecode($_REQUEST['itemName']);
		$itemPath  = $_REQUEST['itemPath'];
		$shareType = $_REQUEST['shareType'];
		
		if(!empty($_SESSION['userName'])){
			$userName = rawurldecode($_SESSION['userName']);
			$password = rawurldecode(base64_decode($_SESSION['password']));
			
			$i=0;
			$itemNameArray = explode("\n",$itemName);
			$itemPathArray = explode("\n",$itemPath);
			$itemTypeArray = explode("\n",$shareType);	
			
			foreach($itemNameArray as $items){
				$type = $itemTypeArray[$i]=='folder'?0:1;
				$itemArr[] = array('filename'=>urlencode(trim($items,"\r")),'resfull_path'=>urlencode(trim($itemPathArray[$i],"\r")),'res_type'=>$type);				
				$i++;
			}
			$exp = explode('/sh?k=',$shareLinkDisp);
			$share_details['shareid'] = $exp[1];
			$share_details['file_details'] = $itemArr;
			
			$shareURL = SHARE_EMAIL_CGI_PATH;
			$shareURL .= '?uid='.urlencode($userName).'&pwd='.urlencode($password);
			$shareURL .= '&to='.urlencode($emailAddress).'&comments='.urlencode($mailcontent);
			$shareURL .= '&share_details='.json_encode($share_details);	

			$sharePage = getCurlOutput($shareURL);
			if(trim($sharePage)=="SUCCESS"){
				$arr[] = true;
			} else {
				$arr[] = false;
			}
			
		} else {
			$arr[] = false;
		}

		break;
	case "getVersionDetails" :
		$itemName = $_REQUEST['itemName'];
		$arr = getVersionInfo($itemName);
		$arr[] = $itemName;
		break;
	case "getDetail":
		$itemName = $_REQUEST['itemName'];
		$itemNameLength = $_REQUEST["itemNameLength"];		
		$itemName = phpRealEscapeString($itemName);		
		$arr = getProperties($itemName);
		$explode = explode("/",$itemName);
		$itemName = array_pop($explode);
		$arr[] = $itemName;
		$arr[] = "Home".implode("/",$explode)."/";
		break;
	case "createDir";
		$newDirName = rawurldecode($_REQUEST['newDirName']);
		$newDirPath = rawurldecode($_REQUEST['newDirPath']);
		$newDirPathLength = $_REQUEST['newDirPathLength'];
		$newDirNameLength = $_REQUEST['newDirNameLength'];

		$newDirName = phpRealEscapeString($newDirName);
		$newDirPath = phpRealEscapeString($newDirPath);

		$out = createDir($newDirName, $newDirPath, $_SESSION['encType']);
		$arr[] = $out[0];
		
		if(strpos($out[1],'folder exists')){
			$arr[] = 'Folder name already exists';
		} else {
			$arr[]= "Folder <b>$newDirName</b> has been created successfully";
			Scheduler::Log('Directory ' . $newDirName . ' has been created successfully');
			updateNewDirInRestoreList($newDirPath,$newDirName);
			$remoteSearchDir = Scheduler::$user_dir."Restore/.+searchList/";
			systemCmdExecutionViaPerl("rm -r $remoteSearchDir");			
		}
		$arr[] = date('Y/m/d h:i:s A'); //2014/09/23 05:54:40 PM		
		break;
	case "startLocalSearch":
		if(isset($_SESSION['localPatternPath'])){
			unset($_SESSION['localPatternPath']);
			unset($_SESSION['currentLocalSearchPath']);
		}	
		
		$searchKeyword = searchKeyword(rawurldecode($_REQUEST['searchKeyword'])); //Constructing keyword
		$searchKeyword = phpRealEscapeString($searchKeyword);
		$searchKeyword = trim($searchKeyword,'/');
		$searchPath    = rawurldecode($_REQUEST['searchPath']);		
		$searchPath    = phpRealEscapeString($searchPath);
		$localSearchPath = Scheduler::$user_dir."Backup/.+searchList";
		
		Scheduler::Log('Local Search: ' + $searchKeyword);
		if(!is_dir($localSearchPath)){
			/* Creating the directory ".+searchList" if not exist */
			if(!mkdir($localSearchPath, $permissionVal)){
				$arr[] = "Failed to create Directory $localSearchPath";
			}
			@chmod($localSearchPath, $permissionVal);
		}
		
		$searchKeyword = getSearchPattern($searchKeyword); 
		$localPatternPath = createSearchDir($searchPath.$searchKeyword,$localSearchPath);
		if(file_exists($localPatternPath."/page1")){
			$_SESSION['localPatternPath'] = $localPatternPath;
			$_SESSION['currentLocalSearchPath'] = $localPatternPath."/";
			$arr[] = false;
			break;
		}

		createLocalSearchTxt($localPatternPath,$searchKeyword,$searchPath);
		if(filesize("$localPatternPath/".SEARCH_FILE)>0) {
			if(!($handle = fopen("$localPatternPath/".PID_FILE, "w"))){
				Scheduler::Log("Failed to create $localPatternPath/" . PID_FILE);
				exit;
			}
			else{
			@chmod("$localPatternPath/".PID_FILE, $permissionVal);
			}
			
			$exec = perlScriptExecution("localSearch.pl","$localPatternPath",0);
			pclose(popen("$exec &","r"));

			Scheduler::Log('Local search started: ' + $searchKeyword);

			$_SESSION['localPatternPath'] = $localPatternPath;
			$_SESSION['currentLocalSearchPath'] = $localPatternPath."/";
			$arr[] = true;
		}
		break;
	case "getSearchRes":
		$currPage = isset($_REQUEST['page'])?"page".$_REQUEST['page']:"page1";
		$type = $_REQUEST['type'];
		$Resultcount = $_REQUEST['count'];
		$isflag = 0;
		if($type=='backup'){
			$localPatternPath = $_SESSION['localPatternPath'];
			if($_REQUEST['page']==1){
				$count = 0;
				$isflag = 1;		
				while(!is_dir($localPatternPath)){
					sleep(2);
					$count++;
					if($count >= 60){
						$isflag = 0;
						break;
					}
				}
				$path = $localPatternPath."/";
			} else {
				$path = $_SESSION['currentLocalSearchPath'];
				$isflag = 1;
			}
			if($isflag==1){
				$page = $path.$currPage;
				$arr = getSearchResult($page,$path.PID_FILE,$Resultcount);
				}			
		} else if($type=='restore'){	
			$path = $_SESSION['currentRemoteSearchPath'];
			$page = $path.$currPage;			
			$arr = getSearchResult($page,$path.PID_FILE,$Resultcount);
		}	
		break;
	case "stopSearch":
		if($_REQUEST['type']=='backup' and !empty($_SESSION['currentLocalSearchPath'])){
			$cmd = perlScriptExecution(JOBTERMINATE,$_SESSION['currentLocalSearchPath'],0);		
			pclose(popen("$cmd &","r"));
		}
		else if($_REQUEST['type']=='restore' and !empty($_SESSION['currentRemoteSearchPath'])){
			$cmd = perlScriptExecution(JOBTERMINATE,$_SESSION['currentRemoteSearchPath'],0, FALSE, TRUE);
			pclose(popen("$cmd &","r"));
		}
		else if($_REQUEST['type']=='archive'){	//Modified by Sajana for Archive Cleanup job termination...
			$_SESSION["progress_stat"] = 1;
			$archive_dir = Scheduler::$archiveclean_dir.$_SESSION['manual_backupset']."/";
			$cmd = perlScriptExecution(JOBTERMINATE,$archive_dir,0);		
			pclose(popen("$cmd &","r"));
			$resultfile = $archive_dir.ARCHIVERESULT;
			$countfile = $archive_dir.ARCHIVECOUNT;
			$cleanupStatusFile = $archive_dir.CLEANUP_STATUS;
			
			@unlink($resultfile);
			@unlink($countfile);
			@unlink($cleanupStatusFile);			
		}
		else if($_REQUEST['type']=='removeArchivePid'){
			$archive_dir = Scheduler::$archiveclean_dir.$_SESSION['manual_backupset']."/";
			$archivePid = $archive_dir.PID_FILE;
			$resultfile = $archive_dir.ARCHIVERESULT;
			$countfile = $archive_dir.ARCHIVECOUNT;
			@unlink($archivePid);
			@unlink($resultfile);
			@unlink($countfile);			
		}
		else{
			$res = "is not running";
		}
		
		$arr[] = true;
		$arr[] = "Execution Terminated";
		break;
	case "startRemoteSearch":
		if(isset($_SESSION['currentRemoteSearchPath'])){
			unset($_SESSION['currentRemoteSearchPath']);
		}
		
		$searchKeyword = strtolower(rawurldecode($_REQUEST['searchKeyword']));
		$searchKeyword = getSearchPattern($searchKeyword);
		$searchPath    = rawurldecode($_REQUEST['searchPath']);
		
		Scheduler::Log('Remote search: ' + $searchKeyword);

		$arr[] = remoteSearch($searchKeyword,$searchPath);		
		break;
	case "setEncryption":
		$encType = ucfirst($_POST['encryptionKey']);
		$passwrd =  base64_decode($_SESSION['password']);
		
		$pvtKey ='';
		if($encType!='DEFAULT'){
		$pvtKey = $_POST['pvtKey'];
		}
		
		encodePathWrapper($passwrd, $encType, $pvtKey);
		$confXmlArray = confAccount($encType);		
		$result = (string)$confXmlArray['message'];
		if($result == "SUCCESS"){
			$dir = getNAShostname();
			$dirOutput = createDir($dir, "", $encType);
			
			$_SESSION['configVerified'] = true;
			$_SESSION['encType'] = $encType;
			$arr[] = true;
			
		} else {
			$arr[] = false;
			$arr[] = INVALID_CREDENTIAL;
		}		
		break;
	case "validateEncryption":
		$encType = 'Private';
		$passwrd = base64_decode($_SESSION['password']);
		$pvtKey = phpRealEscapeString($_POST['encryptKey']);
		encodePathWrapper($passwrd, $encType, $pvtKey);
		
		$serverOutput = getEVSServerAddr(); //Getting & Assigning EVS server address to session variable
		if($serverOutput != ''){			
			$dir = getNAShostname();		
			$dirOutput = createDir($dir, "", $encType);	
			if(strpos($dirOutput[1], "encryption verification failed") !== false){				
				$encPvtkeyPath = Scheduler::$user_dir."IDPVT";
				$result = "FAIL";
				unlink($encPvtkeyPath);
				$arr[] = false;
				$arr[] = INVALID_PRIVATE_KEY;				
			} else {
				$_SESSION['configVerified'] = true;
				$_SESSION['encType'] = $encType;
				$arr[] = true;
			}
		}	
		else {
				$arr[] = false;
				$arr[] = NO_EVS_SERVER;
		}	
				
		break;		
	case "addToExcludeList":		//Added by sajana and modified by Deepak for addToExcludeList option...
		$itemName = rtrim(rawurldecode(trim($_REQUEST['itemName'])),'/');
		$itemType = trim($_REQUEST['itemType']);
		$itemName = phpRealEscapeString($itemName);

		$exludeStatus = addToExcludeList($itemName, $itemType, $excludeFullFile);
		
		$_SESSION['fullEntry'] = file($excludeFullFile, FILE_IGNORE_NEW_LINES);

		$arr	= array($exludeStatus[0], $exludeStatus[1]);
		break;
	case "getSharedList";
		unset($_SESSION['sharedDirectoriesRaw']);
		getSharedList();
		break;
	case "createDefaultBackupSet";
		createDefaultBackupSet();
		break;
	case "deleteArchive" : // archive cleanup delete call.
			$selected_backupset = $_SESSION['manual_backupset'];
			$deleteFile = Scheduler::$archiveclean_dir.$selected_backupset."/".ARCHIVERESULT;
			$delStatus = deleteItems(ARCHIVEOP,$deleteFile); 
			if($delStatus == "")
				$arr[0]=true;
			else
				$arr[0]=$delStatus;
			
			$arr[1] = $_SESSION['deleteCommand'];
		break;		
	case "archiveStatus" : // archive cleanup file progress.
		$jobName = Scheduler::$manual_dir;
		$countFile = Scheduler::$archiveclean_dir.$jobName."/".ARCHIVECOUNT;
		$cleanupStatusFile = Scheduler::$archiveclean_dir.$jobName."/".CLEANUP_STATUS;
		
		$arr['operation_status'] = "scanning";
		
		if(file_exists($cleanupStatusFile)){
			$status = file_get_contents($cleanupStatusFile);
			
			$exp = explode("\n",trim($status));
			foreach($exp as $line){
				if($line=='progress_stat=1'){
					$arr['operation_status'] = "completed";
					@unlink($cleanupStatusFile);
				} elseif(strstr($line,'ERR=')){
					$error = str_replace("ERR=","",$line);
					$arr['Error'] = trim($error); 
				}
			}
		}
		
		$arr['total_count'] = 0;
		if(file_exists($countFile)){
			$readCount = file_get_contents($countFile);
			$countValues = explode("\n", $readCount);
			$arr['files_scanned'] = trim($countValues[1]);
			$arr['total_count'] = trim($countValues[2]); 
		}
		break;
	case "archivePerc" : //archive percentage 
		$countFile = Scheduler::$archiveclean_dir.$_SESSION['manual_backupset']."/".ARCHIVECOUNT;
		$readCount = file_get_contents($countFile);
		$countValues = explode("\n", $readCount);
		$arr['manualPerc'] = $_SESSION['manual_per'];
		$arr['total_count'] = $countValues[2];
		$arr['total_del_count'] = $countValues[3];
		break;
	case "deleteCancel":
		$archive_dir = Scheduler::$archiveclean_dir.$_SESSION['manual_backupset']."/";
		Scheduler::debug_Log("perlScriptExecution--archivedir " . $archive_dir);
		$cmd = perlScriptExecution(JOBTERMINATE,$archive_dir,0);		
		pclose(popen("$cmd &","r"));
		break;
	case "checkJobRunning":
		$archivePath = Scheduler::$archiveclean_dir;
		$jobstatus = checkIfJobRunning($archivePath);
		$arr['jobstatus'] = false;
		if($jobstatus == 1)
			$arr['jobstatus'] = true;
				
		break;
	case "checkWritePermission":
		$itemName = $_REQUEST['dirPath'];
		$itemName = phpRealEscapeString($itemName);		
		$permissionCode = decoct(fileperms($itemName) & 0777); // return "755" for example
		$firstChar = substr(trim($permissionCode),0,1);
		if($firstChar>=4)
			$arr[] = true;
		else
			$arr[] = false;
		break;
	case "ScheduledTaskWatcher":
		$startPidPath   = Scheduler::$user_dir."Backup/Default Backup Set/$startPid";
		$userCancelFile = Scheduler::$user_dir."Backup/Default Backup Set/".CANCEL_PATH;
		$arr[] = file_exists($startPidPath)?true:false;
		$arr[] = file_exists($userCancelFile)?true:false;
		break;
	case "update":
       	$output = updateIDriveApp();
		header('Location: /'.CONFIG.'/logout.php');
       	break;
	case "getProxySettings":
		$output = getProxySettings();
		if(count($output)>0){
			$ipAddress  = trim($output[0]);
			$port 		= trim($output[1]);
			$username 	= trim($output[2]);
			$password 	= base64_encode(urlencode(trim($output[3])));		
			
			$arr[] = true;
			$arr[] = array('ipAddress'=>$ipAddress,'port'=>$port,'username'=>$username,'password'=>$password);
			$arr[] = PROXY_DETECTED;
			$_SESSION['proxy_option']   = 'autodetect';
			$_SESSION['ipAddress']      = $ipAddress;
			$_SESSION['port']           = $port;
			$_SESSION['proxyUserName']  = $username;
			$_SESSION['proxyPassword']  = $password;			
		} else {
			$arr[] = false;
			$arr[] = NO_PROXY;
			if(isset($_SESSION['proxy_option'])) 
				unset($_SESSION['proxy_option']);
			if(isset($_SESSION['ipAddress'])) 
				unset($_SESSION['ipAddress']);
			if(isset($_SESSION['port'])) 
				unset($_SESSION['port']);
			if(isset($_SESSION['proxyUserName'])) 
				unset($_SESSION['proxyUserName']);
			if(isset($_SESSION['proxyPassword'])) 
				unset($_SESSION['proxyPassword']);
		}
		break;
	case "refresh":
		$dirName = rawurldecode($_REQUEST['dirName']);
		$type = $_REQUEST['type'];
		if($type=='restore'){
			$rListPath = Scheduler::$user_dir.".RestoreList/$dirName";
			if(is_dir($rListPath)){
				file_put_contents($temp_file, CMDEXECUTE);
				file_put_contents($temp_file,"\nrm -rf '$rListPath'",FILE_APPEND);
				@chmod($temp_file, $permissionVal);
				perlScriptExecution(OPERATIONSFILE, Scheduler::$user_dir);
			}		
			if(file_exists($searchDirRemote)){
				file_put_contents($temp_file, CMDEXECUTE);
				file_put_contents($temp_file,"\nrm -rf '$searchDirRemote'",FILE_APPEND);
				@chmod($temp_file, $permissionVal);
				perlScriptExecution(OPERATIONSFILE, Scheduler::$user_dir);
			}			
		} else if($type=='backup'){
			unset($_SESSION['sharedDirectoriesRaw']);
			getSharedList();
			
			if(file_exists($searchDirLocal)){
				file_put_contents($temp_file, CMDEXECUTE);
				file_put_contents($temp_file,"\nrm -rf '$searchDirLocal'",FILE_APPEND);
				@chmod($temp_file, $permissionVal);
				perlScriptExecution(OPERATIONSFILE, Scheduler::$user_dir);
			}			
			autoUpdateBackupset();
		}
		break;
	case "removeArchivePid":
		$archive_dir = Scheduler::$archiveclean_dir.$_SESSION['manual_backupset']."/";
		$pid = $archive_dir."pid.txt";
		@unlink($pid);
		break;
	case "readErrorInfo":
		# Sabin Cheruvattil - log file check here and warn user when they click the send button
		$log_rel_path	= '.trace/' . LOG_FILE;
		$trace_rel_path = '.trace/' . TRACE_LOG_FILE;

		$logSendWarning = '';
		if($_SESSION['userName'] != '') {
			$logSize 		= filesize(Scheduler::$user_dir . $log_rel_path);
			$traceLogSize 	= filesize(Scheduler::$user_dir . $trace_rel_path);
			$errorInfoPath 	= Scheduler::$user_dir . 'sendErrorInfo.txt';
			
			if((($logSize + $traceLogSize) / (1024 * 1024)) >= SEND_ERROR_LOG_WARN_SIZE) {
				$logSendWarning = 'It may take a while to prepare your error report. Please wait...';
			}
		}
		
		$arr = array();
		if($errorInfoPath != '' && file_exists($errorInfoPath)) {
			$arr 					= file_get_contents($errorInfoPath);
			$arr					= json_decode($arr, TRUE);
		} else {
			$arr['username'] 		= $_SESSION['userName'];
		}
		
		$arr['logSendWarning']	= $logSendWarning;
		
		echo json_encode($arr);
		break;
	case 'getNextScheduledTask':
		echo json_encode(getNextScheduledTask());
		break;
}
$html_action = array("scheduler_list_table", "log_list_table", "readErrorInfo", 'getNextScheduledTask');
if(!in_array($action, $html_action)) {
	echo json_encode($arr);
}
exit;

?>
