<?php
ini_set('max_execution_time', 0);
error_reporting(0);
#ini_set('display_errors', 'ON');
include_once 'constants.php';
session_start();

if(!isset($_SESSION['httpuser'])) {
	$_SESSION['httpuser'] = exec('whoami');
}

# populate base session
if(!isset($_SESSION['machine']) || !isset($_SESSION['webDir']) || !isset($_SESSION['baseDir']) || !isset($_SESSION['nasUser']) || !isset($_SESSION['permission']) || empty($_SESSION['permission'])) {
	$configFilehash = readConfFile();
}

if(!isset($_SESSION['haslsdatetimeformat'])) {
	$_SESSION['haslsdatetimeformat'] = exec('ls --time-style="+%a %b %e %H:%M:%S %Y" &> /dev/null ; echo $?');
}

$permissionVal	= $_SESSION['permission'];
$webDir 		= isset($_SESSION['webDir'])? $_SESSION['webDir'] : '';
$baseDir 		= isset($_SESSION['baseDir'])? $_SESSION['baseDir'] : '';
$user    		= isset($_SESSION['nasUser'])? $_SESSION['nasUser'] : '';
$machine 		= isset($_SESSION['machine'])? $_SESSION['machine'] : '';

$perlPath = getPerlPath();

include_once 'common.php';
$twoTierSharePathLength = strlen(TWOTIER_SHARED_PATH)-1;

/*********************************************************************************************************
* Subroutine Name       : getPerlPath
* Objective             : This function will return full path for perl based on machine type
* Added By              : Deepak Chaurasia
**********************************************************************************************************/
function getPerlPath()
{
	GLOBAL $machine;
	GLOBAL $appPerlPath;
	
	if(!isset($_SESSION['perlPath'])){
		machineBasedContent($machine);
		if("twotier" == $machine)
			$perlPath = $appPerlPath;
		else {
			$command = "which perl";
			$perlPath=shell_exec($command);
			$perlPath = trim($perlPath);

			if($perlPath == '')
				$perlPath = $appPerlPath;
		}
		$_SESSION['perlPath'] = $perlPath;
	} 
	else 
		$perlPath = $_SESSION['perlPath'];
	
	return $perlPath;
}
/*********************************************************************************************************
* Subroutine Name       : getPhpPath
* Objective             : This function will return full path for PHP based on machine type
* Added By              : Senthil Pandian
**********************************************************************************************************/
function getPhpPath()
{
	GLOBAL $machine;
	GLOBAL $appPHPPath;
	if(!isset($_SESSION['phpPath'])){
		machineBasedContent($machine);
		if ("twotier" == $machine)
			$phpPath = $appPHPPath;
		else {
			$command = "which php";
			$phpPath=shell_exec($command);
			$phpPath = trim($phpPath);

			if($phpPath == '')
				$phpPath = $appPHPPath;
		}
		$_SESSION['phpPath'] = $phpPath;
	} 
	else 
		$phpPath = $_SESSION['phpPath'];
	return $phpPath;
}

/*********************************************************************************************************
* Subroutine Name       : appServices
* Objective             : Build and write perl commands to a file.
* Added By              : Yogesh Kumar P
* Modified By 			: Avinash Kumar
**********************************************************************************************************/
function appServices($script, $currPath) {
	GLOBAL $machine;
	GLOBAL $appPath;
	GLOBAL $perlPath;
	GLOBAL $baseDir;
	GLOBAL $webDir;
	GLOBAL $userName,$permissionVal;
	
	if($currPath==""){
		$currPath = getcwd();
	}

	$currPath = str_replace("'","'\''",$currPath);
	$currPath = str_replace('"','\"',$currPath);
	$currPath = str_replace('$','\$',$currPath);
	$currPath = "'".$currPath."'";
	
	$tempFile    = "$baseDir/$webDir/".SERVICE."/".USER_PROFILE;
	$tempFile   .= "/$userName/".TEMP_OPERATION_FILE;
	$contentFile = NULL;
	
	if (file_exists($tempFile)) {
		$contents     = file($tempFile, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
		$contentFile  = "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/";
		$contentFile .= ('temp_' . time() . '.txt');
		$firstTime = TRUE;
		
		foreach($contents as $content) {
			if ($firstTime) {
				file_put_contents((__DIR__ . "/" . SCHEDULERFILE),
				('echo ' . escapeshellarg($content) . ' > ' . $contentFile . PHP_EOL), FILE_APPEND);
				$firstTime = FALSE;
			}
			else {
				file_put_contents((__DIR__ . "/" . SCHEDULERFILE),
				('echo ' . escapeshellarg($content) . ' >> ' . $contentFile . PHP_EOL), FILE_APPEND);
			}
		}
		file_put_contents((__DIR__ . "/" . SCHEDULERFILE), "rm -rf $tempFile" . PHP_EOL, FILE_APPEND);
	}
	$command = "cd $currPath; " . " $perlPath \"$appPath/" . SCRIPT . "/$script\"";
	if ($contentFile !== NULL) {
		$command .= (" $contentFile ");
	}
	file_put_contents((__DIR__ . "/" . SCHEDULERFILE), ($command . "\n"), FILE_APPEND);
	@chmod((__DIR__ . "/" . SCHEDULERFILE), $permissionVal);
	
	return '';
}

/*********************************************************************************************************
* Subroutine Name       : isJpbRunning.
* Objective             : Chaeck job is running or not through lock on StartPid.txt.
* Added By              : Avinash Kumar.
**********************************************************************************************************/
function isJobRunning($startPidPath)
{
	$lockFlag = 0;
	if(file_exists($startPidPath)){
		$fp = fopen($startPidPath, 'a');
		if(!flock($fp, LOCK_EX|LOCK_NB, $lockFlag)){
			Scheduler::Log("Job is running: " . dirname($startPidPath));	
		}
		fclose($fp);
	}
	return $lockFlag;
}

/*********************************************************************************************************
* Subroutine Name       : cancelJobAfterTerminate.
* Objective             : Remove userCancel.txt if required.
* Added By              : Avinash Kumar.
**********************************************************************************************************/
function cancelJobAfterTerminate($jobPath)
{
	GLOBAL $userCancelFile;
	GLOBAL $pidPath;
	
	$jobs = glob($jobPath . '*' , GLOB_ONLYDIR);
	for($k = 0; $k < count($jobs); $k++){
		$actualPidPath = $jobs[$k]."/$pidPath";
		$actualUserCancelPath = $jobs[$k]."/$userCancelFile";
		
		// if pid is not available but user cancel is there sleep for 5 sec and unlink user cancle.
		if((!file_exists($actualPidPath)) && file_exists($actualUserCancelPath)){
			sleep(5);
			unlink($actualUserCancelPath);
		}
	}
}

/*********************************************************************************************************
* Subroutine Name       : clearPid.
* Objective             : Remove pid.txt if required.
* Added By              : Avinash Kumar.
**********************************************************************************************************/
function clearPid($jobPath)
{
	GLOBAL $pidPath;
	
	/* check pid.txt existance */
	$jobs = glob($jobPath . '*' , GLOB_ONLYDIR);
	for($k = 0; $k < count($jobs); $k++){
		$actualPidPath = $jobs[$k]."/$pidPath";
		if(file_exists($actualPidPath)){
			Scheduler::debug_Log("clearPid: " . $actualPidPath);	
			
			/* check lock on pid.txt */
			if(!($handle = fopen($actualPidPath, "w"))){
				Scheduler::Log("Failed to open $actualPidPath");
				exit;
			}
			else{
				if(flock($handle, LOCK_EX|LOCK_NB, $lockFlag)){
					Scheduler::Log("Trying to remove $actualPidPath");
					unlink($actualPidPath);
				}
			}
		}
	}
}
/*********************************************************************************************************
* Subroutine Name       : clearStartPid.
* Objective             : Remove StartPid.txt if required.
* Added By              : Avinash Kumar.
**********************************************************************************************************/
function clearStartPid($jobPath)
{
	GLOBAL $pidPath,$permissionVal;
	$logpid = LOG_PID_FILE;
	 
	/* check StartPid.txt existance in each backup job */
	$jobs = glob($jobPath . '*' , GLOB_ONLYDIR);
	for($k = 0; $k < count($jobs); $k++){
		$jobRunningFlag = 0;
		$startPidPath = $jobs[$k]."/".START_PID;
		$jobPidPath = $jobs[$k]."/".$pidPath;
		$userCancelPath = $jobs[$k]."/".CANCEL_PATH;
		
		if(!file_exists($startPidPath) && !file_exists($jobPidPath) && !file_exists($userCancelPath)) {
			# Scheduler::Log("[startPidFile | jobPidFile | userCancelFile] not found, Going back.");	
			continue;
		}
		
		/* job is running or not. */
		$jobRunningFlag = isJobRunning($startPidPath);
		if($jobRunningFlag)
			continue;
		
		@unlink($startPidPath);
		@unlink($jobPidPath);
		@unlink($userCancelPath);
		$logpidPath = $jobs[$k]."/".$logpid;
		
		if(!file_exists($logpidPath))
			continue;
		
		$logpidContent = file_get_contents($logpidPath);
		$logpidContent = trim($logpidContent);
	
		if(!file_exists($logpidContent)){
			@unlink($logpidPath);
		}
			
		if(strpos($logpidContent,"_SUCCESS")=== false && strpos($logpidContent,"_ABORTED")=== false && strpos($logpidContent,"_FAILURE")=== false){
			$logFileNew = $logpidContent."_FAILURE";
			
			$cmdToMove = "mv '$logpidContent' '$logFileNew'";
			systemCmdExecutionViaPerl($cmdToMove);
			
			file_put_contents($logpidPath,$logFileNew);
			@chmod($logpidPath, $permissionVal);
		}
	}
}

/*********************************************************************************************************
* Subroutine Name       : perlScriptExecution
* Objective             : Executes the perl script provided
* Added By              : Deepak Chaurasia
* Modified By           : Yogesh Kumar
**********************************************************************************************************/
function perlScriptExecution($script, $currPath="", $needExecute=1, $cronUpdate=FALSE, $useHTTP=FALSE)
{
	GLOBAL $machine;
	GLOBAL $user;
	GLOBAL $appPath;
	GLOBAL $appSudoPath;

	// In case for non admin users, cron updates are not possible.
	// So executing the commands via Idrive services.
	if (('QNAP' == $machine) && ($_SESSION['nasUserName'] != 'admin') &&
		$cronUpdate) {
		return appServices($script, $currPath);
	}
	else if (('synology'==$machine || ASUSTOR==$machine) && ($_SESSION['nasUserName'] != 'root') &&
		isset($_SESSION['encryptedToken']) && !empty($_SESSION['encryptedToken']) && $cronUpdate) {
		return appServices($script, $currPath);
	}

	$command = "";
	$scriptPath = "$appPath/".SCRIPT;
	$phpPath    =  "$appPath/".CONFIG;
	$suPath = "$phpPath/su";
	$nasUserName = $_SESSION['nasUserName'];	
	$perlPath = getPerlPath();
	
	if("synology" == $machine || "QNAP"==$machine || ASUSTOR==$machine){
		if($currPath=="")
			$currPath = getcwd();
	
		$currPath = str_replace("'","'\''",$currPath);
		$currPath = str_replace('"','\"',$currPath);
		$currPath = str_replace('$','\$',$currPath);
		$currPath = "'".$currPath."'";
		
		if((("synology"==$machine || ASUSTOR==$machine) && empty($_SESSION['encryptedToken'])) || $useHTTP)
			$command = "cd $currPath; $perlPath \"$scriptPath/$script\"";
		else {
			$phpbinPath = getPhpPath();
			putenv("TOKEN=$nasUserName");
			$TOKEN = 'TOKEN';
			$str    = $_SESSION['encryptedToken'].$_COOKIE['encryptedToken'];
			$command = "$phpbinPath $phpPath/token.php $str | $suPath -c \"cd $currPath; $perlPath \"$scriptPath/$script\"\"";
			$command .= " \"$$TOKEN\"";
		}
	} 
	else {
		if($currPath == "")
			$currPath = getcwd();
		
		$currPath = str_replace("'","'\''",$currPath);
		$currPath = "'".$currPath."'";
		$command = "cd $currPath;";
		machineBasedContent($machine);
		$command .= "$appSudoPath -u $user $perlPath $scriptPath/$script";
	}

	if($needExecute){
		if("QNAP"==$machine || ASUSTOR==$machine || ('synology'==$machine && !empty($_SESSION['encryptedToken']))){
			$res=shell_exec($command);
			$stOutput = preg_replace('/^Password: /', '', $res);			
		} 
		else
			$stOutput=shell_exec($command);
		return $stOutput;
	}
	else
		return $command;
} 

/*********************************************************************************************************
* Subroutine Name       : systemCmdExecution
* Objective             : Executes the system commands provided
* Added By              : Deepak Chaurasia
**********************************************************************************************************/
function systemCmdExecution($script, $needExecute=1, $currPath='')
{
	GLOBAL $machine;
	GLOBAL $user;
	GLOBAL $appPath;
	GLOBAL $appSudoPath;
	
	$command = "";
	$nasUserName = $_SESSION['nasUserName'];

	if("synology" == $machine || "QNAP" == $machine || ASUSTOR == $machine){
		if ($currPath === '') 
			$currPath = getcwd();
	
		$phpPath =  "$appPath/".CONFIG;
		$suPath = "$phpPath/su";
		
		if ("synology" == $machine && empty($_SESSION['encryptedToken'])) 
			$command = "$script";
		else {
			putenv("TOKEN=$nasUserName");
			$TOKEN = 'TOKEN';
			$str = $_SESSION['encryptedToken'].$_COOKIE['encryptedToken'];
			$phpbinPath = getPhpPath();
			$command = "$phpbinPath $phpPath/token.php $str | $suPath -c \"cd $currPath; $script\"";
			$command .= " \"$$TOKEN\"";
		}
	}	
	else {
		machineBasedContent($machine);
		if ($currPath !== '')
			$command .= "cd $currPath ";
		$command .= "$appSudoPath -u $user $script";
	}
	
	if($needExecute){
		if("QNAP"==$machine || ASUSTOR==$machine || ('synology'==$machine && !empty($_SESSION['encryptedToken']))){
			$res=shell_exec($command);
			$stOutput = preg_replace('/^Password: /', '', $res);
		} 
		else
			$stOutput=shell_exec($command);
		return $stOutput;
	}
	else
		return $command;
}

/****************************************************************************************************
* Subroutine Name         : systemCmdExecutionViaPerl.
* Objective               : To execute system commands via perl
* Added By                : Pooja Havaldar
* Modified By			  : Avinash Kumar
******************************************************************************************************/
function systemCmdExecutionViaPerl($script)
{
	GLOBAL $webDir;
	GLOBAL $baseDir;
	GLOBAL $userName;
	GLOBAL $temp_file,$permissionVal; 

	$userType = shell_exec("whoami");
	$userType = rtrim($userType);
	if("root" === $userType) {
		if(is_array($script)){
			for($j = 0; $j < sizeof($script); $j++){
				shell_exec($script[$j]);
			}
		}
		else{
			shell_exec($script);
		}
		return;
	}

	$operation = "commandExecution\n";
    if(empty($script)) 
        return false;
    
    file_put_contents($temp_file,$operation);
    
    if(is_array($script)){
		$script = implode("\n", $script);
	}
	file_put_contents($temp_file,$script."\n",FILE_APPEND);
	@chmod($temp_file, $permissionVal);
    perlScriptExecution(OPERATIONSFILE, Scheduler::$user_dir);
}

/****************************************************************************************************
* Subroutine Name         : createDefaultBackupSet.
* Objective               : To create befault backupset file.
* Added By                : Avinash Kumar.
* Modified By             : Senthil Pandian.K
* Modified On             : 25-06-2015
******************************************************************************************************/
function createDefaultBackupSet()
{
	GLOBAL $machine;
 	GLOBAL $appPath;
	GLOBAL $permissionVal;
	
	$publicPath = "";
	//$sharedPath = "";
	$multimediaPath = "";
	$downloadPath = "";
					
	$backupSetDisplayFile = Scheduler::$backup_dir."Default Backup Set/".BACKUPSETFILEDISPLAY;
	
	if(!file_exists($backupSetDisplayFile)){
		$backupSetDisplayContent = '';

		if("synology" == $machine)
		{			
			$shared = getSynologySharedFolders(SYNOLOGY_AVOID_PROP);

			foreach($shared as $dir => $property) {
				if(strtolower($property['realName']) == 'public') {
					$backupSetDisplayContent .= $dir . "\nfolder\n";
				}

				if(strtolower($property['realName']) == 'shared') {
					$backupSetDisplayContent .= $dir . "\nfolder\n";
				}		
			}		
		}
		else if("QNAP" == $machine)
		{	
			$shared = getQNAPSharedFolders();	
			foreach($shared as $dirName=>$property){
				$publicPathRes = strPos("$dirName/",'/Public/');
				if($publicPathRes>0){
					$backupSetDisplayContent .= $dirName."\nfolder\n";
				}
				$multimediaPathRes = strPos("$dirName/",'/Multimedia/');
				if($multimediaPathRes>0){
					$backupSetDisplayContent .= $dirName."\nfolder\n";
				} 
				$downloadPathRes = strPos("$dirName/",'/Download/');
				if($downloadPathRes>0){
					$backupSetDisplayContent .= $dirName."\nfolder\n";					
				}	
			}
		} else if("netgear" == $machine){
			$shared = getNetgearSharedFolders();	
			foreach($shared as $dirName=>$property){			
				if($dirName==NETGEAR_SHARED_PATH."Pictures"){
					$backupSetDisplayContent .= $dirName."\nfolder\n";					
				}
				if($dirName==NETGEAR_SHARED_PATH."Documents"){
					$backupSetDisplayContent .= $dirName."\nfolder\n";					
				} 
				if($dirName==NETGEAR_SHARED_PATH."Music"){
					$backupSetDisplayContent .= $dirName."\nfolder\n";					
				}	
				if($dirName==NETGEAR_SHARED_PATH."Videos"){
					$backupSetDisplayContent .= $dirName."\nfolder\n";					
				}	
			}
		} else if("twotier" == $machine){
			$shared = getTwotierSharedFolders();
			foreach($shared as $dirName=>$property){
				$type = $property['type']=='D'?'folder':'file';
				$backupSetDisplayContent .= "$dirName\n$type\n";					
			}
			autoUpdateBackupset();
		}
		else if(ASUSTOR == $machine)
		{			
			$shared = getASUSTORSharedFolders();
			foreach($shared as $dir => $property) {	
				if(strtolower($property['filename']) == 'public'){
					$backupSetDisplayContent .= $dir . "\nfolder\n";
					continue;
				}				 
				if(strtolower($property['filename'])=="music"){
					$backupSetDisplayContent .= $dir."\nfolder\n";		
					continue;
				}	
				if(strtolower($property['filename'])=="videos"){
					$backupSetDisplayContent .= $dir."\nfolder\n";
					continue;
				}	
				if(strtolower($property['filename'])=="photogallery"){
					$backupSetDisplayContent .= $dir."\nfolder\n";
					continue;
				}
			}		
		}
					
		file_put_contents($backupSetDisplayFile,$backupSetDisplayContent);	
		@chmod($backupSetDisplayFile, $permissionVal);
	}
	else if ("twotier" == $machine) {
		autoUpdateBackupset();
	}
}


/****************************************************************************************************
* Subroutine Name         : getCronEntry.
* Objective               : To get cron table entries.
* Added By                : Uttam Tiwari.
******************************************************************************************************/
function getCronEntry($args)
{
	$result="";
	$space = " ";
	$tab = "\t";
	$arguments = func_get_args();
	GLOBAL $machine;
	GLOBAL $user;
	if($machine=== 'synology')
	{
		//in synology we need to add user in crontab entry
		//so we are adding user at end and swaping with previous value.
		array_push($arguments,$user);
		$lastIndex = count($arguments) - 1;
		$tmp = $arguments[$lastIndex-1];
		$arguments[$lastIndex - 1] = $arguments[$lastIndex];
		$arguments[$lastIndex] = $tmp;
		foreach ($arguments as $argument)
		{
        		$result .= $argument.$tab;
    		}
	chop($result,$tab);
	}
	else
	{
		foreach ($arguments as $argument)
		{
        		$result .= $argument.$space;
    		}
	chop($result,$space);
	}
return $result;
}

/****************************************************************************************************
* Subroutine Name         : crontabSeperator.
* Objective               : Separate content depends on machine type.
* Added By                : Avinash Kumar.
******************************************************************************************************/
function crontabSeperator($scheduleString)
{
	GLOBAL $machine;
	$scheduleArray = Array();
    if("synology" == $machine)
	{
		$scheduleArray = explode("\t", $scheduleString);
	}
	else
	{
		$scheduleArray = explode(' ', $scheduleString);
	}
	return $scheduleArray;	
}

function dirlist($arg = "/")
{
	GLOBAL $machine;
	GLOBAL $appPath;
	$tmpDirArr = array();
    if("twotier" == $machine){
		$arg = str_replace("'","'\''",$arg);
    }
    else{
		$arg = str_replace('\\','\\\\',$arg);
        $arg = str_replace("'","'\''",$arg);
		$arg = preg_replace("/\"/","\\\"",$arg);
		$arg = str_replace('$','\$',$arg);
		$arg = str_replace('`','\`',$arg);
    }

	if("synology" == $machine){
		if($arg=="/") {
			$tmpDirArr = getSynologySharedFolders(SYNOLOGY_AVOID_PROP);
		} else if (empty($_SESSION['encryptedToken'])) {			
			$dirDefault = systemCmdExecution("ls -al '$arg' | grep ^d | awk '{print $9}'");
		}
		else {
			$dirDefault = systemCmdExecution("ls -al '$arg' | grep ^d | awk '{print \\$9}'");
		}
	} 
	else if("QNAP" == $machine){
		if($arg=="/") {
			$tmpDirArr = getQNAPSharedFolders();	
		} else {		
			$dirDefault = systemCmdExecution("ls -al '$arg' | grep ^d | awk '{print \\$9}'");
		}
	} 	
	else if("netgear" == $machine){
		if($arg=="/") {
			$tmpDirArr = getNetgearSharedFolders();		
		} else {		
			$dirDefault = systemCmdExecution("$appPath/ls -al '$arg' | grep ^d | awk '{ sub(/[^ ]+ +[^ ]+ +[^ ]+ +[^ ]+ +[^ ]+ +[^ ]+ +[^ ]+ +[^ ]+ /, \"\"); print }' |  awk '{ print }'");
		}
	} 
	else if("twotier" == $machine){
		if($arg=='/'){
			$arg = '/'.IDRIVE_VAULT_RESTORELOCATION_ROOT;
			$dirDefault = systemCmdExecution("/bin/ls -al '$arg' | grep ^d | awk '{ sub(/[^ ]+ +[^ ]+ +[^ ]+ +[^ ]+ +[^ ]+ +[^ ]+ +[^ ]+ +[^ ]+ /, \"\"); print }' |  awk '{ print }'");
		} else {
			$dirDefault = systemCmdExecution("/bin/ls -al '$arg' | grep ^d | awk '{ sub(/[^ ]+ +[^ ]+ +[^ ]+ +[^ ]+ +[^ ]+ +[^ ]+ +[^ ]+ +[^ ]+ /, \"\"); print }' |  awk '{ print }'");
		}
	}  
	else if(ASUSTOR == $machine){
		if($arg=="/") 
			$tmpDirArr = getASUSTORSharedFolders();	
		else
			$dirDefault = systemCmdExecution("ls -al '$arg/' | grep ^d | awk '{print \\$9}'");
	} 
	if(!empty($dirDefault)){	
		$tmpDirArr = explode("\n", rtrim($dirDefault,"\n"));
		sort($tmpDirArr);
	}	
	return $tmpDirArr;
}

/****************************************************************************************************
* Function Name         : machineBasedContent.
* Objective             : Getting content based on machine QNAP/Synology
* Added By              : Senthil Pandian
******************************************************************************************************/
function machineBasedContent($machine){
    GLOBAL $appName;
	GLOBAL $logoClassName;
	GLOBAL $appVersion;
	GLOBAL $appTitle;
	GLOBAL $appDesc;
	GLOBAL $appHelpLink;
	GLOBAL $appMetaTitle;
	GLOBAL $appUpdateMsg;
	GLOBAL $appUpdateKey;
	GLOBAL $appUpdateURL;	
	GLOBAL $appThemeCSS;
	GLOBAL $appPerlPath;
	GLOBAL $appPHPPath;
	GLOBAL $appSudoPath;
	GLOBAL $appCloudPath;
	GLOBAL $appFavicon;
	GLOBAL $appIDriveDesc;
	
	switch($machine){
		case 'QNAP':
			$appName       = QNAP;
			$logoClassName = QNAP_LOGO_CLASSNAME; 
			$appVersion    = QNAP_VERSION;
			$appTitle      = QNAP_TITLE;
			$appDesc       = NAS_DESC;
			$appIDriveDesc = QNAP_IDRIVE_ACCOUNT_DESC;
			$appHelpLink   = QNAP_HELP;
			$appMetaTitle  = QNAP_META_TITLE;
			$appUpdateMsg  = QNAP_VERSION_MSG;
			$appUpdateKey  = IDRIVE_APP_FOR_QNAP;
			$appUpdateURL  = QNAP_UPDATE_URL;
			$appThemeCSS   = CSS_THEME_FOR_NAS;
			$appPerlPath   = PERL_PATH_FOR_QNAP;
			$appPHPPath    = PHP_PATH_FOR_QNAP;
			$appCloudPath  = IDRIVE_CLOUD_FOR_NAS;
			$appFavicon    = IDRIVE_FAV_FOR_NAS;
			break;
		case 'synology':
			$appName       = SYNOLOGY;
			$logoClassName = SYNOLOGY_LOGO_CLASSNAME;
			$appVersion    = SYNOLOGY_VERSION;
			$appTitle      = SYNOLOGY_TITLE;
			$appDesc       = NAS_DESC;
			$appIDriveDesc = SYNOLOGY_IDRIVE_ACCOUNT_DESC;			
			$appHelpLink   = SYNOLOGY_HELP;
			$appMetaTitle  = SYNOLOGY_META_TITLE;
			$appUpdateMsg  = SYNOLOGY_VERSION_MSG;
			$appUpdateKey  = IDRIVE_APP_FOR_SYNOLOGY;
			$appUpdateURL  = SYNOLOGY_UPDATE_URL;
			$appThemeCSS   = CSS_THEME_FOR_NAS;
			$appPerlPath   = PERL_PATH_FOR_SYNOLOGY;
			$appPHPPath    = PHP_PATH_FOR_SYNOLOGY;	
			$appCloudPath  = IDRIVE_CLOUD_FOR_NAS;
			$appFavicon    = IDRIVE_FAV_FOR_NAS;
			break;
		case 'netgear':
			$appName       = NETGEAR;
			$logoClassName = NETGEAR_LOGO_CLASSNAME; 
			$appVersion    = NETGEAR_VERSION;
			$appTitle      = NETGEAR_TITLE;
			$appDesc       = NAS_DESC;
			$appIDriveDesc = NETGEAR_IDRIVE_ACCOUNT_DESC;			
			$appHelpLink   = NETGEAR_HELP;
			$appMetaTitle  = NETGEAR_META_TITLE;
			$appUpdateMsg  = NETGEAR_VERSION_MSG;
			$appUpdateKey  = IDRIVE_APP_FOR_NETGEAR;
			$appUpdateURL  = NETGEAR_UPDATE_URL;
			$appThemeCSS   = CSS_THEME_FOR_NAS;
			$appPerlPath   = PERL_PATH_FOR_NETGEAR;
			$appPHPPath    = PHP_PATH_FOR_NETGEAR;
			$appSudoPath   = SUDO_PATH_FOR_NETGEAR;
			$appCloudPath  = IDRIVE_CLOUD_FOR_NAS;
			$appFavicon    = IDRIVE_FAV_FOR_NAS;
			break;
		case 'twotier':
			$appName       = TWOTIER;
			$logoClassName = TWOTIER_LOGO_CLASSNAME; 
			$appVersion    = TWOTIER_VERSION;
			$appTitle      = TWOTIER_TITLE;
			$appDesc       = TWOTIER_DESC;
			$appIDriveDesc = TWOTIER_IDRIVE_ACCOUNT_DESC;			
			$appHelpLink   = TWOTIER_HELP;
			$appMetaTitle  = TWOTIER_META_TITLE;
			$appUpdateMsg  = TWOTIER_VERSION_MSG;
			$appUpdateKey  = IDRIVE_APP_FOR_TWOTIER;
			$appUpdateURL  = TWOTIER_UPDATE_URL;
			$appThemeCSS   = CSS_THEME_FOR_TWOTIER;	
			$appPerlPath   = PERL_PATH_FOR_TWOTIER;
			$appPHPPath    = PHP_PATH_FOR_TWOTIER;
			$appSudoPath   = SUDO_PATH_FOR_TWOTIER;
			$appCloudPath  = IDRIVE_CLOUD_FOR_TWOTIER;
			$appFavicon    = IDRIVE_FAV_FOR_TWOTIER;
			break;		
		case ASUSTOR:
			$appName       = ASUSTOR;
			$logoClassName = ASUSTOR_LOGO_CLASSNAME;
			$appVersion    = ASUSTOR_VERSION;
			$appTitle      = ASUSTOR_TITLE;
			$appDesc       = NAS_DESC;
			$appIDriveDesc = ASUSTOR_IDRIVE_ACCOUNT_DESC;			
			$appHelpLink   = ASUSTOR_HELP;
			$appMetaTitle  = ASUSTOR_META_TITLE;
			$appUpdateMsg  = ASUSTOR_VERSION_MSG;
			$appUpdateKey  = IDRIVE_APP_FOR_ASUSTOR;
			$appUpdateURL  = ASUSTOR_UPDATE_URL;
			$appThemeCSS   = CSS_THEME_FOR_NAS;
			$appPerlPath   = PERL_PATH_FOR_ASUSTOR;
			$appPHPPath    = PHP_PATH_FOR_ASUSTOR;	
			$appCloudPath  = IDRIVE_CLOUD_FOR_NAS;
			$appFavicon    = IDRIVE_FAV_FOR_NAS;
			$processPath   = PS_PATH_FOR_ASUSTOR;
			break;		
	}
}
	
/****************************************************************************************************
* Function Name         : synologyNASlogin
* Objective             : Verifying synology NAS login detail
* Added By              : Senthil Pandian
******************************************************************************************************/
function synologyNASlogin($user,$pass,$nasVerification)
{
	$optCode = '';
	$version=3;
	$isNonAdmin=false;
	
	if(!empty($nasVerification)){
		$optCode = "&otp_code=".$nasVerification;
	}
START:	
/*	$appIP = $_SERVER['SERVER_ADDR'];
	$ssl = empty($_SERVER['HTTPS'])?'':'s';
	$appIP = (isset($_SESSION['ipAddress'])&&!empty($_SESSION['ipAddress']))?$_SERVER['SERVER_ADDR']:'localhost';
	$shareURL = "http$ssl://$appIP:$port/webapi/auth.cgi";
*/
	$shareURL  = getNasURL();
	$shareURL .= "webapi/auth.cgi";
	
	if($isNonAdmin==false){
		$shareURL .= "?api=SYNO.API.Auth&version=$version&method=login&account=$user&passwd=$pass".$optCode.'&format=cookie';
	} else {
		$shareURL .= "?api=SYNO.API.Auth&version=$version&method=login&account=$user&passwd=$pass".$optCode."&session=FileStation&format=cookie";
	}
	$sharePage = getCurlOutput($shareURL);
	$arr = json_decode($sharePage);
	$strPos = strpos($sharePage,"data");
	if(empty($sharePage)){
		if(isset($_SESSION['isProxyEnabled']) && !empty($_SESSION['ipAddress']))
			return INVALID_PROXY;
		else 
			return INVALID_HOST_NAME;
	} elseif(!empty($strPos) && $strPos>=0){
		$sid  = $arr->data->sid;
		$succ = $arr->success;
		if($sid!='' && $succ==1){
			$_SESSION['CGI_SID'] = $sid;
			return "TRUE";
		} else {
			return $succ;
		}
	} else {
		$sid  = $arr->error->code;
		$succ = $arr->success;
		if($sid=='104' && $succ==''){
			$version--;
			goto START;
		} elseif($sid=='402'){
			$isNonAdmin=true;
			goto START;
		} elseif($sid=='403' && $succ==''){			
			return TWO_STEP_REQUIRED;
	    } elseif($sid=='404' && $succ==''){			
			return INVALID_TWO_STEP;
		} elseif($sid!='' && $succ==''){
			return INVALID_NAS_LOGIN;
		} else {
			return $succ;
		}		
	}
}

/****************************************************************************************************
* Function Name         : qnapNASlogin
* Objective             : Verifying QNAP NAS login detail
* Added By              : Senthil Pandian
******************************************************************************************************/
function qnapNASlogin($user,$pass,$nasVerification)
{
	$pass = base64_encode($pass);
	$optCode = '';
	if(!empty($nasVerification)){
		$optCode = "&security_code=".$nasVerification;
	}	
	$shareURL  = getNasURL();
	$shareURL .= "cgi-bin/filemanager/wfm2Login.cgi";
	$shareURL .= "?user=$user&pwd=$pass".$optCode;
	$sharePage = getCurlOutput($shareURL);

	$strPos = strpos($sharePage,"status");
	if(empty($sharePage)){
		if(isset($_SESSION['isProxyEnabled']) && !empty($_SESSION['ipAddress']))
			return INVALID_PROXY;
		else 
			return INVALID_HOST_NAME;
	} elseif(!empty($strPos) && $strPos>=0){
		$sharePage = utf8_encode($sharePage);
		$arr = json_decode($sharePage);	
		
		$sid  = $arr->sid;
		$succ = $arr->status;
		
		if($sid!='' && $succ==1){
			$_SESSION['CGI_SID'] = $sid;
			return "TRUE";
		} else if(isset($arr->need_2sv) && $arr->need_2sv==1){
			if($arr->authPassed==1){
				$_SESSION['CGI_SID'] = $arr->authSid;
				return "TRUE";				
			} else if(!$nasVerification)
				return TWO_STEP_REQUIRED;
			else		
				return INVALID_TWO_STEP;
		} else {
			return $succ;
		}
	} else {
		return INVALID_PROXY;
	}
}

/****************************************************************************************************
* Function Name         : asustorNASlogin
* Objective             : Verifying ASUSTOR NAS login detail
* Added By              : Vijay Vinoth
******************************************************************************************************/
function asustorNASlogin($user,$pass,$nasVerification)
{
	$optCode = '';
	if(!empty($nasVerification))
		$optCode = "&verifycode=".$nasVerification;
	
	$shareURL  = getNasURL();
	$shareURL .= ASUSTOR_LOGIN_CGI_PATH."&account=".$user."&password=".$pass."&two-step-auth=true&stay=yes".$optCode;
	$sharePage = getCurlOutput($shareURL);
	
	$arr = json_decode($sharePage);
	if($arr->success == false){
		if($arr->error_code == ASUSTOR_TWO_STEP_REQUIRED_ERROR_CODE)
			return TWO_STEP_REQUIRED;
		else if($arr->error_code == ASUSTOR_INVALID_TWO_STEP_ERROR_CODE)
			return INVALID_TWO_STEP;
		else		
			return INVALID_NAS_LOGIN;
	}
	else{
		$sid  = $arr->sid;
		$succ = $arr->success;
		
		if($sid!='' && $succ==1){
			$_SESSION['CGI_SID'] = $sid;
			return "TRUE";
		}
		return $succ;
	}
}

/****************************************************************************************************
* Function Name         : nasLogin
* Objective             : Validating the NAS login detail based on NAS machine
* Added By              : Senthil Pandian
******************************************************************************************************/
function nasLogin($nasUserName,$nasPassword,$nasVerification){
	GLOBAL $machine;
	GLOBAL $appPath,$permissionVal;
	
	if(ASUSTOR == $machine && $nasUserName=='admin')
		$_SESSION['nasUserName'] = 'root';
	else 
		$_SESSION['nasUserName'] = $nasUserName;
	
	$_SESSION['encryptedToken'] = '';
	if("synology" == $machine){
		if ($_SESSION['httpuser'] != 'root') 
			encryptAndSaveNasPassword($nasPassword);
		$stOutput = synologyNASlogin(rawurlencode($nasUserName),rawurlencode($nasPassword),rawurlencode($nasVerification));
	} 
	else if("QNAP" == $machine){
		encryptAndSaveNasPassword($nasPassword);
		$stOutput = qnapNASlogin(rawurlencode($nasUserName),$nasPassword,rawurlencode($nasVerification));		
	}
	else if(ASUSTOR == $machine){
		encryptAndSaveNasPassword($nasPassword);
		$stOutput = asustorNASlogin(rawurlencode($nasUserName),rawurlencode($nasPassword),rawurlencode($nasVerification)); 		
	} 
	else {
		file_put_contents("$appPath/".SESSIONTOK,$nasUserName."\n".encrypt($nasPassword));
		@chmod("$appPath/".SESSIONTOK, $permissionVal);
		$stOutput = perlScriptExecution(NASLOGIN,$appPath);
	}
	return $stOutput;
}

/****************************************************************************************************
* Function Name         : searchKeyword
* Objective             : constructing search keyword based on NAS machine
* Added By              : Senthil Pandian
******************************************************************************************************/
function searchKeyword($searchKeyword){
	GLOBAL $machine;
	if($machine == "synology"){
		$searchKeyword = strtolower($searchKeyword);
	}	
	return $searchKeyword;
}


/****************************************************************************************************
* Function Name         : getLocalServerPort
* Objective             : Getting the local server port number
* Added By              : Senthil Pandian
******************************************************************************************************/
function getLocalServerPort(){
	GLOBAL $machine;
	if(!isset($_SESSION['PORT'])){
		if($machine=="synology"){
			//Getting DSM port number
			$synoConfig = SYNOLOGY_INFOCONF;
			$contents = file($synoConfig); 
			$i=0;
			foreach ($contents as $line) {
				if(strpos($line,"admin_port=") !== FALSE){		
					$isPort1 = explode("=", trim($line));
					if($isPort1[0]=="admin_port"){
						$port = trim($isPort1[1],'\"');
					}
					if($isPort1[0]=="secure_admin_port") {
						$securePort = trim($isPort1[1],'\"');
					}		
					$i++;
				}	
				if(strpos($line,"runHTTPS") !== FALSE){
					$isPort1 = explode("=", trim($line));
					if($isPort1[0]=="runHTTPS"){
						$isSSL = trim($isPort1[1],'\"');
					}	
					$i++;
				}
				if($i==3){
					break;
				}
			}
			if(isset($isSSL) && ($isSSL=='yes')){
				$port = $securePort;
			}
		} else if($machine=="QNAP"){
			$port = shell_exec('/sbin/getcfg System "Web Access Port"');
			$port = trim($port);
			if(trim($port)==''){
				$port = '8080';
			}
		}
		$_SESSION['PORT'] = $port;
	} else{
		$port = $_SESSION['PORT'];
	}
	return $port;
}
/****************************************************************************************************
* Function Name         : getNasURL
* Objective             : Getting the NAS URL
* Added By              : Senthil Pandian
******************************************************************************************************/
function getNasURL()
{
	GLOBAL $machine;
	if(isset($_SESSION['nasURL']))
		return $_SESSION['nasURL'];
		
	if($machine=="QNAP"){
		$FORCE_SSL = parse_ini_string(exec('cat /etc/config/uLinux.conf | grep "Force SSL"'));
		$FORCE_SSL = ((isset($FORCE_SSL['Force SSL'])) ? $FORCE_SSL['Force SSL'] : '');

		if ($FORCE_SSL == 1)
		{
			$QNAP_HTTPS_PORT = exec("/sbin/getcfg Stunnel \"Port\" -f /etc/config/uLinux.conf");				
			if ($QNAP_HTTPS_PORT != 443 && $QNAP_HTTPS_PORT != '')
				$contact_port = ":".$QNAP_HTTPS_PORT;
			else
				$contact_port = "";
			$protocol = "https";
		}
		else
		{
			$QNAP_HTTPD_PORT = parse_ini_string(exec('cat /etc/config/uLinux.conf | grep "Web Access Port"'));
			$QNAP_HTTPD_PORT = ((isset($QNAP_HTTPD_PORT['Web Access Port'])) ? $QNAP_HTTPD_PORT['Web Access Port'] : '8080');
			
			$contact_port = ":".$QNAP_HTTPD_PORT;
			$protocol = "http";				
		}
		if(isset($_SESSION['ipAddress'])&&!empty($_SESSION['ipAddress'])){
			$ip = $_SERVER['SERVER_ADDR'];
			$nasURL = $protocol."://$ip".$contact_port."/";
		} else {
			$nasURL = $protocol."://127.0.0.1".$contact_port."/";
		}
		
	} 
	else if($machine=="synology"){		
		//Getting DSM port number
		$synoConfig = SYNOLOGY_INFOCONF;
		$contents = file($synoConfig); 
		$i=0;
		foreach ($contents as $line) {
			if(strpos($line,"admin_port=") !== FALSE){		
				$isPort1 = explode("=", trim($line));
				if($isPort1[0]=="admin_port"){
					$port = trim($isPort1[1],'\"');
				}
				if($isPort1[0]=="secure_admin_port") {
					$securePort = trim($isPort1[1],'\"');
				}		
				$i++;
			}	
			if(strpos($line,"runHTTPS") !== FALSE){
				$isPort1 = explode("=", trim($line));
				if($isPort1[0]=="runHTTPS"){
					$isSSL = trim($isPort1[1],'\"');
				}	
				$i++;
			}
			if($i==3){
				break;
			}
		}	
		// In case on DSM-6 find the admin_port in http.service file.
		if(!isset($port) &&  !isset($securePort)) {
			$httpConfFile = NULL;
			if (file_exists(SYNOLOGY_HTTP_CONF_1)) {
				$httpConfFile = SYNOLOGY_HTTP_CONF_1;
			}
			else if (file_exists(SYNOLOGY_HTTP_CONF_2)) {
				$httpConfFile = SYNOLOGY_HTTP_CONF_2;
			}
			if ($httpConfFile !== NULL) {
				$service = file_get_contents($httpConfFile);
				$xml = new SimpleXMLElement($service);
				$arr = get_object_vars($xml->service);
				foreach($arr['txt-record'] as $line) {
					if( strpos($line,"admin_port=") !== FALSE ) {
						$isPort1 = explode("=", trim($line));
						if( $isPort1[0]=="admin_port" ) {
							$port = trim($isPort1[1],'\"');
						}
					}
				}
			}
		}
		
		if(isset($isSSL) && ($isSSL=='yes')){
			$protocol = "https";
			$contact_port = ":".$securePort;				
		} else {
			$protocol = "http";
			$contact_port = ":".$port;				
		}			
		if(isset($_SESSION['ipAddress'])&&!empty($_SESSION['ipAddress'])){
			$ip = $_SERVER['SERVER_ADDR'];
			$nasURL = $protocol."://$ip".$contact_port."/";
		} else {
			$nasURL = $protocol."://127.0.0.1".$contact_port."/";
		}			
	}
	else if($machine == ASUSTOR){
		$asusConfig = ASUSTOR_INFOCONF;
		$contents = file($asusConfig); 
		$i=0;
		foreach ($contents as $line) {
			if(strpos($line,"HttpsOnly =") !== FALSE){
				$HttpsOnlyArray = explode("=", trim($line));
				$HttpsOnly = trim($HttpsOnlyArray[1]);
				$i++;
				continue;
			}
			
			if(strpos($line,"EnableHttps =") !== FALSE){
				$EnableHttpsArray = explode("=", trim($line));
				$EnableHttps = trim($EnableHttpsArray[1]);
				$i++;
				continue;
			}
			
			if(strpos($line,"HttpPort =") !== FALSE){
				$HttpPortArray = explode("=", trim($line));
				$HttpPort = trim($HttpPortArray[1]);
				$i++;
				continue;
			}
			
			if(strpos($line,"HttpsPort =") !== FALSE){
				$HttpsPortArray = explode("=", trim($line));
				$HttpsPort = trim($HttpsPortArray[1]);
				$i++;
				continue;
			}
			
			if($i == 4)
				break;
		}
		
		if($HttpsOnly == 'Yes' && $EnableHttps == 'Yes') {
			$protocol = "https";
			$contact_port = ":".$HttpsPort;				
		} 
		else {
			$protocol = "http";
			$contact_port = ":".$HttpPort;				
		}	
		
		if(isset($_SESSION['ipAddress'])&&!empty($_SESSION['ipAddress'])){
			$ip = $_SERVER['SERVER_ADDR'];
			$nasURL = $protocol."://$ip".$contact_port."/";
		} 
		else
			$nasURL = $protocol."://127.0.0.1".$contact_port."/";
	}
	$_SESSION['nasURL'] = $nasURL;
	return $nasURL;
}
/****************************************************************************************************
* Function Name         : getSynologySharedFolders
* Objective             : Getting synology shared folders list
* Added By              : Senthil Pandian
* Modified By			: Sabin Cheruvattil - 2016-05-20 | shared files are now stored in session
******************************************************************************************************/
function getSynologySharedFolders($flag = 0)
{
	while(1) {
		if(isset($_SESSION['sharedDirectoriesRaw']) && !empty($_SESSION['sharedDirectoriesRaw'])) {
			$sharedDirList	= $_SESSION['sharedDirectoriesRaw'];

			# check whether we get a valid object or not
			if(!json_decode($sharedDirList)) {
				unset($_SESSION['sharedDirectoriesRaw']);
				continue;
			}

			if(file_exists(SYNOLOGY_SHARE_CGI_PATH)) {
				$arr = json_decode($sharedDirList);
				$shareArray = $arr->data->shares;
				
				$dir_list = array();
				$_SESSION['shared_folders'] = array();
				foreach($shareArray as $dirList) {
					$dirname = $dirList->additional->real_path;
					if($flag == 0) {
						$type = $dirList->isdir=='1'?"D":"F";
						$size = $dirList->isdir=='1'?"":$dirList->size;
						$dir_list[$dirname]["size"] = trim($size);
						$dir_list[$dirname]["datetime"] = gmdate("Y/m/d h:i:s A", $dirList->additional->time->mtime);	
						$dir_list[$dirname]["type"] = $type;
					}
					
					$dir_list[$dirname]["realName"] = $dirList->name;
					array_push($_SESSION['shared_folders'], ($dirname . '/'));
				}
				
				ksort($dir_list);
			}
			
			// If the shared folders are empty, fallback to manual listing.
			$arr = json_decode($sharedDirList);
			$shareArray = $arr->data->shares;
			if(!(count($shareArray) > 0)) {
				$dir_list = json_decode($sharedDirList, true);
				
				if(!file_exists(SYNOLOGY_SHARE_CGI_PATH)) {
					foreach($dir_list as $key => &$value) {
						$value['realName'] = basename($key);
					}
				}

				ksort($dir_list);
			}

			break;
		} else {
			unset($_SESSION['sharedDirectoriesRaw']);
			saveSynologySharedFolders();	
		}
		
		sleep(1);
	}
	
	return $dir_list;
}

/****************************************************************************************************
* Function Name         : saveSynologySharedFolders
* Objective             : Saving synology shared folders list into text file
* Added By              : Senthil Pandian
* Modified By			: Sabin Cheruvattil - 2016-05-20 | shared files are now stored in session
******************************************************************************************************/
function saveSynologySharedFolders()
{
	$retry = 0;
	$sharedDirList = '';
	if(file_exists(SYNOLOGY_SHARE_CGI_PATH)){
		$shareURL      = getNasURL();
		$sharedDirURL  = $shareURL."webapi";
	START:
		if(!isset($_SESSION['CGI_SID'])) {
			header("Location:../index.php");
			exit;
		} else {
			$sid = $_SESSION['CGI_SID'];
		}
		
		$sharedDirURL = $shareURL."webfm/webUI/file_share.cgi?api=SYNO.FileStation.List&version=1&method=list_share&additional=real_path%2Ctime%2Csize&_sid=$sid";
		$sharedDirList = getCurlOutput($sharedDirURL);
		if(empty($sharedDirList) && $retry == 0) {
			$retry =1;
			unset($_SESSION['CGI_SID']);
			goto START;
		}
		
	}
	
	// If the shared folders are empty, fallback to manual listing.
	$arr = json_decode($sharedDirList);
	$shareArray = $arr->data->shares;
	if (!(count($shareArray) > 0)) {
	    $path = "/volume*";
		$list = array();
		$shared     = systemCmdExecution("ls -d -1 /volume*");
		$sharedList = explode("\n",trim($shared));
		$_SESSION['shared_folders'] = array();
		foreach($sharedList as $name){
			$command = '';
			if ($_SESSION['haslsdatetimeformat'] == 0) {
				$command  = ('ls -aln ' . escapeshellarg($name));
				$command .= (' --time-style=\"+%a %b %e %H:%M:%S %Y\" | grep \'^d\'');
			}
			else {
				$command  = ('ls -alen ' . escapeshellarg($name));
				$command .= (' | grep \'^d\'');
			}




			$res = systemCmdExecution($command);
			$res = parseLocalDirList($res,$name,'/');
			array_push($_SESSION['shared_folders'], ($name . '/'));
			$list = $list+$res;
		}
		
		$sharedDirList = json_encode($list);
	}
	
	$_SESSION['sharedDirectoriesRaw'] = $sharedDirList;
}

/****************************************************************************************************
* Function Name         : getQNAPSharedFolders
* Objective             : Getting QNAP shared folders list
* Added By              : Senthil Pandian
* Modified By			: Sabin Cheruvattil - 2016-05-18 | shared files are now stored in session
******************************************************************************************************/
function getQNAPSharedFolders()
{
	while(1) {
		if(isset($_SESSION['sharedDirectoriesRaw']) && !empty($_SESSION['sharedDirectoriesRaw'])) {
			$sharedDirList = $_SESSION['sharedDirectoriesRaw'];
			
			# check whether we get a valid object or not
			if(!json_decode($sharedDirList)) {
				unset($_SESSION['sharedDirectoriesRaw']);
				continue;
			}			

			$dir_list = json_decode($sharedDirList, true);
			ksort($dir_list);
			break;
		} else {
			unset($_SESSION['sharedDirectoriesRaw']);
			saveQNAPSharedFolders();	
		}
		
		sleep(3);
	}
	
	return $dir_list;
}

/****************************************************************************************************
* Function Name         : saveQNAPSharedFolders
* Objective             : Saving QNAP shared folders list into text file
* Added By              : Senthil Pandian
* Modified By			: Sabin Cheruvattil - 2016-05-18 | shared files are now stored in session
******************************************************************************************************/
function saveQNAPSharedFolders()
{
	GLOBAL $appPath;
	$path = QNAP_SHARED_PATH;
	$res = systemCmdExecution("ls -alen \"$path\" | grep '^l'");
	$res = parseLocalDirList($res,'/');
	$sharedDirList = json_encode($res);
	$_SESSION['sharedDirectoriesRaw'] = $sharedDirList;
}

/****************************************************************************************************
* Function Name         : getNetgearSharedFolders
* Objective             : Getting Netgear shared folders list
* Added By              : Senthil Pandian
* Modified By			: Sabin Cheruvattil - 2016-05-18 | shared files are now stored in session
******************************************************************************************************/
function getNetgearSharedFolders()
{
	while(1) {
		if(isset($_SESSION['sharedDirectoriesRaw']) && !empty($_SESSION['sharedDirectoriesRaw'])) {
			$sharedDirList	= $_SESSION['sharedDirectoriesRaw'];
			
			# check whether we get a valid object or not
			if(!json_decode($sharedDirList)) {
				unset($_SESSION['sharedDirectoriesRaw']);
				continue;
			}
			

			$dir_list = json_decode($sharedDirList, true);
			ksort($dir_list);
			break;
		} else {
			unset($_SESSION['sharedDirectoriesRaw']);
			saveNetgearSharedFolders();	
		}
		
		sleep(3);
	}
	
	return $dir_list;
}

/****************************************************************************************************
* Function Name         : saveNetgearSharedFolders
* Objective             : Saving Netgear shared folders list into text file
* Added By              : Senthil Pandian
* Modified By			: Sabin Cheruvattil - 2016-05-19 | shared files are now stored in session
******************************************************************************************************/
function saveNetgearSharedFolders()
{
	GLOBAL $appPath;
	$homePath = NETGEAR_SHARED_PATH;
	$toGrep = 'home';
	
	$path = NETGEAR_SHARED_LINK;
	$res = systemCmdExecution("$appPath/ls -aln \"$path\" --time-style=\"+%a %b %e %H:%M:%S %Y\" | grep '^d\|^-'");
	$res .= systemCmdExecution("$appPath/ls -aln \"$homePath\" --time-style=\"+%a %b %e %H:%M:%S %Y\" | grep '$toGrep'| grep '^d\|^-'");
	$res = parseLocalDirList($res,'/');
	$sharedDirList = json_encode($res);
	$_SESSION['sharedDirectoriesRaw'] = $sharedDirList;
}

/****************************************************************************************************
* Function Name         : getTwotierSharedFolders
* Objective             : Getting Netgear shared folders list
* Added By              : Yogesh Kumar
* Modified By			: Sabin Cheruvattil - 2016-05-18 | shared files are now stored in session
******************************************************************************************************/
function getTwotierSharedFolders()
{
	while(1) {
		if(isset($_SESSION['sharedDirectoriesRaw']) && !empty($_SESSION['sharedDirectoriesRaw'])) {
			$sharedDirList	= $_SESSION['sharedDirectoriesRaw'];
			
			# check whether we get a valid object or not
			if(!json_decode($sharedDirList)) {
				unset($_SESSION['sharedDirectoriesRaw']);
				continue;
			}
			
			$dir_list = json_decode($sharedDirList, true);
			ksort($dir_list);
			break;
		} else {
			unset($_SESSION['sharedDirectoriesRaw']);
			saveTwotierSharedFolders();
		}
		
		sleep(3);
	}
	
	return $dir_list;
}

/****************************************************************************************************
* Function Name         : saveTwotierSharedFolders
* Objective             : Saving Twotier shared folders list into text file
* Added By              : Yogesh Kumar
* Modified By			: Sabin Cheruvattil - 2016-05-19 | shared files are now stored in session
******************************************************************************************************/
function saveTwotierSharedFolders()
{
	GLOBAL $appPath;
	$homePath = TWOTIER_SHARED_PATH;
	$cmd = "/bin/ls -aln -D \"+%a %b %e %H:%M:%S %Y\" \"$homePath\" | grep '^d' | grep -v '\.zfs$'";
	$res = systemCmdExecution($cmd);
	$res = parseLocalDirList($res,'/');
	$sharedDirList = json_encode($res);
	
	$_SESSION['sharedDirectoriesRaw'] = $sharedDirList;
}

/****************************************************************************************************
* Function Name         : updateBackupsetFiles
* Objective             : To remove the file entries which are not exists.
* Added By              : Yogesh Kumar
* Modified By           : Senthil Pandian
******************************************************************************************************/
function updateBackupsetFiles($oldDeltaSharedList, $tempListArray, $backupSetDir) {
	GLOBAL $permissionVal;
    $backupSetDisplayFile = $backupSetDir . '/' . BACKUPSETFILEDISPLAY;

	$backupSetDisplayFileList = file_get_contents($backupSetDisplayFile);

	$backupSetDisplayFileArray = explode("\n", $backupSetDisplayFileList);
	array_pop($backupSetDisplayFileArray);
	$deltaFiles = array();

	foreach( $oldDeltaSharedList as $file) {
		$filename = preg_quote($file, '/');
		$match = preg_grep('/^' . $filename . '$|^' . $filename . '\//', $backupSetDisplayFileArray);
		if( count( $match ) > 0 ) {
			$deltaFiles[] = array_keys($match);
		}
	}

	$udpateBackupSet = false;
	foreach( $deltaFiles as $deltaArray) {
		foreach( $deltaArray as $index => $value) {
			unset($backupSetDisplayFileArray[($value * 2)]);
			unset($backupSetDisplayFileArray[($value * 2) + 1]);
			if( ! $udpateBackupSet ) $udpateBackupSet = true;
		}
	}
	if( $udpateBackupSet ) {
		//Added this condition to avoid keeping only '\n'
		if(count($backupSetDisplayFileArray)>0){
			$newBSDF = implode("\n", $backupSetDisplayFileArray) . "\n";
		} else {
			$newBSF = '';
			$newBSDF = '';
		}
		file_put_contents($backupSetDisplayFile, $newBSDF, LOCK_EX);
		@chmod($backupSetDisplayFile, $permissionVal);
		return true;
	}
	return false;
}

/****************************************************************************************************
* Function Name         : autoUpdateBackupset
* Objective             : To dynamically add newly added folders to backupset.
* Added By              : Yogesh Kumar
******************************************************************************************************/
function autoUpdateBackupset($userServicePath = NULL) {
	$backupSetDir = NULL;
	GLOBAL $userDirListsFile,$permissionVal;
	If ($userServicePath === NULL) {
		$backupSetDir = Scheduler::$backup_dir."Default Backup Set";
        }
	else {
		$userDirListsFile = ($userServicePath . '/' . USERDIRLISTS) ;
		$backupSetDir     = $userServicePath . '/' . BACKUPDIR . '/' . 'Default Backup Set';
	}
	// Get all directory (excluding hidden dirs) names.
	$command = ("find " . TWOTIER_SHARED_PATH . " -not -path '*/\.*' -type d -name '*' -mindepth 1 -maxdepth 1");
	$newSharedDirList = shell_exec($command);

	// Convert string to an array.
	$tempListArray = explode("\n", $newSharedDirList);

	// Pop is required to remove last empty element.
	array_pop($tempListArray);

	// If userDirListsFile is not set just return void;
	if (!isset($userDirListsFile)) {
		return;
	}

	// If the userdirlists is empty then init.
	if(!file_exists($userDirListsFile)) {
		$newSharedDirList = serialize($tempListArray);
		file_put_contents($userDirListsFile, $newSharedDirList, LOCK_EX);
	}
	else {
		// Get the old list to compare with the new list.
		$oldSharedList = file_get_contents($userDirListsFile);
		$oldSharedList = unserialize($oldSharedList);

		// Get newly added directories.
		$newDeltaSharedList = array_diff($tempListArray, $oldSharedList);

		// Get all deleted directories.
		$oldDeltaSharedList = array_diff($oldSharedList, $tempListArray);

		if( (count($oldDeltaSharedList) > 0) &&
			file_exists($backupSetDir) ) {
			updateBackupsetFiles($oldDeltaSharedList, $tempListArray, $backupSetDir);
		}

		// When there're new Dirs added, it requires to udpate 3 files.
		// 1.userdirlists.txt 2.BackupSetFile.txt 3.BackupSetDisplayFile.txt
		if( (count($newDeltaSharedList) > 0) &&
			file_exists($backupSetDir) ) {

        		$backupSetDisplayFile = $backupSetDir . '/' . BACKUPSETFILEDISPLAY;

			// Check for duplicate entries.
			$newDeltaSharedList = array_diff($newDeltaSharedList, file($backupSetDisplayFile, FILE_IGNORE_NEW_LINES));
			if (count($newDeltaSharedList) > 0) {
				$newBackupDisplaySet  = (implode("\nfolder\n", $newDeltaSharedList) . "\nfolder\n");
				file_put_contents($backupSetDisplayFile, $newBackupDisplaySet, FILE_APPEND | LOCK_EX);
				@chmod($backupSetDisplayFile, $permissionVal);
			}
		}

		file_put_contents($userDirListsFile, serialize($tempListArray), LOCK_EX);
		@chmod($userDirListsFile, $permissionVal);
	}
}


/****************************************************************************************************
* Function Name         : getFullPathOfSharedFolder
* Objective             : Getting Netgear shared folders list
* Added By              : Senthil Pandian
******************************************************************************************************/
function getFullPathOfSharedFolder(){
	GLOBAL $machine;
    if("netgear" == $machine){
		$path = NETGEAR_SHARED_PATH;
	}
	elseif('twotier' == $machine) {
		$path = TWOTIER_SHARED_PATH;
	}
	elseif(ASUSTOR == $machine) {
		$path = ASUSTOR_SHARED_PATH;
	}
	return $path;
}

/****************************************************************************************************
* Function Name         : getTwotierSharedPath
* Objective             : Getting two tier's mounted shared folder name
* Added By              : Senthil Pandian
******************************************************************************************************/
function getTwotierSharedPath(){
	if(!isset($_SESSION['TWOTIER_SHARED_PATH'])){
		$cmd = "ls / | grep '^ID'";
		$getMountedPath = systemCmdExecution($cmd);
		$homePath = '/'.trim($getMountedPath).'/';
		$_SESSION['TWOTIER_SHARED_PATH'] = $homePath;
	} else {
		$homePath = $_SESSION['TWOTIER_SHARED_PATH'];
	}
	return $homePath;
}
/****************************************************************************************************
* Function Name         : parseLocalDirList
* Objective             : Parsing the ls command result & returning as array
* Added By              : Senthil Pandian
******************************************************************************************************/
function parseLocalDirList($res,$path,$actualPath=''){
	GLOBAL $machine;
	GLOBAL $appPath;
	
	if("QNAP" == $machine && $path=='/') {
		$res1 =  explode("\n", $res);
		$res1 =  array_filter($res1);
		$dir_list = array();
    
		$retry = 0;
		while ($retry <= 1) {
			$retry++;
			$loggedIn = 'TRUE';
			if (!isset($_SESSION['CGI_SID'])) {
				$nasUserName = rawurlencode($_SESSION['nasUserName']);
				$nasPwd      = rawurlencode(simple_decrypt());
				$loggedIn    = qnapNASlogin($nasUserName, $nasPwd);
			}

			if ($loggedIn === 'TRUE') {
				$url = (getNasURL() . "cgi-bin/filemanager/utilRequest.cgi?func=get_tree&sid="
					. $_SESSION['CGI_SID'] . "&node=share_root" );
				$sharedFoldersJSON = json_decode(getCurlOutput($url));
				// Usually status is set on Failure.
				if (isset($sharedFoldersJSON->status) && ($sharedFoldersJSON->status == 3)) {
					unset($_SESSION['CGI_SID']);
				}
				else if (isset($sharedFoldersJSON->status)) {
					Scheduler::Log("Failed to get shared folders");
					unset($_SESSION['CGI_SID']);
				}
				else {
					break;
				}
			}
		}
		$sharedFolders = array();
		foreach($sharedFoldersJSON as $foldersInfo) {
			if (isset($foldersInfo->text)) {
				$sharedFolders[$foldersInfo->text] = $foldersInfo->text;
			}
			else {
				break;
			}
		}
		foreach($res1 as $res2) {
			$split = preg_split('/\s+/', $res2,5);
			$split1 = preg_split('/\s+/', $split[4],2);
			$size = trim($split1[0]);
		
			$linkName  = substr($split1[1],25);
			$splitLink = preg_split('/->/', $linkName);
			$dirname   = trim($splitLink[1]);
			$splitLink[0] = rtrim($splitLink[0]);
			$dirname  = QNAP_SHARED_PATH.$dirname;
			if (!file_exists($dirname) || (isset($_SESSION['CGI_SID']) && !isset($sharedFolders[$splitLink[0]]))) {
				continue;
			}
				
				$type = substr($split[0],0,1);		
				$type = $type=='l'?"D":"F";
				$dir_list[$dirname]["size"] = humanReadableSize(trim($size));			
				$parts = preg_split('/\s+/', $date);

					$fullPath = str_replace("'","'\''",$dirname);
					$fullPath = str_replace('\\','\\\\',$fullPath);
					$fullPath = preg_replace("/\"/","\\\"",$fullPath);
					$fullPath = str_replace('$','\$',$fullPath);
					$fullPath = str_replace('`','\`',$fullPath);
				$cmd = "date +'%Y/%m/%d %T %p' -r '$fullPath'";
				$date = systemCmdExecution($cmd);
				$dir_list[$dirname]["datetime"] = $date;
				$dir_list[$dirname]["type"] = $type;
		}
	}	 
	elseif("netgear" == $machine && $path=='/'){
		$res1 =  explode("\n", $res);
		$res1 =  array_filter($res1);
		$dir_list = array();
		foreach($res1 as $res2) {
			$split = preg_split('/\s+/', $res2,5);
			$split1 = preg_split('/\s+/', $split[4],2);
			$size = trim($split1[0]);
			$date = trim(substr($split1[1],0,24));	
			$dirname  = substr($split1[1],25);
			$trimmedDirname = trim($dirname);
			if($trimmedDirname !='' && $trimmedDirname !='.' && $trimmedDirname !='..'){
				$dirname  = NETGEAR_SHARED_PATH.$dirname;
				if(!file_exists($dirname))
					continue;
				$type = substr($split[0],0,1);
				$type = $type=='d'?"D":"F";
				$dir_list[$dirname]["size"] = humanReadableSize(trim($size));			
				$parts = preg_split('/\s+/', $date);
				$dir_list[$dirname]["datetime"] = date("Y/m/d h:i:s A", strtotime($parts[2]." ".$parts[1]." ".$parts[4]." ".$parts[3]));	
				$dir_list[$dirname]["type"] = $type;	
			}
		}		
	} 
	elseif("twotier" == $machine && $path=='/'){
		$res1 =  explode("\n", $res);
		$res1 =  array_filter($res1);
		$dir_list = array();

		$homePath = TWOTIER_SHARED_PATH;
		foreach($res1 as $res2) {
			$split = preg_split('/\s+/', $res2,5);
			$split1 = preg_split('/\s+/', $split[4],2);
			$size = trim($split1[0]);
			$date = trim(substr($split1[1],0,25));
			$dirname  = substr($split1[1],26);
			$trimmedDirname = trim($dirname);
			if($trimmedDirname !='' && $trimmedDirname !='.' && $trimmedDirname !='..'){
				$dirname  = $homePath.$dirname;
				if(!file_exists($dirname) || $dirname=='.zfs')
					continue;
				$type = substr($split[0],0,1);		
				$type = $type=='d'?"D":"F";
				$dir_list[$dirname]["size"] = humanReadableSize(trim($size));			
				$parts = preg_split('/\s+/', $date);
				$dir_list[$dirname]["datetime"] = date("Y/m/d h:i:s A", strtotime($parts[2]." ".$parts[1]." ".$parts[4]." ".$parts[3]));	
				$dir_list[$dirname]["type"] = $type;	
			}
		}		
	} 
	else if("synology" == $machine && $actualPath=='/'){
		$res1 =  explode("\n", $res);
		$res1 =  array_filter($res1);
		$dir_list = array();
		foreach($res1 as $res2) {
			$split = preg_split('/\s+/', $res2,5);
			$split1 = preg_split('/\s+/', $split[4],2);
			$date = trim(substr($split1[1],0,24));
			$dirname  = substr($split1[1],25);
			$dirname1 = trim($dirname);
			if($dirname1!='' && $dirname1!='.' && $dirname1!='..'  && substr($dirname1,0,1)!='@'){
				$dirname  = "$path/$dirname";
				$type = substr($split[0],0,1);		
				$type = $type=='d'?"D":"F";
				$dir_list[$dirname]["size"] = '';
				$parts = preg_split('/\s+/', $date);
				$dir_list[$dirname]["datetime"] = date("Y/m/d h:i:s A", strtotime($parts[2]." ".$parts[1]." ".$parts[4]." ".$parts[3]));	
				$dir_list[$dirname]["type"] = $type;	
			}
		}
	} 
	else if("asustor" == $machine && $path=='/'){
		$res1 =  explode("\n", $res);
		$res1 =  array_filter($res1);
		$dir_list = array();
		foreach($res1 as $res2) {
			$split = preg_split('/\s+/', $res2,5);
			$split1 = preg_split('/\s+/', $split[4],2);
			$size = trim($split1[0]);
			$date = trim(substr($split1[1],0,24));	
			$dirname  = substr($split1[1],25);
			$dirname1 = trim($dirname);
			if($dirname1!='' && $dirname1!='.' && $dirname1!='..'  && substr($dirname1,0,1)!='@'){
				$dirname = "$path$dirname";
				
				$type = substr($split[0],0,1);		
				$type = $type=='d'?"D":"F";
				$dir_list[$dirname]["size"] = '';
				$parts = preg_split('/\s+/', $date);
				$dir_list[$dirname]["datetime"] = date("Y/m/d h:i:s A", strtotime($parts[2]." ".$parts[1]." ".$parts[4]." ".$parts[3]));	
				$dir_list[$dirname]["type"] = $type;	
				$dir_list[$dirname]["filename"] = $dirname1;	
			}
		}		
	} 
	else {
		$res1 =  explode("\n", $res);
		$res1 =  array_filter($res1);
		$dir_list = array();
		foreach($res1 as $res2) {
			if ((0 === strpos($res2, 'd?')) || (0 === strpos($res2, '-?'))) {
				continue;
			}
			$split = preg_split('/\s+/', $res2,5);
			$split1 = preg_split('/\s+/', $split[4],2);
			$size = trim($split1[0]);
			if ('twotier' == $machine){
				$dirname  = substr($split1[1],26);
				$date = trim(substr($split1[1],0,25));			
			} else  {
				$dirname  = substr($split1[1],25);
				$date = trim(substr($split1[1],0,24));
			}
			$trimmedDirname = trim($dirname);
			if($trimmedDirname !='' && $trimmedDirname !='.' && $trimmedDirname !='..'){
				$type = substr($split[0],0,1);		
				$type = $type=='d'?"D":"F";
				$dir_list[$dirname]["size"] = humanReadableSize(trim($size));			
				$parts = preg_split('/\s+/', $date);
				$dir_list[$dirname]["datetime"] = date("Y/m/d h:i:s A", strtotime($parts[2]." ".$parts[1]." ".$parts[4]." ".$parts[3]));	
				$dir_list[$dirname]["type"] = $type;	
			}
		}		
	}
	ksort($dir_list);
	return $dir_list;
}
/****************************************************************************************************
* Function Name         : getLocalDirListHTML
* Objective             : Returning the HTML elements for local directory list
* Added By              : Senthil Pandian
******************************************************************************************************/
function getLocalDirListHTML($dir_list,$fullPath){
	GLOBAL $machine;
	GLOBAL $index;
	GLOBAL $dirArray;
	GLOBAL $type;
	GLOBAL $class;
	
	$resHtml = '';
	/* Condition added for synology market place */
	if($fullPath=='/'){
		$fullPath = "";
		
		if($machine=='netgear' || $machine==ASUSTOR || 'twotier' == $machine){
			$fullPath = getFullPathOfSharedFolder();
			$drivePath = str_replace('/','',$fullPath);				
		}		
		foreach($dir_list as $dir=>$property)
		{
			$parts = explode("/", $dir);
			$dir = array_pop($parts);
			$fullPath = implode("/", $parts)."/";			
			$dirName = $dir;
			
			if($machine=='QNAP'){
				$drivePath = $parts[1]."/".$parts[2];
				$title = htmlentities($dir,ENT_QUOTES)." @ ".htmlentities($drivePath,ENT_QUOTES);
			} else if($machine=='netgear'){
				$drivePath = $drivePath;	
				$title = htmlentities($dir,ENT_QUOTES)." @ ".htmlentities($drivePath,ENT_QUOTES);
			} else if('twotier' == $machine){
				$drivePath = $drivePath;				
				$title = htmlentities($dir,ENT_QUOTES);				
			} else if(ASUSTOR == $machine){
				$dirName = $property['filename'];
				$drivePath = $drivePath;				
				$title = htmlentities($dir,ENT_QUOTES);				
			} else {
				$drivePath = $parts[1];
				$title = htmlentities($dir,ENT_QUOTES)." @ ".htmlentities($drivePath,ENT_QUOTES);
			}
			
			if($_SESSION['showHidden']=="Hide" && (strpos($dir, '.') === 0)){
				$tr_style='hide';
			}
			else{
				$tr_style='';
			}
			if($property['type']=="D")
			{
				if($tr_style==''){
					$resHtml .= '<tr class="row_list">';
					$resHtml .= "<td class='file_check'><input type='checkbox' name='chk_elements[".$index."]' value='".htmlentities($fullPath.$dir,ENT_QUOTES)."' id='chk_elements[".$index."]'> <label>folder</label> </td>";
					$resHtml .= "<td class='cont_heading' title='".$dirName."'><a class='getDirList' href='javascript:void(0);' alt='".htmlentities($fullPath.$dir,ENT_QUOTES)."'><img src='include/images/idq_ico_folder.png'>";
					$resHtml .= '</a>';
					$resHtml .= "<a class='getDirList' href='javascript:void(0);' alt='".htmlentities($fullPath.$dir,ENT_QUOTES)."'><span>";
					$resHtml .= str_replace(" ","&nbsp;",htmlentities($dirName,ENT_QUOTES));
					$resHtml .= '</span></a></td>';
					$resHtml .= '<td class="file_size"> -- </td><td class="file_date">'.$property["datetime"].'</td>';
					$resHtml .= '<td '.$class.'></td>';
					$resHtml .= '</tr>';	
					$index++;
				}
				$type[]   = 'folder';
				$dirArray[] = $fullPath.$dir;
			}
			else
			{
				if($tr_style==''){
					$resHtml .= '<tr '.$tr_style.'class="row_list">';
					$resHtml .= "<td class='file_check'><input type='checkbox' name='chk_elements[".$index."]' value='".htmlentities($fullPath.$dir,ENT_QUOTES)."' id='chk_elements[".$index."]'> <label>file</label> </td>";
					$resHtml .= "<td class='cont_heading' title='".$dirName."'><img src='include/images/idq_ico_file.png'><span>";
					$resHtml .= str_replace(" ","&nbsp;",htmlentities($dirName,ENT_QUOTES));
					$resHtml .= '</span></td>';
					$resHtml .= '<td class="file_size"> '.$property["size"].' </td><td class="file_date"> '.$property["datetime"].' </td>';
					$resHtml .= '<td '.$class.'></td>';
					$resHtml .= '</tr>';
					$index++;
				}					
				$type[]   = 'file';
				$dirArray[] = $fullPath.$dir;
			}				
		}			
	} else { 
		$fullPath = "$fullPath/";		
		foreach($dir_list as $dir=>$property)
		{
			if($_SESSION['showHidden']=="Hide" && (strpos($dir, '.') === 0)){
				$tr_style='hide';
			}
			else{
				$tr_style='';
			}
			$dirName = $dir;
			
			if($property['type']=="D")
			{
				if($tr_style==''){
					$resHtml .= '<tr class="row_list">';
					$resHtml .= "<td class='file_check'><input type='checkbox' name='chk_elements[".$index."]' value='".htmlentities($fullPath.$dir,ENT_QUOTES)."' id='chk_elements[".$index."]'><label>folder</label></td>";
					$resHtml .= "<td class='cont_heading' title='".htmlentities($dirName,ENT_QUOTES)."'><a class='getDirList' href='javascript:void(0);' alt='".htmlentities($fullPath.$dir,ENT_QUOTES)."'><img src='include/images/idq_ico_folder.png'>";
					$resHtml .= '</a>';
					$resHtml .= "<a class='getDirList' href='javascript:void(0);' alt='".htmlentities($fullPath.$dir,ENT_QUOTES)."'><span>";
					$resHtml .= str_replace(" ","&nbsp;",htmlentities($dirName,ENT_QUOTES));
					$resHtml .= '</span></a></td>';
					$resHtml .= '<td class="file_size"> -- </td><td class="file_date">'.$property["datetime"].'</td>';
					$resHtml .= '<td '.$class.'></td>';
					$resHtml .= '</tr>';	
					$index++;
				}
				$type[]   = 'folder';
				$dirArray[] = $fullPath.$dir;
			}
			else
			{
				if($tr_style==''){
					$resHtml .= '<tr class="row_list">';
					$resHtml .= "<td class='file_check'><input type='checkbox' name='chk_elements[".$index."]' value='".htmlentities($fullPath.$dir,ENT_QUOTES)."' id='chk_elements[".$index."]'><label>file</label></td>";
					$resHtml .= "<td class='cont_heading' title='".htmlentities($dir,ENT_QUOTES)."'><img src='include/images/idq_ico_file.png'><span>";
					$resHtml .= str_replace(" ","&nbsp;",htmlentities($dir,ENT_QUOTES));
					$resHtml .= '</span></td>';
					$resHtml .= '<td class="file_size"> '.$property["size"].' </td><td class="file_date"> '.$property["datetime"].' </td>';
					$resHtml .= '<td '.$class.'></td>';
					$resHtml .= '</tr>';
					$index++;
				}
				$type[]   = 'file';
				$dirArray[] = $fullPath.$dir;
			}		
		}
	}	
	return $resHtml;
}
/****************************************************************************************************
* Function Name         : getRemoteLocationListHTML
* Objective             : Returning the HTML elements for Remote Location List
* Added By              : Senthil Pandian
******************************************************************************************************/
function getRemoteLocationListHTML($dir_list,$fullPath){
	GLOBAL $machine;
	GLOBAL $index;
	GLOBAL $dirArray;
	GLOBAL $type;
	GLOBAL $class;
	$resHtml = '';
	/* Condition added for synology market place */
	if($fullPath=='/'){
		$fullPath = "";
		foreach($dir_list as $dir=>$property)
		{
			if($machine=='twotier') {
				if($property!='.' && $property!='..'){
					$dir = $property;
				} else {
					continue;
				}
				$drivePath = IDRIVE_VAULT_RESTORELOCATION_ROOT;
				$fullPath  = '/'.IDRIVE_VAULT_RESTORELOCATION_ROOT.'/';
			} else {
				$parts = explode("/", $dir);
				if($machine==ASUSTOR)
					$dirName = $property['filename'];
				else
					$dirName = $dir;

				$fullPath = implode("/", $parts)."/";
				
				if($machine=='QNAP'){
					$drivePath = $parts[1]."/".$parts[2];
				} else if($machine=='netgear'){
					$fullPath = getFullPathOfSharedFolder();
					$drivePath = str_replace('/','',$fullPath);				
				} else {
					$drivePath = $parts[1];
				}		
			}	
			if($_SESSION['showHidden']=="Hide" && (strpos($dir, '.') === 0)){
				$tr_style='hide';
			}
			else{
				$tr_style='';
			}
			if($machine=='twotier')
				$title = htmlentities($dir,ENT_QUOTES);
			else 
				$title = htmlentities($dir,ENT_QUOTES)." @ ".htmlentities($drivePath,ENT_QUOTES);

			if($machine==ASUSTOR)
				$path = $dir;
			else
				$path = $fullPath.$dir;
			if($tr_style==''){
				$resHtml .= '<tr class="'.$tr_style.'" >';
				$resHtml .= "<td class='cont_heading' width='100%' title='".$dirName."'><span>";
				$resHtml .= "<a class='getRestoreDirList' href='javascript:void(0);' alt='".htmlentities($path,ENT_QUOTES)."'><img src='include/images/idq_ico_folder.png'>";
				$resHtml .= htmlentities($dirName,ENT_QUOTES);
				$resHtml .= "</a><input type='hidden' value='".htmlentities($path,ENT_QUOTES)."/' /></span></td>";
				$resHtml .= '</tr>';
	
				$index++;
				$type[]   = 'folder';		
				$dirArray[] = $path;
			}							
		}			
	} else { 
		$fullPath = "$fullPath/";		
		foreach($dir_list as $dir)
		{
			if(trim($dir) !='' && trim($dir)!='.' && trim($dir)!='..'){
				if($_SESSION['showHidden']=="Hide" && (strpos($dir, '.') === 0)){
					$tr_style='hide';
				}
				else{
					$tr_style='';
				}
				if($tr_style==''){
					$resHtml .= '<tr class="'.$tr_style.'" >';
					$resHtml .= "<td class='cont_heading' width='100%' title='".htmlentities($dir,ENT_QUOTES)."'><span>";
					$resHtml .= "<a class='getRestoreDirList' href='javascript:void(0);' alt='".htmlentities($fullPath.$dir,ENT_QUOTES)."'><img src='include/images/idq_ico_folder.png'>";
					$resHtml .= htmlentities($dir,ENT_QUOTES);
					$resHtml .= "</a><input type='hidden' value='".htmlentities($fullPath.$dir,ENT_QUOTES)."/' /></span></td>";
					$resHtml .= '</tr>';
		
					$index++;
					$type[]   = 'folder';				
					if($machine==ASUSTOR)	
						$dirArray[] = $fullPath;
					else
						$dirArray[] = $fullPath.$dir;				
						
				}
			}
		}
	}	
	return $resHtml;
}

/****************************************************************************************************
* Function Name         : getCronContent
* Objective             : This function will return the cron file content based on machine
* Added By              : Deepak Chaurasia
******************************************************************************************************/
function getCronContent($MIN, $HOUR, $DOM, $MON, $DOW){
	GLOBAL $machine;
	GLOBAL $user;

	if ("QNAP" == $machine || ASUSTOR == $machine) {
		$content = $MIN." ".$HOUR." ".$DOM." ".$MON." ".$DOW." ";
	}
	else{
		$content = $MIN."\t".$HOUR."\t".$DOM."\t".$MON."\t".$DOW."\t".$user."\t";		
	}
	return $content;
}

/****************************************************************************************************
* Function Name         : getListForDirectory
* Objective             : This function will return the directory list for the path passed as input
* Added By              : Deepak Chaurasia
******************************************************************************************************/
function getListForDirectory($fullPath){
	GLOBAL $machine;
	GLOBAL $appPath;
	
	$full_Path = $fullPath;
    if ("twotier" == $machine){
        $fullPath = str_replace("'","'\''",$fullPath);
    }
    else if ("synology" == $machine) {
		$fullPath = preg_replace("/\"/","\\\"",$fullPath);
		$fullPath = str_replace('$','\$',$fullPath);
    } else {
		$fullPath = str_replace("'","'\''",$fullPath);
		$fullPath = str_replace('\\','\\\\',$fullPath);
		$fullPath = preg_replace("/\"/","\\\"",$fullPath);
		$fullPath = str_replace('$','\$',$fullPath);
		$fullPath = str_replace('`','\`',$fullPath);
    }
	$page_no = 1;
	$list_per_page = 1000;
	if (isset($_GET['page_no'])) $page_no = $_GET['page_no'];
	$from = ($list_per_page * ($page_no -1));
	$from = ($from === 0 ? 1 : $from+1);
	$to = (($list_per_page * $page_no) . 'p');
	$pagination = ("sed -n $from,$to");
	
	if($machine == "netgear"){
		if($fullPath=='/'){
			$res = getNetgearSharedFolders();
		} else {
			$res = systemCmdExecution("$appPath/ls -aln '$fullPath' --time-style=\"+%a %b %e %H:%M:%S %Y\" | grep '^d\|^-' | $pagination");
			$res = parseLocalDirList($res,$full_Path);
		}
	}
	else if($machine == "QNAP"){
		if($fullPath=='/'){
			$res = getQNAPSharedFolders();
		} else {
			$res = systemCmdExecution("ls -alen '$fullPath' | grep '^d\|^-' | $pagination");
			$res = parseLocalDirList($res,$full_Path);
		}		
	}
	else if($machine == "synology"){
		
		if($fullPath=='/'){
			$res = getSynologySharedFolders(); //Getting shared folders list	
		} else {
			if (hasReadPermissions($fullPath)) {
				if ($_SESSION['haslsdatetimeformat'] == 0) {
					$command  = ('ls -aln ' . escapeshellarg($fullPath));
					$command .= (' --time-style=\"+%a %b %e %H:%M:%S %Y\" | grep \'^d\|^-\' | ' . $pagination);
				}
				else {
					$command  = ('ls -alen ' . escapeshellarg($fullPath));
					$command .= (' | grep \'^d\|^-\' | ' . $pagination);
				}
				$res = systemCmdExecution($command);
				$res = parseLocalDirList($res,$full_Path);
			}
			else {
				$res = array();
			}
		}
	}
	else if ("twotier" == $machine) {
		if($fullPath=='/'){
			$res = getTwotierSharedFolders();
		} else {
			$res = systemCmdExecution("/bin/ls -aln  -D \"+%a %b %e %H:%M:%S %Y\" '$fullPath' | grep '^d\|^-' | $pagination");
			$res = parseLocalDirList($res,$full_Path);
		}
	}
	else if($machine == ASUSTOR){
		if($fullPath=='/'){
			$res = getASUSTORSharedFolders();
		} else {
			$res = systemCmdExecution("ls -alen '$fullPath' | grep '^d\|^-' | $pagination");
			$res = parseLocalDirList($res,$full_Path);
		}		
	}
	
	return $res;
}


/****************************************************************************************************
* Function Name         : excludeworkingfolder
* Objective             : Creating/updating full path exclude file with working folder
* Added By              : Pooja Havaldar
******************************************************************************************************/
function excludeworkingfolder()
{
	GLOBAL $baseDir,$excludeFullFile,$webDir,$userName,$machine,$permissionVal;

	if($machine=="netgear" || $machine=="twotier"){
		return true;
	}
	
	$servicePath = getOriginalServicePath();
	$servicePath .= "\n";
	
	if (!file_exists($excludeFullFile)) {
		file_put_contents($excludeFullFile, ($servicePath ."folder\n"));
		unset($_SESSION['fullEntry']);
		unset($_SESSION['fullEntryImg']);
	}
	else {
		$sessionFullEntry = file_get_contents($excludeFullFile, FILE_IGNORE_NEW_LINES);

		$ret = strpos($sessionFullEntry,$servicePath);
		if($ret === FALSE){			
			$sessionFullEntry = trim($sessionFullEntry, "\s");
			file_put_contents($excludeFullFile, $servicePath . "folder\n" . $sessionFullEntry);

			unset($_SESSION['fullEntry']);
		}
		@chmod($excludeFullFile, $permissionVal);
	}
}

/****************************************************************************************************
* Function Name         : getOriginalServicePath
* Objective             : Returns the Working folder path according to machine
* Modified By           : Senthil Pandian
******************************************************************************************************/
function getOriginalServicePath()
{	
	$servicePath = getWebDirPath()."/".SERVICE;;
	return $servicePath;
}

/****************************************************************************************************
* Function Name         : getWebDirPath
* Objective             : Returns the Web directory path according to machine
* Added By              : Senthil Pandian
******************************************************************************************************/	
function getWebDirPath()
{
		GLOBAL $baseDir,$webDir,$machine;
		
	$servicePath = "$baseDir/$webDir";
	
	if("synology" == $machine || ASUSTOR == $machine)
		$servicePath = readlink("$baseDir/$webDir");
		
		return $servicePath;
}
	
/****************************************************************************************************
* Function Name         : machineBasedError
* Objective             : Returning machine based error for backup list
* Added By              : Senthil Pandian
******************************************************************************************************/
/*function machineBasedError(){
	GLOBAL $machine;	
	if("synology" == $machine){
		if(isset($_SESSION['encryptedToken']) && isset($_SESSION['nasUserName'])){
			$resHtml = '<div class="nfiles" style="display:block;"><span style="font-size: 12px; color: #b33e3e;">'.str_replace('#USERNAME#',$_SESSION['nasUserName'],NO_SH).'<span></div>';
		} else {
			$resHtml = '<div class="nfiles" style="display:block;">'.SESSION_TIMEOUT.'</div>';
		}
	} else {
		$resHtml = '<div class="nfiles" style="display:block;">No files</div>';	
	}
	return $resHtml;
}*/

/****************************************************************************************************
* Function Name         : createLocalSearchTxt
* Objective             : Creating Local Search Txt file
* Added By              : Senthil Pandian
******************************************************************************************************/
function createLocalSearchTxt($localPatternPath,$searchKeyword,$searchPath)
{
	GLOBAL $machine,$permissionVal;
	
	if($searchPath=='/'){
		file_put_contents("$localPatternPath/".SEARCH_FILE,$searchKeyword);
		if("synology" == $machine){			
			$dir_list = getSynologySharedFolders(SYNOLOGY_AVOID_PROP);		
			foreach($dir_list as $dir=>$property){			
				file_put_contents("$localPatternPath/".SEARCH_FILE,"\n".$dir,FILE_APPEND);
			}
			@chmod("$localPatternPath/".SEARCH_FILE, $permissionVal);
		} else if("QNAP" == $machine){
			$res = getQNAPSharedFolders();
			foreach($res as $dir=>$property){			
				file_put_contents("$localPatternPath/".SEARCH_FILE,"\n".$dir,FILE_APPEND);
			}
			@chmod("$localPatternPath/".SEARCH_FILE, $permissionVal);			
		} else if("netgear" == $machine){
			$res = getNetgearSharedFolders();
			$path = getFullPathOfSharedFolder();
			foreach($res as $dir=>$property){
				//$dir = $path.$dir;
				file_put_contents("$localPatternPath/".SEARCH_FILE,"\n".$dir,FILE_APPEND);
			}
			@chmod("$localPatternPath/".SEARCH_FILE, $permissionVal);			
		}		
		else if ("twotier" == $machine) {
			$res = getTwotierSharedFolders();
			$path = getFullPathOfSharedFolder();
			foreach($res as $dir=>$property){
				file_put_contents("$localPatternPath/".SEARCH_FILE,"\n".$dir,FILE_APPEND);
			}
			@chmod("$localPatternPath/".SEARCH_FILE, $permissionVal);			
		} 
		else if(ASUSTOR == $machine){
			$res = getASUSTORSharedFolders();
			$path = getFullPathOfSharedFolder();
			foreach($res as $dir=>$property){			
				file_put_contents("$localPatternPath/".SEARCH_FILE,"\n".$dir,FILE_APPEND);
			}
			@chmod("$localPatternPath/".SEARCH_FILE, $permissionVal);			
		}
	} else {
		file_put_contents("$localPatternPath/".SEARCH_FILE,$searchKeyword."\n".$searchPath);
	}
	@chmod($nasUserFile, $permissionVal);
}
/****************************************************************************************************
* Function Name         : getProxyDetail
* Objective             : Reading Proxy details
* Added By              : Senthil Pandian
******************************************************************************************************/
function getProxyDetail(){
	GLOBAL $machine;
	$output = array();
	
	if($machine=="synology"){
		$proxyConfFile = SYNOLOGY_PROXYCONF;
		if(!file_exists($proxyConfFile)){
			return $output;
		}
		
		$isProxyEnabled = array();
		$contents = file($proxyConfFile);
		foreach ($contents as $line) {				
			if(strpos($line, "proxy_enabled=") !== FALSE){
				$isProxyEnabled = explode("=", $line);
				$temp = trim($isProxyEnabled[1]);
				$_SESSION['isProxyEnabled']=true;
				if($temp == "no"){
					$proxy_enabled=0;
					unset($_SESSION['ipAddress']);
					unset($_SESSION['port']);
					unset($_SESSION['proxyUserName']);
					unset($_SESSION['proxyPassword']);
					$_SESSION['isProxyEnabled']=false;
					break;
				}
			}			
			elseif(strpos($line, "https_host=") !== FALSE){
				$proxyAddrField = explode("=", $line);
				$output[0] = trim($proxyAddrField[1]);
				$_SESSION['ipAddress'] = $output[0];
			}
			elseif(strpos($line, "https_port=") !== FALSE){
				$proxyPassField = explode("=", $line);
				$output[1] = trim($proxyPassField[1]);
				$_SESSION['port']=$output[1];
			}			
			elseif(strpos($line, "auth_enabled=") !== FALSE){
				$isAuthEnabled = explode("=", $line);
				$temp = trim($isAuthEnabled[1]);
				if($temp == "no"){
					$auth_enabled=0;					
				}
			}
			elseif(strpos($line, "proxy_user=") !== FALSE){
				$proxyUser = explode("=", $line);
				if($proxyUser === ""){
					$output[2] = "";
					$_SESSION['proxyUserName']='';
				}
				else{
					$output[2] = trim($proxyUser[1]);
					$_SESSION['proxyUserName']=trim($proxyUser[1]);
				}
			}
			elseif(strpos($line, "proxy_pwd=") !== FALSE){
				$proxyPass = explode("=", $line);
				if($proxyPass === ""){
					$output[3] = "";
					$_SESSION['proxyPassword']='';
				}
				else{
					$output[3] = trim($proxyPass[1]);
					$_SESSION['proxyPassword']=trim($proxyPass[1]);
				}
			}			
		}
		$_SESSION['proxy_option']='autodetect';
	} 
	else if($machine=="QNAP"){
		$_SESSION['isProxyEnabled']=true;
		$proxyDetails = shell_exec("/sbin/getcfg \"System\" \"proxy server\" -d \"\"");
		$proxyDetails = trim($proxyDetails);	
		if($proxyDetails == ""){
			return $output;
		}
		$proxyUser = shell_exec("/sbin/getcfg \"System\" \"proxy username\" -d \"\"");
		$proxyUser = trim($proxyUser);
		if($proxyUser === ""){
			$output[2] = "";
			$_SESSION['proxyUserName']="";
		}
		else{
			$output[2] = $proxyUser;
			$_SESSION['proxyUserName']=$proxyUser;
		}
		$proxyPass = shell_exec("/sbin/getcfg \"System\" \"proxy password\" -d \"\"");
		$proxyPass = trim($proxyPass);
		if($proxyPass === ""){
			$output[3] = "";
			$_SESSION['proxyPassword']='';
		}
		else{
			$output[3] = $proxyPass;
			$_SESSION['proxyPassword']=$proxyPass;
		}
		$proxyFields = explode(":", $proxyDetails);	
		$output[0] = str_replace('/','',$proxyFields[1]); 
		$output[1] =trim($proxyFields[2]);
		$_SESSION['ipAddress'] = trim($output[0]);
		$_SESSION['port']	   = $output[1];
		$_SESSION['proxy_option']='autodetect';				
	}
	else if($machine==ASUSTOR){
		$proxy_enabled=1;
		$auth_enabled=1;
		$proxyConfFile = ASUSTOR_PROXYCONF;
		if(file_exists($proxyConfFile) === FALSE)
			return $output;
		
		$contents = file($proxyConfFile);
		$proxy_data = 0;
		$i = 0;
		foreach ($contents as $line) {
			if(strpos($line, "[Proxy Client]") !== FALSE){
				$proxy_data = 1;
				continue;
			}
			
			if($proxy_data == 1 && $i<6){					
				if(strpos($line, "IsEnabled =") !== FALSE){
					$isProxyEnabled = explode("=", $line);
					$proxy_enabled_chk = trim($isProxyEnabled[1]);
					$_SESSION['isProxyEnabled']=true;
					if($proxy_enabled_chk == 'No'){
						$proxy_enabled = 0;
						unset($_SESSION['ipAddress']);
						unset($_SESSION['port']);
						unset($_SESSION['proxyUserName']);
						unset($_SESSION['proxyPassword']);
						$_SESSION['isProxyEnabled']=false;
						break;
					}
					$i++;
				}
				else if(strpos($line, "ServerAddress =") !== FALSE){
					$proxyAddrField = explode("=", $line);
					$server_ip = preg_replace("(https?://)", "", trim($proxyAddrField[1]));
					$output[0] = $server_ip;
					$_SESSION['ipAddress'] = $output[0];
					$i++;
				}
				else if(strpos($line, "ServerPort =") !== FALSE){
					$proxyAddrField = explode("=", $line);
					$output[1] = trim($proxyAddrField[1]);
					$_SESSION['port']=$output[1];
					$i++;
				}
				else if(strpos($line, "AuthEnabled =") !== FALSE){
					$proxyAddrField = explode("=", $line);
					$auth_enabled_chk = trim($proxyAddrField[1]);
					if($auth_enabled_chk == 'No')
						$auth_enabled = 0;
					$i++;
				}
				else if(strpos($line, "AuthUsername =") !== FALSE){
					$proxyAddrField = explode("=", $line);
					$output[2] = trim($proxyAddrField[1]);
					$_SESSION['proxyUserName']=$output[2];
					$i++;
				}
				else if(strpos($line, "AuthPassword =") !== FALSE){
					$proxyAddrField = explode("=", $line);
					$output[3] = trim($proxyAddrField[1]);
					$_SESSION['proxyPassword']=$output[3];
					$i++;
				}
			}
		}				
		$_SESSION['proxy_option']='autodetect';
	}	
	return $output;
}
/****************************************************************************************************
* Function Name         : getFullPath
* Objective             : Reading Proxy details
* Added By              : Senthil Pandian
******************************************************************************************************/
function createRestoreLocationFile(){
	GLOBAL $machine,$drlFile,$userName,$permissionVal;
	
	if($machine=="QNAP" || $machine=="synology" || $machine==ASUSTOR){
		$servicePath = getOriginalServicePath();
		$restorePath = "$servicePath/".USER_PROFILE."/$userName/RESTORE_DATA";
		file_put_contents($drlFile,$restorePath);
		@chmod($drlFile, $permissionVal);
	} else if($machine=="netgear"){		
		$idrivePath = NETGEAR_HOME_PATH.SERVICE;
		/* Creating the directory "idrive" if not exist */
		if(!is_dir($idrivePath)){
			if(!mkdir($idrivePath, $permissionVal)){	
				Scheduler::Log("Failed to create Directory " . $idrivePath . " : " . $php_errormsg);
				exit;
			}
		}
		$userProfile = $idrivePath.'/'.USER_PROFILE;
		if(!is_dir($userProfile)){
			if(!mkdir($userProfile, $permissionVal)){	
				Scheduler::Log("Failed to create Directory " . $userProfile . " : " . $php_errormsg);
				exit;
			}
		}		
		$userFolder = $userProfile."/$userName";
		if(!is_dir($userFolder)){
			if(!mkdir($userFolder, $permissionVal)){	
				Scheduler::Log("Failed to create Directory " . $userFolder . " : " . $php_errormsg);
				exit;
			}
		}
		$restorePath = $userFolder.'/RESTORE_DATA';
		if(!is_dir($restorePath)){
			if(!mkdir($restorePath, $permissionVal)){	
				Scheduler::Log("Failed to create Directory " . $restorePath . " : " . $php_errormsg);
				exit;
			}
		}
		file_put_contents($drlFile,$restorePath);
		@chmod($drlFile, $permissionVal);
	}
	else if ("twotier" == $machine) {
		$restorePath = IDRIVE_VAULT_RESTORELOCATION;
		if(!file_exists($restorePath)){
			$restoredData = '/'.IDRIVE_VAULT_RESTORELOCATION_ROOT;
			if(!is_dir($restoredData)){
				systemCmdExecutionViaPerl("mkdir $restoredData");
			}
			systemCmdExecutionViaPerl("mkdir $restorePath");
		}
		file_put_contents($drlFile,$restorePath);
		@chmod($drlFile, $permissionVal);
	}
	return $restorePath;
}
/****************************************************************************************************
* Function Name         : checkServicePath
* Objective             : Checking the first element of full path exclude file
* Added By              : Senthil Pandian
******************************************************************************************************/
function checkServicePath($firstElement,$servicePath){
	GLOBAL $machine;
	if($firstElement==$servicePath || $machine=="netgear" ||  $machine=="twotier"){
		return false;
	}
	return true;
}

/****************************************************************************************************
* Function Name         : getSearchPattern
* Objective             : Getting the search pattern for Search
* Added By              : Pooja Havaldar
*****************************************************************************************************/
function getSearchPattern($searchKeyword = "")
{
	GLOBAL $machine;
	if($searchKeyword == ""){
		scheduler::Log("No pattern to search : ");
		return;
	}
	
	if("QNAP" == $machine){
		$searchKeyword = str_replace('\\','',$searchKeyword);
		return $searchKeyword;
	}
	return $searchKeyword;
}

/****************************************************************************************************
* Subroutine Name         : removeFromCron.
* Objective               : Remove crontab entries.
* Added By                : Uttam Tiwari.
*not in use
******************************************************************************************************/
function removeFromCron()
{
	GLOBAL $baseDir;
	GLOBAL $webDir;
	GLOBAL $userName;

	$retVal = perlScriptExecution(REMOVECRON);
	unlink("$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/".REMOVE_FROM_CRON_TAB_FILE);

return $retVal;
}
/****************************************************************************************************
* Function Name         : getBackupMode
* Objective             : Get backup mode to enable/disable Archive cleanup link
* Added By              : Senthil Pandian
******************************************************************************************************/
function getBackupMode(){
	GLOBAL $relativeFile;
	if(file_exists($relativeFile))
	{
		$readRelativetxt = file_get_contents($relativeFile);
		if($readRelativetxt == NORELATIVE){
			$backupMode='relative';
		}
		else{
			$backupMode='mirror';
		}
	}
	else{
		$backupMode='mirror';
	}
	return $backupMode;
}

/****************************************************************************************************
* Function Name         : getCleanupCmd
* Objective             : Get command for archive cleanup
* Added By              : Deepak
******************************************************************************************************/
function getCleanupCmd($jobName){
	GLOBAL $machine;
	GLOBAL $appPath;
	GLOBAL $archive_dir;

	$perlPath = getPerlPath();
	$scriptPath = "$appPath/".SCRIPT;
	$cmd = "$perlPath $scriptPath/".GETCLEANUPLIST;

	return $cmd;
}
/****************************************************************************************************
* Function Name         : getNAShostname
* Objective             : Getting host name of NAS
* Added By              : Senthil Pandian
******************************************************************************************************/
function getNAShostname(){
	GLOBAL $machine;
	GLOBAL $mpc;
	$hostName = '';
	if($machine=="twotier"){
		if(file_exists($mpc)){
			$hostName = file_get_contents($mpc);			
		} 
		else if(file_exists('/'.MPC_FILE)){			
			$hostName = file_get_contents('/'.MPC_FILE);
			$hostName = "/$hostName";
		}
	
		$hostName = trim($hostName);
		if(!$hostName){
			$hostName = '/';
			Scheduler::Log(MPC_FILE . "#$hostName#");
		}
	} else {
		$hostName = gethostname();
	}
	return $hostName;
}
/****************************************************************************************************
* Function Name         : update_mpc
* Objective             : update the backup location to mpc.txt file
* Added By              : Deepak Chaurasia
******************************************************************************************************/
function update_mpc($mpcLoc='')
{
	GLOBAL $mpc;
	GLOBAL $permissionVal;
	GLOBAL $machine;
	
	if($machine=='twotier' && (trim($mpcLoc)=='/' || $mpcLoc=='')){
		$mpcName = getNAShostname();
	} else if($mpcLoc == "")
		$mpcName = "/".php_uname('n');
	else	
		$mpcName = rtrim(phpRealEscapeString($mpcLoc), '/');
		
	file_put_contents($mpc, $mpcName);
	@chmod($mpc, $permissionVal);
	return $mpcName ;
}
/****************************************************************************************************
* Function Name         : getPermission
* Objective             : Getting permission based on machine type.
* Added By              : Sajana K
******************************************************************************************************/
function getPermission()
{

	$permission = 0777;

	
	return $permission;
}

/************************************************************************************************
* Subroutine Name	: readConfFile
* Objective		: TO read machine details
* Added By		: Avinash
* Modified By		: Senthil Pandian
* Modified On		: 16-04-2014
************************************************************************************************/
function readConfFile()
{
	if (file_exists(__DIR__ . '/'.CONFIG_FILE)) {
		$file = fopen(__DIR__ . '/'.CONFIG_FILE ,"r");
	}
	
	if(!$file) {
		$_SESSION['msg'] = 'System Configuration Settings are missing.';
		$destinationURL = "http://$serverIPAddress/".APPDIR."/".CONFIG."/messageDisplay.php";
  		header("Location:$destinationURL");
		exit();
	}

	$hash = array();
	while(! feof($file)) {
		$pair = preg_split ('/\s+/',fgets($file));
		$hash[array_shift($pair)] = array_shift($pair);
	}
	
	fclose($file);
	
	GLOBAL $machine;
	$machine 		= $hash['machine'];
	$permissionVal	= getPermission();

	$_SESSION['webDir'] 	= $hash['webDir'];
	$_SESSION['baseDir'] 	= $hash['baseDir'];
	$_SESSION['nasUser'] 	= $hash['user'];
	$_SESSION['machine'] 	= $machine;
	$_SESSION['permission'] = $permissionVal;
	
	return $hash;
}

/****************************************************************************************************
* Function Name         : backupJobList
* Objective             : Getting machine based backup Job List
* Added By              : Senthil Pandian
******************************************************************************************************/
function backupJobList($jobs=''){
	GLOBAL $machine;
	if($machine=='twotier'){
		print '<td colspan="2" class="topHeading" width="40%">
				<input type="hidden" id="select_job" name="select_job"  value="'.DEFAULT_BACKUPSET_NAME.'">';
		print "Contents of Backup Set";
		print "</td>";
	} else {
		print '<td colspan="2" class="topHeading" width="40%">Backup Set Name:
				<select id="select_job" name="select_job"  class="backupsetInput" onchange="loadExistingJob(this.value,\'backup\')">
				<option value="0" selected="selected">Select Backup Set</option>';
			foreach($jobs as $k=>$job) {
				if($job["job_type"] == "Backup") {
					$jobName = substr($k,7);
					print '<option value="'.$k.'">'.$jobName.'</option>';
				}
			}
		print '</select></td><td colspan="2" class="topHeading scheduleChangeBtn" align="left" width="35%" style="display:none;">
				<span class="schedulerSpan">Backup Schedule:</span> 
				<span class="backuptime"><!--5:30 am Daily &nbsp;<img src="include/images/idq_ico_schedarrow.png" >--></span>
			</td>';
	}		
}

/************************************************************************************************
* Subroutine Name	: checkErrorAndUpdateServerAddr.
* Objective			: Read error.txt file check for server error if found update server address.
* Added By			: Avinash Kumar.
*************************************************************************************************/
function checkErrorAndUpdateServerAddr($evsErrorPath)
{
	if(file_exists($evsErrorPath) && filesize($evsErrorPath)){
		$evsError = file_get_contents($evsErrorPath);
		if(FALSE != (strpos($evsError, SERVER_ERROR))){
			getServerAddress();
			return TRUE;
		}
	}
	return FALSE;
}

/****************************************************************************************************
* Function Name         : periodicCronupdate
* Objective             : Updating crontab entry for Periodic Cleanup
* Added By              : Sajana K
*****************************************************************************************************/
function periodicCronupdate()
{
	GLOBAL $periodic_days;
	GLOBAL $job_name;
	GLOBAL $machine;
	$startDate = date("Y-m-d");
	$cronTimearr = getCrontime();
	$periodInterval = "*/".$periodic_days;
	$content = getCronContent($cronTimearr[2], $cronTimearr[1], "*", "*", "*");
	$command = Scheduler::CreateJobCommand(ARCHIVE_JOB."_".$job_name, ARCHIVE_JOB);
	$phpBinaryPath = "php";
	if($machine == "QNAP") $phpBinaryPath = PHP_PATH_FOR_QNAP;
	$content .= $command." '$startDate' '$periodic_days' '$phpBinaryPath'";
	Scheduler::AddCronJob(ARCHIVE_JOB."_".$job_name, "Archive", $content);
}

/*********************************************************************************************************
* Subroutine Name       : getSharedList
* Objective             : To get machine based shared folder/file lists.
* Added By              : Yogesh Kumar P
* Modified By			: Sabin Cheruvattil - 2016-05-18 | modified if to switch
**********************************************************************************************************/
function getSharedList()
{
	GLOBAL $machine;
	
	switch($machine) {
		case 'synology':
			saveSynologySharedFolders();
			break;
		case 'QNAP':
			saveQNAPSharedFolders();
			break;
		case 'netgear':
			saveNetgearSharedFolders();
			break;
		case 'twotier':
			saveTwotierSharedFolders();
			break;
		case ASUSTOR:
			saveASUSTORSharedFolders();
			break;
		default:
			break;
	}
}

/*********************************************************************************************************
* Subroutine Name       : validateFileList
* Objective             : Validate every item of file list
* Added By              : Avinash Kumar
* Mofified By			: Sabin Cheruvattil - 2016 May 03
* Modification Reason	: PL was getting wrong path from the function 'perlScriptExecution'. This change is intented to make multi user login
**********************************************************************************************************/
function validateFileList($filePath, $refreshItem, $jobPath = '')
{
	GLOBAL $temp_file,$permissionVal;
	
	$tmpFileContent = VALIDATE_FILELIST . "\n" . $filePath . "\n" . $refreshItem;
	file_put_contents($temp_file, $tmpFileContent);
	@chmod($temp_file, $permissionVal);
	
	$output = '';
	if($jobPath != '') {
		$output = perlScriptExecution(OPERATIONSFILE, $jobPath);
	} else {
		$output = perlScriptExecution(OPERATIONSFILE, dirname($filePath) . '/');
	}

	return $output;
}

/*********************************************************************************************************
* Subroutine Name       : getProxySettings
* Objective             : To get proxy settings.
* Added By              : Yogesh Kumar P
**********************************************************************************************************/
function getProxySettings() {
	GLOBAL $machine;
	$output = array();
	if($machine=="QNAP"){
		$proxyDetails = shell_exec("/sbin/getcfg \"System\" \"proxy server\" -d \"\"");
		$proxyDetails = trim($proxyDetails);	
		if($proxyDetails != ""){			
			$proxyUser = shell_exec("/sbin/getcfg \"System\" \"proxy username\" -d \"\"");
			$proxyUser = trim($proxyUser);
			if($proxyUser === ""){
				$output[2] = "";
			}
			else{
				$output[2] = $proxyUser;
			}
			$proxyPass = shell_exec("/sbin/getcfg \"System\" \"proxy password\" -d \"\"");
			$proxyPass = trim($proxyPass);
			if($proxyPass === ""){
				$output[3] = "";
			}
			else{
				$output[3] = $proxyPass;
			}
			$proxyFields = explode(":", $proxyDetails);	
			$output[0] = str_replace('/','',$proxyFields[1]); 
			$output[1] = $proxyFields[2];
		}
	}
	else if($machine==ASUSTOR){
		$proxy_enabled=1;
		$auth_enabled=1;
		$proxyConfFile = ASUSTOR_PROXYCONF;
		if(file_exists($proxyConfFile) === FALSE)
			return $output;
			
		$contents = file($proxyConfFile);
		$proxy_data = 0;
		$i = 0;
		foreach ($contents as $line) {
			if(strpos($line, "[Proxy Client]") !== FALSE){
				$proxy_data = 1;
				continue;
			}
			
			if($proxy_data == 1 && $i<6){					
				if(strpos($line, "IsEnabled =") !== FALSE){
					$isProxyEnabled = explode("=", $line);
					$proxy_enabled_chk = trim($isProxyEnabled[1]);
					if($proxy_enabled_chk == 'No'){
						$proxy_enabled = 0;
						break;
					}
					$i++;
				}
				else if(strpos($line, "ServerAddress =") !== FALSE){
					$proxyAddrField = explode("=", $line);
					$server_ip = preg_replace("(https?://)", "", trim($proxyAddrField[1]));
					$output[0] = $server_ip;
					$i++;
				}
				else if(strpos($line, "ServerPort =") !== FALSE){
					$proxyAddrField = explode("=", $line);
					$output[1] = trim($proxyAddrField[1]);
					$i++;
				}
				else if(strpos($line, "AuthEnabled =") !== FALSE){
					$proxyAddrField = explode("=", $line);
					$auth_enabled_chk = trim($proxyAddrField[1]);
					if($auth_enabled_chk == 'No')
						$auth_enabled = 0;
					$i++;
				}
				else if(strpos($line, "AuthUsername =") !== FALSE){
					$proxyAddrField = explode("=", $line);
					$output[2] = trim($proxyAddrField[1]);
					$i++;
				}
				else if(strpos($line, "AuthPassword =") !== FALSE){
					$proxyAddrField = explode("=", $line);
					$output[3] = trim($proxyAddrField[1]);
					$i++;
				}
			}
		}
		
		if($proxy_enabled==0)
			$output = array();
		else if($auth_enabled==0){
			$output[2] = "";
			$output[3] = "";
		}
	}
	else{
	
		$proxy_enabled=1;
		$auth_enabled=1;
		
		$proxyConfFile = SYNOLOGY_PROXYCONF;
		if(file_exists($proxyConfFile) === TRUE){
			$isProxyEnabled = array();
			$contents = file($proxyConfFile);
			foreach ($contents as $line) {
				if(strpos($line, "proxy_enabled=") !== FALSE){			
					$isProxyEnabled = explode("=", $line);
					$temp = trim($isProxyEnabled[1]);
					if($temp == "no"){
						$proxy_enabled=0;
					}
				}			
				elseif(strpos($line, "https_host=") !== FALSE){
					$proxyAddrField = explode("=", $line);
					$output[0] = $proxyAddrField[1];
				}
				elseif(strpos($line, "https_port=") !== FALSE){
					$proxyPassField = explode("=", $line);
					$output[1] = $proxyPassField[1];				
				}			
				elseif(strpos($line, "auth_enabled=") !== FALSE){
					$isAuthEnabled = explode("=", $line);
					$temp = trim($isAuthEnabled[1]);
					if($temp == "no"){
						$auth_enabled=0;					
					}
				}
				elseif(strpos($line, "proxy_user=") !== FALSE){
					$proxyUser = explode("=", $line);
					if($proxyUser === ""){
						$output[2] = "";
					}
					else{
						$output[2] = $proxyUser[1];
					}
				}
				elseif(strpos($line, "proxy_pwd=") !== FALSE){
					$proxyPass = explode("=", $line);
					if($proxyPass === ""){
						$output[3] = "";
					}
					else{
						$output[3] = $proxyPass[1];
					}
				}			
			}
		}
		if($proxy_enabled==0){
			$output = array();
		}	
		elseif($auth_enabled==0){					
			$output[2] = "";
			$output[3] = "";
		}
	}
	return $output;
}

/*********************************************************************************************************
* Function Name			: sendCGIMail
* Objective             : This function helps to send email
* Added By              : Sabin Cheruvattil
**********************************************************************************************************/
function sendCGIMail($path, $data)
{
	$ch = curl_init();

	curl_setopt($ch, CURLOPT_URL, $path);

	curl_setopt($ch, CURLOPT_POST, true);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

	/* For Proxy - Start*/	
	if(isset($_SESSION['isProxyEnabled']) && $_SESSION['isProxyEnabled'] === true) {
		# IP & Port
		if(isset($_SESSION['ipAddress']) && !empty($_SESSION['ipAddress'])) {
			$proxy = $_SESSION['ipAddress'] . ":" . $_SESSION['port'];
			curl_setopt($ch, CURLOPT_PROXY, $proxy);
		}
		
		# Username & Password
		if(isset($_SESSION['proxyUserName']) && !empty($_SESSION['proxyUserName'])) {
			$proxyauth = $_SESSION['proxyUserName'] . ":" . $_SESSION['proxyPassword'];
			curl_setopt($ch, CURLOPT_PROXYUSERPWD, $proxyauth);
		}
	}
	/* For Proxy - End*/

	$server_output = curl_exec($ch);
	$server_error  = curl_error($ch);
	curl_close ($ch);
	
	return array('output' => $server_output, 'error' => $server_error);
}

/*********************************************************************************************************
* Function Name			: hasNASUserShellPermission
* Objective             : This function helps to check NAS user shell permission
* Added By              : Sabin Cheruvattil
**********************************************************************************************************/
function hasNASUserShellPermission() {
	if(exec('whoami') == "root") {
		return TRUE;
	}
	
	$passwds	= file('/etc/passwd');
	$curNASUser = $_SESSION['nasUserName'];

	foreach($passwds as $passwd) {
		$accessPerms = explode(':', $passwd);
		
		if(trim($accessPerms[0]) == $curNASUser) {
			if(trim($accessPerms[6]) == '/sbin/nologin') {
				return FALSE;
			}
			
			break;
		}
	}
	
	return TRUE;
}
/****************************************************************************************************
* Function Name         : getASUSTORSharedFolders
* Objective             : Getting ASUSTOR shared folders list
* Added By              : Vijay Vinoth
******************************************************************************************************/
function getASUSTORSharedFolders()
{	
	$retry = 0;
	while($retry++ <= 2) {
		if(isset($_SESSION['sharedDirectoriesRaw']) && !empty($_SESSION['sharedDirectoriesRaw'])) {
			$sharedDirList = $_SESSION['sharedDirectoriesRaw'];
			$dir_list = json_decode($sharedDirList, true);
			
			# check whether we get a valid object or not
			if(count($dir_list) <= 0) {
				unset($_SESSION['sharedDirectoriesRaw']);
				continue;
			}			
			
			ksort($dir_list);
			break;
		} 
		else {
			unset($_SESSION['sharedDirectoriesRaw']);
			saveASUSTORSharedFolders();
		}
		sleep(3);
	}	
	return $dir_list;
}

/****************************************************************************************************
* Function Name         : saveASUSTORSharedFolders
* Objective             : Saving ASUSTOR shared folders list into text file
* Added By              : Vijay Vinoth
******************************************************************************************************/
function saveASUSTORSharedFolders()
{
	GLOBAL $appPath;
	$sharedDirList = '';
	
	if(file_exists(ASUSTOR_SHARE_CGI_PATH)){
		$shareURL      = getNasURL();
		
		if(!isset($_SESSION['CGI_SID'])) {
			header("Location:../index.php");
			exit;
		} 
		else 
			$sid = $_SESSION['CGI_SID'];
		
		$sharedDirURL = $shareURL.ASUSTOR_SHARED_DIR_CGI_PATH."?sid=$sid&path=share&showrecyclebin=true&showhome=true&act=file_list&onlydir=true";
		$sharedDirListArray = getCurlOutput($sharedDirURL);
		$arr = json_decode($sharedDirListArray);
		
		# Fall back logic. If SID is expired the response will be false. Regenerating SID	
		if(!$arr->success){		
			$str 		= $_SESSION['encryptedToken'].$_COOKIE['encryptedToken'];
			$phpPath    =  "$appPath/".CONFIG;
			$phpbinPath = getPhpPath();
			$command 	= "$phpbinPath $phpPath/token.php $str";
			$stOutput=shell_exec($command);			
			asustorNASlogin($_SESSION['nasUserName'],$stOutput);
			saveASUSTORSharedFolders();			
		}
		
		$sharedDirObject = $arr->data;
		$dir_list = array();		
		foreach($sharedDirObject as $dirList){		
			$dirname = $dirList->physical_path;	
			$type = $dirList->is_dir =='1'?"D":"F";
			$size = $dirList->is_dir =='1'?"--":$dirList->size;
			$dir_list[$dirname]["size"] 	= $size;
			$dir_list[$dirname]["datetime"] = date("Y/m/d h:i:s A",$dirList->modify_time_second);
			$dir_list[$dirname]["type"] 	= $type;
			$dir_list[$dirname]["filename"] = $dirList->filename;
		}
		ksort($dir_list);
	    $sharedDirList = json_encode($dir_list);
	
		if(empty($sharedDirList)) {
			unset($_SESSION['CGI_SID']);
			header("Location:../index.php");
			exit;
		}
	}	
	
	// If the shared folders are empty, fallback to manual listing.
	$shareArray = json_decode($sharedDirList);
	
	if (count($shareArray)<=0) {
		$list = array();		
		// Listing shared folders from DB path ( volume0 )
		$sharedDbDir = systemCmdExecution("ls -l ".ASUSTOR_VOL_SYSTEM_SHARED_PATH);
		$sharedList = explode("\n",trim($sharedDbDir));	
		
		// Listing shared folders from shared path
		$sharedDir = systemCmdExecution("ls -len  /share");		
		$sharedDirRes = parseLocalDirList($sharedDir,"/");
		
		$sharedDirRes['/home']['filename'] = "Home";
							
		#$_SESSION['shared_folders'] = array();
		$sharedDbDirHome = systemCmdExecution("ls -l ".ASUSTOR_VOL_SYSTEM_HOME_PATH);
		$sharedListHome = explode("\n",trim($sharedDbDirHome));	
		
		// comparing both array and updating real path insted of dir name
		foreach($sharedList as $nameVal)
		{
			$nameData = explode("-> ",trim($nameVal));
			$name = $nameData[1];
			if($name == '')
				continue;
			
			$dir_name = str_replace("/.@CNID",'',$name,$i);
			if($i < 1)
			{
				foreach($sharedListHome as $nameHomeVal)
				{
					$nameHomeData = explode("-> ",trim($nameHomeVal));
					$name = $nameHomeData[1];
					if($name == '')
						continue;
					
					$dir_name = str_replace("/.@CNID",'',$name,$i);
				}
			}
				
			
			$sharedDirName = end(explode('/', $dir_name));
			
			foreach ($sharedDirRes as $key => $value) {
				if($key == '/'.$sharedDirName){
					if($sharedDirName == 'home'){
						if($_SESSION['nasUserName'] =='root')
							$dir_name = $dir_name.'/admin';
						else
							$dir_name = $dir_name.'/'.$_SESSION['nasUserName'];
					}
						
					$sharedDirRes1[$dir_name] = $sharedDirRes[$key];
					unset($sharedDirRes[$key]);		
					#array_push($_SESSION['shared_folders'], ($dir_name . '/'));			
				}
			}
		}		
		
		$sharedDirList = json_encode($sharedDirRes1);
	}
	$_SESSION['sharedDirectoriesRaw'] = $sharedDirList; 
}

/****************************************************************************************************
* Function Name         : getNASUsersList
* Objective             : This helps to get the list of NAS users
* Added By              : Cheruvattil Sabin
******************************************************************************************************/
function getNASUsersList()
{
	$nasUserList = explode("\n", trim(`cut -d: -f1 /etc/passwd`));
	if(empty($nasUserList) || !count($nasUserList)) {
		if(!file_exists('/etc/passwd') || !is_readable('/etc/passwd')) {
			# this will be array by default
			return $nasUserList;
		}

		foreach(file('/etc/passwd') as $userParams) {
			$expUserParams = explode(':', $userParams);
			$nasUserList[] = $expUserParams[0];
		}
	}
	return $nasUserList;
}
/****************************************************************************************************
* Function Name         : getValidNASUser
* Objective             : This helps to get the list of NAS users
* Added By              : Cheruvattil Sabin
******************************************************************************************************/
function getValidNASUser($checkNASUserName)
{
	$nasUserList 		= getNASUsersList();
	
	$nasUserListLower	= $nasUserList;
	$nasUserListLower = convertStrToLower($nasUserListLower);

	if(count($nasUserList) > 0) {
		# If needle is a string, the comparison is done in a case-sensitive manner.
		$nasUserKey = array_search(strtolower($checkNASUserName), $nasUserListLower);

		if($nasUserKey !== FALSE) {
			return trim($nasUserList[$nasUserKey]);
		}
	}

	return FALSE;
}
/****************************************************************************************************
* Function Name         : convertStrToLower
* Objective             : Converting array values to lower case.
* Added By              : Senthil Pandian
******************************************************************************************************/
function convertStrToLower($convertedNASUserName)
{
	for($i=0;$i<count($convertedNASUserName);$i++){
		$convertedNASUserName[$i] = strtolower($convertedNASUserName[$i]);
	}
	return $convertedNASUserName;
}

/****************************************************************************************************
* Function Name         : isValidNASUser
* Objective             : This helps to validate the NAS user name | Case checking
* Added By              : Cheruvattil Sabin
******************************************************************************************************/
function isValidNASUser($checkNASUserName) {
	$nasUserList = getNASUsersList();
	if(count($nasUserList) > 0) {
		# If needle is a string/number, the comparison is done in a case-sensitive manner.
		if(!in_array($checkNASUserName, $nasUserList)) {
			return FALSE;
		}
	}
	
	return TRUE;
}

?>