
use constant false => 0;
use constant true => 1;

# doBackupOperation() return types. Type value taken from 11, because 1-10 may be used for other purpose.
use constant BACKUP_SUCCESS => 13;

use constant CHILD_PROCESS_STARTED => 1;
use constant CHILD_PROCESS_COMPLETED => 2;
use constant FILE_MAX_COUNT => 1000;
use constant FILE_COUNT_PROCESS_STARTED => 1;
use constant FILE_COUNT_PROCESS_COMPLETED => 2;
use constant MAX_RETRY => 5;

my $currentFilePath  = __FILE__;
require substr($currentFilePath, 0, rindex($currentFilePath, '/')) . '/fetchPath.pl';

# check last day for sechedule job
if("" ne $ARGV[0] and "lastDay" eq $ARGV[0] and !checkLastDayOfMonth()){
	exit;
}

my $backupUtfFile = "";
my $parStr = "";
my $BackupsetFileTmp = "";
my $current_source = "";
my $cancelStr = "";
my $rel_Data = "";
my $BackupFile = "";

my $idevsutilCommandLine = undef;
my $pid_OutputProcess = undef;
my $childProcessStatus = undef;

my $arch_flag = 0;
my $filecount = 0;
my $Backupfilecount = 0;
my $relative = 0;
my $filesOnlyFile_count = 0;
my %backupExcludeHash = 0;
my $exitStatus = 0;
my $jobDir = $jobrunningDir."/";
my $successFlag = false;
my $partialSuccessFlag = false;
my $BackupsetFile = "BackupsetFileForDisplay.txt";
my $whiteSpace = " ";
my $lineFeed = "\n";
my $assignmentOperator = "=";
my $periodOperator = ".";
my $pathSeparator = "/";
my $operationComplete = "100";
my $errorRedirection = "2>&1";
my $defaultEncryptionKey = "DEFAULT";
my $privateEncryptionKey = "PRIVATE";
my $evsTempDirPath = "./evs_temp";
my $ProgressDetailsFilePath = undef;
my $excludeFullPath = "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/ExcludeFullPath.txt";
my $excludePartialPath = "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/ExcludeListPartial.txt";
my $hidden = "Enabled";
my $filehandle = 'FILEH';
my $ArchiveJobPath = "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/Archive/";
my $BackupsetFile_relative = "BackupsetFile_relative.txt";
my $BackupsetFile_norelative = "BackupsetFile_no-relative.txt";
my $BackupsetFile_filesOnly = "BackupsetFile_onlyFiles.txt";
my $fileOnlySetName = $BackupsetFile_filesOnly;
my $failedFilesName = "failedfiles.txt";
my $info_file = "./info_file";
my $varManualTask = '\+ManualTask/';
my $outputFileName = "BACKUP";
my $exec_errorfile = "./exec_errorfile";
my $startPid = "StartPid.txt";
my $noRelIndex = 0;
$operationName = "Backup";
	
my @excludeParArray;
my @excludeArray;
my @quotemeta;
my @source;

# Index number for statusFileArray
use constant BACKUP_COUNT_FILES_INDEX => 0;
use constant SYNC_COUNT_FILES_INDEX => 1;
use constant FAILED_COUNT_FILES_INDEX => 2;
use constant FILE_COUNT_INDEX => 3;
use constant EXIT_FLAG_INDEX => 4;

# Process ID of all child process performing Backup - generating files, running evs cmd, and output parsing
my $pid_generate = undef;
my $pid = undef;
my $pid_OutputProcess = undef;

# Subroutine that processes SIGINT and SIGTERM signal received by the script during backup 
$SIG{INT} = \&process_term;
$SIG{TERM} = \&process_term;

# Trace Log Entry #
my $curFile = `basename '$currentFilePath'`;
chomp($curFile);

#Checking whether current job is ManualTask or Scheduled
if($jobDir !~ /$varManualTask/){	
	$taskType = "Scheduled";
}

#Read backup location
$backupLocation = readBackupLocation();

#create pid.txt if required.
createPid();
# pre cleanup for all intermediate files and folders.
`rm -rf $BackupsetFile_relative* $BackupsetFile_norelative* $BackupsetFile_filesOnly* $info_file $retryinfo ERROR $exec_errorfile $failedFilesName* $userCancel`;
#To get the Operation type as mirror/relative
getBackupOperationType();
checkBinaryExists();
createLogFiles($outputFileName);
#To load the partial and full Exclude array from Exclude file
loadExcludeArray();
writeLogHeader();

if($jobDir !~ /$varManualTask/){
	waitforArchiveJobtoFinish($ArchiveJobPath, $arch_flag);	
}

startBackup();

exit_cleanup();

#******************************************************************************************************************************************
# Subroutine Name         : startBackup.
# Objective               : Start backup operation by reading the content of info_file. The info_file is getting created and written by 
#							generateBackupsetFiles() subroutine. Check the retry condition and perform retry to backup, if needed. 
# Added By                : Pooja Havaldar
#******************************************************************************************************************************************
sub startBackup()
{
	traceLog("Starting Backup", __FILE__, __LINE__);

	# To udpate backupset files to sync with the root(/) directory.
	autoUpdateBackupset();

	#opening info file for generateBackupsetFiles function to write backup set information and for main process to read that information
	if(!open(FD_WRITE, ">", $info_file)){
		$errStr = "Could not open file $info_file to write, Reason:$!";
		return;
	}
	
	$pid_generate = fork();
	if(!defined $pid_generate){
		$errStr = "Unable to start generateBackupsetFiles operation. Reason:$!";
		return;
	}
	
	# this child process will create all backup set files with 1000-1000 files set
	if($pid_generate == 0){
		generateBackupsetFiles();
		exit 1;
	}
	
	close FD_WRITE;
	close BACK_FILE;
START:	
	if(!open(FD_READ, "<", $info_file)){
		$errStr = "Could not open file $info_file to read, Reason:$!";
		return;
	}
	
	#this loop will read info file and for every record it will execute doBackupOperation for backing up the data
	while (1){
		if(!-e $processIdFile){
			last;
		}
		
		$line = <FD_READ>;
		if($line eq ""){
			sleep(1);
			seek(FD_READ, 0, 1);		#to clear eof flag
			next;
		}

		if($line =~ m/^TOTALFILES/){
			@lineSplit = split(' ', $line,2);
			$totalFiles = $lineSplit[1];
			#calc total files
			last;
		}
		else{
			chomp($line);
			if(!doBackupOperation($line)){
				$exitStatus = 1;
				last;
			}
		}
	}
	close FD_READ;
	
	# empty linesStatusFile array to get latest content.
	undef @linesStatusFile;
	waitpid($pid_generate,0);
	
	
	if($totalFiles == 0){
		if(!open(FD_READ, "<", $info_file)){
			$errStr = "Could not open file $info_file to read, Reason:$!";
			return;
		}
		@filecontent = <FD_READ>;
		close FD_READ;
		for($i = $#filecontent; $i >= 0; $i--){
			if($filecontent[$i] =~ m/^TOTALFILES/){
				@split_totalFiles = split(' ',$filecontent[$#filecontent],2);
				$totalFiles = $split_totalFiles[1];
			}
		}
		#loop and traverse from last
		if($totalFiles == 0){
			traceLog("Unable to get total files count", __FILE__, __LINE__);
		}
	} 
	
	if(-s $retryinfo > 0 and $retrycount < MAX_RETRY and -e $processIdFile and $exitStatus == 0){
		$failedfiles_index = 0;
		if(!updateStatusFile($failedfiles_index)){
			return;
		}
		
		if(! rename $retryinfo, $info_file){
			traceLog("Unable to rename $retryinfo to $info_file, Reason: $!", __FILE__, __LINE__);
			return;
		}
		if(!open(FD_WRITE, ">>", $info_file)){
			$errStr = "Could not open file $info_file to write, Reason:$!";
			return;
		}
		
		print FD_WRITE "TOTALFILES $totalFiles";
		close FD_WRITE;
		
		# checking for last retry to instruct child process not to create any more retry info file
		if($retrycount == MAX_RETRY - 1){
			$failedfiles_index = -1;
			#tie my @filelines, 'Tie::File', "$StatusFilePath" or ($errStr ="Tie failed with $StatusFilePath : $!" and return);
			#$filelines[3] = "FILE_COUNT_INDEX = $failedfiles_index \n";
			#untie @filelines;
			if(!updateStatusFile($failedfiles_index)){
				return;
			}
		}
		
		`rm -rf $errorFilePath`; 
		$errorFilePath = $jobrunningDir."/ERROR";
		if(!-d $errorFilePath){
			if(! mkdir $errorFilePath){
				traceLog("Unable to create directory $errorFilePath, Reason: $!", __FILE__, __LINE__);
				return;
			}
			chmod $permissionVal, $errorFilePath;
		}
		updateRetryCount(FAILED_COUNT_FILES_INDEX);
		goto START;
	}	
}

#****************************************************************************************************
# Subroutine Name         : generateBackupsetFiles
# Objective               : Generating backupset file/files based on backup set content based on exclude 
#							and relative/no-relative and the required data is entered to info_file.
# Added By                : Pooja Havaldar
#*****************************************************************************************************/
sub generateBackupsetFiles()
{	
	if(!open BACKUPSETFILE_HANDLE, "<", $BackupsetFile){
		traceLog("Unable to open $BackupsetFile for enumerating, Reason: $!", __FILE__, __LINE__);
		goto LAST;
	}
	
	
	undef @BackupArrayInitial;
	@BackupArrayInitial = <BACKUPSETFILE_HANDLE>;
	close BACKUPSETFILE_HANDLE;
	
	undef @BackupArray ;
	for($i = 0; $i <= $#BackupArrayInitial; $i+=2){
		push(@BackupArray,$BackupArrayInitial[$i]);
	}
	
	$filesonlycount = 0;
	my $pos = 0;
	foreach $item(@BackupArray){
		if(!-e $processIdFile){
			last;
		}
		chomp($item);
		if($item =~ m/^$/){
			next;
		}
		elsif ($item eq "." or $item eq "..") {
			next;
		}
		elsif(-l $item or -p $item or -S $item or -b $item or -c $item or -t $item){
			traceLog("[".localtime()."] [EXCLUDED] [$item]. Reason: Not a regular file/folder.", __FILE__, __LINE__);
			next;
		}
		
		if(($item =~ m/\/\./) && ($hidden eq 'Disabled')){
			next;
		}
		
		$printItem = getPrintItem($item);
		if(!-e $item){
			print OUTFILE "[".localtime()."] [FAILED] [$printItem] Reason : $!.$lineFeed";
			next;
		}
		
		if(excludeCheck($item, $printItem)){
			next;
		}
		
		if(-d $item){
			if($relative == 0){
				$Backupfilecount = 0;
				$noRelIndex++;
				$BackupFile = $BackupsetFile_norelative."$noRelIndex";
				$filecount = 0;
				$pos = rindex ($item, '/');
				$source[$noRelIndex] = substr($item,0,$pos);
				if($source[$noRelIndex] eq ""){
					$source[$noRelIndex] = "/";
				}
				$current_source = $source[$noRelIndex];
				if(!open $filehandle, ">>", $BackupFile){
					traceLog("Unable to open $BackupFile to write, Reason: $!", __FILE__, __LINE__);
					goto LAST;
				}
			}
			if(!enumerate($item)){
				goto LAST;
			}	
			
			if($relative == 0 && $filecount>0){
				#autoflush FD_WRITE;
				select((select(FD_WRITE), $| = 1)[0]);
				print FD_WRITE "$BackupFile $rel_Data $current_source\n";
			}
		}	
		else{
			print BACK_FILE $printItem.$lineFeed;
			$current_source = getSource();
			
			if($relative == 0){
				$filesonlycount++;
				$filecount = $filesonlycount;
			}
			else{
				$filecount++;
			}
			
			$totalFiles++;
			if($filecount == FILE_MAX_COUNT){
				$filesonlycount = 0;
				if(!createBackupSetFiles1k("FILESONLY")){
					goto LAST;
				}
			}
		}
	}
	
	if($relative == 1 && $filecount > 0){
		print FD_WRITE "$BackupFile $rel_Data $current_source \n";
	}
	elsif($filesonlycount >0){
		$current_source = "/";
		print FD_WRITE "$fileOnlySetName $rel_Data $current_source\n";
	}
	
LAST:	
	print FD_WRITE "TOTALFILES $totalFiles";
	close FD_WRITE;
	if(tell(BACK_FILE) != -1){
		close BACK_FILE;
	}
}

#****************************************************************************************************
# Subroutine Name         : doBackupOperation.
# Objective               : This subroutine performs the actual task of backing up files. It creates 
#							a child process which executes the backup command. It also creates a process
#							which continuously monitors the temporary output file. At the end of backup, 
#							it inspects the temporary error file if present. It then deletes the temporary 
#							output file, temporary error file and the temporary directory created by 
#							idevsutil binary.             
# Modified By             : Deepak Chaurasia, Pooja Havaldar
#*****************************************************************************************************/
sub doBackupOperation()
{ 
	$parameters = $_[0];
	@parameter_list = split / /,$parameters,3;
	
	$backupUtfFile = getOperationFile($backupOp,$parameter_list[0] ,$parameter_list[1] ,$parameter_list[2]);
	
	# EVS command to execute for backup
	$idevsutilCommandLine = $idevsutilBinaryPath.$whiteSpace.$idevsutilArgument.$assignmentOperator."\"$backupUtfFile\"";
	
	$pid = fork();
	if(!defined $pid){
		$errStr = "Cannot fork() evs process, Reason:$! $lineFeed ";
		traceLog("$errStr", __FILE__, __LINE__);
		return 0;
	}
	
	if($pid == 0){	
		if(-e $processIdFile){
			exec($idevsutilCommandLine);
			if (open(ERRORFILE, ">> $exec_errorfile")){
				close ERRORFILE;
				chmod $permissionVal, $exec_errorfile;
			}
			else{
				traceLog("Unable to open file $exec_errorfile, Reason:$!", __FILE__, __LINE__);
			}
		}
		exit 1;
	}

	$pid_OutputProcess = fork();
	if(!defined $pid_OutputProcess){
		$errStr = "Cannot fork() child process for output parsing, Reason:$!";
		traceLog("$errStr", __FILE__, __LINE__);
		return 0;
	}
	
	if($pid_OutputProcess == 0){
		if(-e $processIdFile){
			# backup child process for output file parsing 
			$fileChildProcessPath = "$baseDir/$webDir/$APPDIR/.scripts/Backup_Script_ChildProcess_IDrive.pl"; 
			
			exec("$perlPath $fileChildProcessPath \"$outputFilePath\" \"$parameter_list[0]\" \"$parameter_list[1]\" \"$parameter_list[2]\"");
			if (open(ERRORFILE, ">> $exec_errorfile")){
				close ERRORFILE;
				chmod $permissionVal, $exec_errorfile;
			}
			else{
				traceLog("Unable to open file $exec_errorfile, Reason:$!", __FILE__, __LINE__);
			}
		}
		exit 1;
	}
	
	waitpid($pid,0);

	# update server address if cmd failed due to wrong evs server address
	checkErrorAndUpdateServerAddr($OutErrorFilePaths[1]);
	
	if(open OFH, ">>", $OutErrorFilePaths[0]){
		print OFH "CHILD_PROCESS_COMPLETED\n";
		close OFH;
	}
	else{
		$errStr = "\nFailed to open output file. Reason : $!.\n";
		return 0;
	}
	
	if(-e $exec_errorfile){
		$errStr = "\nUnable to proceed the backup operation. Reason : Couldn't execute evs command.\n";
	}
	
	waitpid($pid_OutputProcess, 0);
	if(-e $exec_errorfile){
		if($errStr eq ""){
			$errStr = "\nUnable to proceed the backup operation. Reason : Child process launch failed.\n";
		}
		return 0;
	}
	return BACKUP_SUCCESS;
}

#**********************************************************************************************************
# Subroutine Name         : enumerate
# Objective               : This function recursively enumerates a directly and enters data in the created 
#							backupset files.  		
# Added By                : Pooja Havaldar
#**********************************************************************************************************/
sub enumerate
{	
	my $item  = $_[0];
	my $retVal = 1;
	my $toPrint = "";
	if (substr($item, -1, 1) ne "/"){
		$item .= "/";
	}
	# get path after 1st level
	my $printItem = getPrintItem($item);

	if(opendir(DIR, $item)){
		foreach my $file (readdir(DIR)){
			if(!-e $processIdFile){
				last;
			}
			
			my $temp = $item.$file;
			chomp($temp);
			if ( $file eq "." or $file eq "..") {
				next;
			}
			elsif(-l $temp or -p $temp or -S $temp or -b $temp or -c $temp or -t $temp){
				traceLog("[".localtime()."] [EXCLUDED] [$temp]. Reason: Not a regular file/folder.", __FILE__, __LINE__);
				next;
			}
			
			if(($temp =~ m/\/\./) && ($hidden eq 'Disabled')){
				next;
			}
		
			if(!-e $temp){
				print OUTFILE "[".localtime()."] [FAILED] [$printItem$file]] Reason : $!.$lineFeed";
				next;
			}
			
			if(excludeCheck($temp, $printItem.$file)){
				next;
			}
			
			if(-d $temp){
				if(!enumerate($temp)){
					$retVal = 0;
					last;
				}		
			}
			else{
				if($relative == 0){
					$item_orig = $item;
					if($current_source ne "/"){
						$item_orig =~ s/$current_source//;
					}
					$temp = $item_orig.$file;
					print $filehandle $temp.$lineFeed;
				}
				else{
					$current_source = getSource();
					print BACK_FILE $printItem.$file.$lineFeed;
					$BackupsetFileTmp = $BackupsetFile_relative;
				}
				
				$totalFiles++;
				$filecount++;	
				
				if($filecount == FILE_MAX_COUNT){
					if(!createBackupSetFiles1k()){
						$retVal = 0;
						last;
					}
				}
			}
		}
		closedir(DIR);
	}
	else{
		traceLog("Unable to open directory $item, Reason: $!", __FILE__, __LINE__);
	}
	return $retVal;	
}

#************************************************************************************************************************************
# Subroutine Name         : excludeCheck
# Objective               : This function checks whether the argument passed is present in any exclude list - full/partial exclude 		
# Added By                : Pooja Havaldar
#**************************************************************************************************************************************/
sub excludeCheck()
{
	my $element = $_[0];
	my $parElement = $_[1];

	if(exists $backupExcludeHash{$element}){
		print OUTFILE "[".localtime()."] [EXCLUDED] [$parElement]. Reason: Full path excluded item.$lineFeed";
		return 1;
	}
	else{
		for(my $i = 0;$i <= $#excludeArray; $i++){
			$excludeArray_quotemeta = quotemeta($excludeArray[$i]);
			if($element =~ m/^$excludeArray_quotemeta/){
				print OUTFILE "[".localtime()."] [EXCLUDED] [$parElement]. Reason: Full path excluded item.$lineFeed";
				return 1;
			}
		}
	}	

	if($parStr ne ""){
		if($parElement =~ m/$parStr/) {
			print OUTFILE "[".localtime()."] [EXCLUDED] [$parElement]. Reason: Partial path excluded item.$lineFeed";
			return 1;
		}
	}
	return 0;
}

#****************************************************************************************************
# Subroutine Name         : createBackupSetFiles1k.
# Objective               : Construct the backup set file/files based on relative or no-relative.
# Added By                : Pooja Havaldar
#*****************************************************************************************************/
sub createBackupSetFiles1k
{
	my $filesOnly_flag = $_[0];
	$Backupfilecount++;
	if($relative == 0){
		if($filesOnly_flag eq "FILESONLY"){
			$filesOnlyFile_count++;
			print FD_WRITE "$fileOnlySetName $rel_Data $current_source\n";
			$fileOnlySetName = $BackupsetFile_filesOnly."_".$filesOnlyFile_count;
			close BACK_FILE;
			if(!open BACK_FILE, ">>", $fileOnlySetName){
				traceLog("Unable to open $fileOnlySetName to write, Reason: $!", __FILE__, __LINE__);
				return 0;
			}
		}
		else{
			print FD_WRITE "$BackupFile $rel_Data $current_source\n";
			$BackupFile = $BackupsetFile_norelative."$noRelIndex"."_$Backupfilecount";
			close $filehandle;
			if(!open $filehandle, ">", $BackupFile){
				traceLog("Unable to open file $BackupFile to write, Reason: $!", __FILE__, __LINE__);
				return 0;
			}	
		}
	}
	else{
		print FD_WRITE "$BackupFile $rel_Data $current_source\n";
		$BackupFile = $BackupsetFile_relative."_$Backupfilecount";
		close BACK_FILE;
		if(!open BACK_FILE, ">>", $BackupFile){
			traceLog("Unable to open file $BackupFile to write, Reason: $!", __FILE__, __LINE__);
			return 0;
		}
	}

	#autoflush FD_WRITE;
	select((select(FD_WRITE), $| = 1)[0]);
	$filecount = 0;
	return 1;
}

#****************************************************************************************************
# Subroutine Name         : process_term.
# Objective               : The signal handler invoked when SIGINT or SIGTERM signal is received by the script                 
# Added By				  : Arnab Gupta
#*****************************************************************************************************/
sub process_term()
{
  cancelSubRoutine();
}

#****************************************************************************************************
# Subroutine Name         : cancelSubRoutine
# Objective               : This subroutine gets call if user cancel the execution of script. It will do
#							all require cleanup before exiting.
# Added By				  : Arnab Gupta
#*****************************************************************************************************/
sub cancelSubRoutine()
{
	kill SIGTERM, $pid_OutputProcess;
	waitpid($pid_OutputProcess, 0);

	copyTempErrorFile();
	unlink($OutErrorFilePaths[0]);
	copyError2Trace(\$OutErrorFilePaths[1]);
	unlink($OutErrorFilePaths[1]);
	
	# if userCancel exists read from this file and update $errStr with the same content cancelSubRoutine(). 
	$errStr = readFromUserCancel();
	traceLog($errStr, __FILE__, __LINE__);
	exit_cleanup();
	exit 0;
}

#******************************************************************************************************************
# Subroutine Name         : removeBackupTempFiles.
# Objective               : This subroutine romoves all temporary files and folders. Also cleanup condition based files 
# 							and folder e.g  restore list etc.
# Added By                : Pooja Havaldar
#******************************************************************************************************************/
sub removeBackupTempFiles()
{
	#If backup success, then .RestoreList and Search list gets cleaned up
	if(0 < $successFiles){
		$rListPath = "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/.RestoreList";
		$remoteSearchPath = "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/Restore/.+searchList/*";
		$backupLocation =~ s/\'/\'\\''/g;
		
		$rem = "rm -rf \'$rListPath$backupLocation\' \'$remoteSearchPath\'";
		`$rem`;
		
	}

	# pre cleanup for all intermediate files and folders.
	`rm -rf $BackupsetFile_relative* $BackupsetFile_norelative* $BackupsetFile_filesOnly* $info_file $retryinfo \'$errorFilePath\' $exec_errorfile $failedFilesName*`;
}

#****************************************************************************************************
# Subroutine Name         : exit_cleanup.
# Objective               : This function will execute the major functions required at the time of exit 
# Added By                : Deepak Chaurasia
# Modified by	 		  : Pooja Havaldar 
#*****************************************************************************************************/
sub exit_cleanup()
{
	getParameterValueFromStatusFile(\$statusFileArray[BACKUP_COUNT_FILES_INDEX],\$successFiles);
	getParameterValueFromStatusFile(\$statusFileArray[SYNC_COUNT_FILES_INDEX],\$syncedFiles);
	getParameterValueFromStatusFile(\$statusFileArray[FAILED_COUNT_FILES_INDEX],\$failedFiles);
	getParameterValueFromStatusFile(\$statusFileArray[EXIT_FLAG_INDEX],\$exit_flag);
	
	if(-e $processIdFile){
		unlink($processIdFile);
		if("" ne $evsTempDirPath){
			`rm -rf $evsTempDirPath`;
		}
	}
	else {
		# In childprocess, if we exit due to some exit scenario, then this exit_flag will be true with error msg
		@exit = split("-",$exit_flag,2);
		$cancelFlag = true;
		if(!$exit[0]){
			$errStr = readFromUserCancel();
		}else{
			if($exit[1] ne ""){
				$errStr = $exit[1];
			}
		}	
		traceLog("$errStr", __FILE__, __LINE__);
	}

	writeOperationSummary($backupOp);
	unlink $errorFilePath;
	unlink $jobrunningDir."/error.txt";
	unlink($StatusFilePath);
	getOperationStatus();
	updateLogFileName();
	sendMail();	
	unlink($backupUtfFile);
	unlink($OutErrorFilePaths[0]);
	removeBackupTempFiles();
	close FHSPID;
	unlink($startPid);
	unlink($userCancel); 
}

#****************************************************************************************************
# Subroutine Name         : waitforArchiveJobtoFinish.
# Objective               : This subroutine will wait till Archive Job finishes
# Modified By             : Pooja Havaldar
#*****************************************************************************************************/
sub waitforArchiveJobtoFinish
{
	while(checkIfJobRunning($_[0])){
		
		if(!-e $processIdFile){
			traceLog("$processIdFile is not there", __FILE__, __LINE__);
			last;
		}
		
		if($_[1] == 0){
			print OUTFILE "Your scheduled job has been delayed, as Archive Cleanup is in progress.";
			traceLog("Your scheduled job has been delayed, as Archive Cleanup is in progress.", __FILE__, __LINE__);
			$_[1] = 1;
		}
		sleep 5;
	}	
}

#**************************************************************************************************************************
# Subroutine Name         : getBackupOperationType.
# Objective               : This subroutine reads the .relative.txt to get the type of Backup Operation - mirror/relative
#							and also open the intermediate files required for backup based on mirror/relative
# Added By                : Pooja Havaldar
#**************************************************************************************************************************/
sub getBackupOperationType
{
	# get the backup operation type mirror/relative
	if(open RFH, "<", "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/.relative.txt"){
		$rel_Data = <RFH>;
		close RFH;
		chomp($rel_Data);	
		if($rel_Data eq "--relative"){
			$relative = 1;
			$current_source = "/";
		}
		else{
			$relative = 0;
		}
	}
	else {
		$rel_Data = "--relative";
		$relative = 1;
		$current_source = "/";
	}
	
	#opening the backup set files based on mirror/relative
	if($relative == 1){
		$BackupFile =  $BackupsetFile_relative;
		if(!open BACK_FILE, ">>", $BackupsetFile_relative){
			traceLog("Unable to open file $BackupsetFile_relative to write, Reason: $!", __FILE__, __LINE__);
			exit 1;
		}
	}
	else {
		if(!open BACK_FILE, ">>", $BackupsetFile_filesOnly){
			traceLog("Unable to open file $BackupsetFile_filesOnly to write, Reason: $!", __FILE__, __LINE__);
			exit 1;
		}
		$BackupFile =  $BackupsetFile_norelative;
	}
}

#******************************************************************************************************************
# Subroutine Name         : writeLogHeader.
# Objective               : This subroutine constructs the log header message and returns the constructed message.
# Added By                : Pooja Havaldar
#******************************************************************************************************************/
sub writeLogHeader()
{
	my $temp = "";
	my $msg = "";
	my $logheader = "";
	if($relative == 1){
		$temp = "Mirror";
	}else{
		$temp = "Relative";
	}
	# require to open log file to show job in progress as well as to log exclude details
	if(open(OUTFILE, ">", $outputFilePath)){
		# As log file is opened so create logpid file as well
		if(open(FH, ">", $logPidPath)){ 
			print FH $outputFilePath;
			close FH;
			chmod $permissionVal, $logPidPath;
		}
		else {
			$errStr = "Unable to open file $logPidPath, Reason: $!";
			goto ERROR;
		}
		chmod $permissionVal,$outputFilePath;
	}
	else {
		$errStr = "Failed to create $outputFilePath, Reason: $!";
		goto ERROR;
	}
		
	# construct log header.
	$headerMsg = "Backup Start Time: $whiteSpace".localtime()."$lineFeed";
	$logheader = "$headerMsg$lineFeed"."User name: $username $lineFeed";
	
	$headerMsg .= getHeaderMsg($temp, $hidden);
	$headerMsg .= 	"Backup Location: $backupLocation$lineFeed";	
	
	$logheader .= getHeaderMsg($temp, $hidden);
	$logheader .= 	"Backup Location: $backupLocation$lineFeed$lineFeed";	
					
	# write log header.
	#autoflush OUTFILE;
	select((select(OUTFILE), $| = 1)[0]);
	print OUTFILE $logheader;
	
ERROR:
	if(tell(OUTFILE) != -1 and $errStr ne ""){
		traceLog($errStr, __FILE__, __LINE__);
		close OUTFILE;
		unlink($outputFilePath);
	}
	
	if($errStr ne ""){
		exit;
	}
}

#****************************************************************************************************
# Subroutine Name         : loadExcludeArray
# Objective               : To load the partial and full exclude array from Exclude file
# Added By                : Pooja Havaldar
#*****************************************************************************************************/
sub loadExcludeArray()
{
	# read full path exclude file and prepare a hash for it
	if(-e $excludeFullPath and 0 < -s $excludeFullPath) {
		if(!open(EXFH, $excludeFullPath)){
			traceLog("Unable to open full path exclude file $excludeFullPath, Reason: $!", __FILE__, __LINE__);
			exit;
		}
		
		@excludeArrayInitial = <EXFH>;
		close EXFH;
		chomp(@excludeArrayInitial);
		
		for (my $i=0; $i<=$#excludeArrayInitial; $i+=2){
			$backupExcludeHash{$excludeArrayInitial[$i]} = 1;
			$excludeArrayInitial[$i].="/";
			push(@excludeArray, $excludeArrayInitial[$i]);
		}		
	}
		
	@keys = keys %backupExcludeHash;
	@values = values %backupExcludeHash;
	
	#read partial path exclude file and prepare a partial match pattern 
	if(-e $excludePartialPath and 0 < -s $excludePartialPath and -e $processIdFile) {
		if(!open(EPF, $excludePartialPath)){
			traceLog("Unable to open partial path exclude file $excludePartialPath, Reason: $!", __FILE__, __LINE__);
			exit;
		}
		
		@excludeParArray = <EPF>;
		chomp(@excludeParArray);
		close EPF;
		my $tmp = $excludeParArray[0];
		if($tmp eq '\/.'){ 
			$hidden = "Disabled";
		}

		for(my $i = 0; $i <= $#excludeParArray; $i++){
			$quotemeta[$i] = quotemeta($excludeParArray[$i]);
		}
		
		$parStr = join("\n", @quotemeta);  
		chomp($parStr);
		$parStr =~ s/\n/|/g;
	}
}
