
use constant false => 0;
use constant true => 1;

# return types for doRestoreOperation function. Type value taken from 11, because 1-10 may be used for other purpose.
use constant RESTORE_SUCCESS => 11;
use constant REMOTE_SEARCH_FAIL => 12;
use constant REMOTE_SEARCH_CMD_ERROR => 13;
use constant REMOTE_SEARCH_OUTPUT_PARSE_FAIL => 14;
use constant REMOTE_SEARCH_SUCCESS => 15;
use constant CREATE_THOUSANDS_FILES_SET_SUCCESS => 16;
use constant REMOTE_SEARCH_THOUSANDS_FILES_SET_ERROR => 17;

use constant CHILD_PROCESS_STARTED => 1;
use constant CHILD_PROCESS_COMPLETED => 2;
use constant FILE_MAX_COUNT => 1000;
use constant FILE_COUNT_PROCESS_STARTED => 1;
use constant FILE_COUNT_PROCESS_COMPLETED => 2;
use constant FOLDER => folder;
use constant SEARCH => search;
use constant MAX_RETRY => 5;
use constant SPLIT_LIMIT_OUTPUT_PARSE => 6;
use constant SPLIT_LIMIT_INFO_LINE => 3;

my $currentFilePath  = __FILE__;
require substr($currentFilePath, 0, rindex($currentFilePath, '/')) . '/fetchPath.pl';

# check last day for sechedule job
if("" ne $ARGV[0] and "lastDay" eq $ARGV[0] and !checkLastDayOfMonth()){
	exit;
}

my $filesonly = 0;
my $RestoresetFile = "./RestoresetFile.txt";
my $restoreDisplayPath = "./RestoresetFileForDisplay.txt";
my $whiteSpace = " ";
my $lineFeed = "\n";
my $assignmentOperator = "=";
my $periodOperator = ".";
my $pathSeparator = "/";
my $operationComplete = "100";
my $errorRedirection = "2>&1";
my $idevsutilCommandLine = undef;
my $pid_OutputProcess = undef;
my $filesConsideredCount = undef;
my $retryRestoreCancel = false;
my $evsTempDirPath = "./evs_temp";
my $headerWrite = 0;
my @source;
my $startPid = "StartPid.txt";
my $filecount = 0;
my $exitStatus = 0;
my $Restorefilecount = 0;
my $relative = 0;
my $relativeType = "--relative";
my $noRelativeType = "--no-relative";
my $current_source = "";
my $filehandle = 'FILEH';
my $RestoresetFileTmp = "";
my $restore_errorfile = "RESTORE_ERRORFILE";
my $filesOnlyFile_count = 0;
my $RestoreFile = "";
my $restoreUtfFile = "";
my $RestoresetFile_norelative = "RestoresetFile_no-relative.txt";
my $RestoresetFile_filesOnly = "RestoresetFile_onlyFiles.txt";
my $RestoresetFile_relative = "RestoresetFile_relative.txt";
my $exec_errorfile = "./exec_errorfile";
my $fileOnlySetName = $RestoresetFile_filesOnly;
my $noRelIndex = 0;
$operationName = "Restore";

# If job in progress then don't run again
$jobDir = $jobrunningDir."/";
$varManualTask = '\+ManualTask/';

#Checking whether current job is ManualTask or Scheduled
if($jobDir !~ /$varManualTask/){
	$taskType = "Scheduled";
}

#create pid.txt if required.
createPid();
	
# String to be logged when user cancels job
my $cancelStr = "";

# Output File Name
my $outputFileName = "RESTORE";

# Indicates whether child process has started/completed          
my $childProcessStatus = undef;

# Index number for statusFileArray
use constant RESTORE_COUNT_FILES_INDEX => 0;
use constant SYNC_COUNT_FILES_INDEX => 1;
use constant FAILED_COUNT_FILES_INDEX => 2;
use constant FILE_COUNT_INDEX => 3;
use constant RESTORE_TERMINATION_INDEX => 4;

# Process ID of child process performing Restore
my $pid = undef;

# Count of files which could not be backed up/synced due to unspecified errors               
my $countOtherErrors = 0;

# Subroutine that processes SIGINT and SIGTERM signal received by the script during restore 
$SIG{INT} = \&process_term;
$SIG{TERM} = \&process_term;

# Trace Log Entry #
my $curFile = `basename '$currentFilePath'`;

#$retryinfo = "./retry_info_file";
$info_file = "./info_file";

# pre cleanup intermediate file and folder.
`rm -rf $RestoresetFile_relative* $RestoresetFile_norelative* $RestoresetFile_filesOnly* $info_file $retryinfo $exec_errorfile $userCancel failedfiles.txt* search ERROR`;

my $rel_Data = "";

# hard coded for now.
$rel_Data = "--no-relative";
#$rel_Data = "--relative";

if($rel_Data eq "--relative"){
	$relative = 1;
	$current_source = "/";
}

if($relative == 1){
	$RestoreFile =  $RestoresetFile_relative;
	if(!open RESTORE_FILE, ">>", $RestoresetFile_relative){
		traceLog("Unable to open file $RestoresetFile_relative to write, Reason: $!", __FILE__, __LINE__);
	}
}
else {
	if(!open RESTORE_FILE, ">>", $RestoresetFile_filesOnly){
		traceLog("Unable to open file $RestoresetFile_filesOnly to write, Reason: $!", __FILE__, __LINE__);
	}

	$RestoreFile =  $RestoresetFile_norelative;
}

my $hostName = getRestoreLocation();
$hostName =~ s/^\/RestoredData//;
my $sourceIdx = 0;
checkBinaryExists();
createLogFiles($outputFileName);
writeLogHeader();
startRestore();
exit_cleanup();

#****************************************************************************************************
# Subroutine Name         : startRestore.
# Objective               : Start restore operation by reading the content of info_file.
#							The info_file is getting created and written by generateRestoresetFiles() 
#							subroutine. Check the retry condition and perform retry to restore,
#							if needed. 
# Added By                : Avinash Kumar.
#*****************************************************************************************************/
sub startRestore()
{
	traceLog("Starting Restore", __FILE__, __LINE__);

	# opening the info file for transferring the backup set information from child process to main process
	open FD_WRITE, ">", $info_file or (traceLog("Unable to open file $info_file to write, Reason:$!", __FILE__, __LINE__) and die);

	$pidGen = fork();
	if(!defined $pidGen){
		$errStr = "Unable to start generate restoreset files process.\n";
		traceLog("Unable to fork() child process, Reason:$!", __FILE__, __LINE__);
		return;
	}
	
	if($pidGen == 0){
		generateRestoresetFiles();
		exit 0;
	}
	
	close FD_WRITE;
    close RESTORE_FILE;
START:
	open FD_READ, "<", $info_file or ($errStr = "Could not open file $info_file to read, Reason:$!" and traceLog($errStr, __FILE__, __LINE__));
	if($errStr ne ""){
		return;
	}
	
	while (1){
		if(!-e $processIdFile){
			last;
		}
		$line = <FD_READ>;
		if($line eq ""){
			sleep(1);
			seek(FD_READ, 0, 1);		#to clear eof flag
			next;
		}
		if($line =~ m/^TOTALFILES/){
			@lineSplit = split(' ', $line,2);
			$totalFiles = $lineSplit[1];
			#calc total files
			last;
		}
		else {
			chomp($line);
			if(!doRestoreOperation($line)){
				$exitStatus = 1;
				last;
			}
		}
	}
	close FD_READ;
	
	# empty linesStatusFile array to get latest content.
	undef @linesStatusFile;
	waitpid($pidGen,0);
	
	if($totalFiles == 0){
		open FD_READ, "<", $info_file or ($errStr = "Could not open file $info_file to read, Reason:$!" and traceLog($errStr, __FILE__, __LINE__));
		if($errStr ne ""){
			return;
		}
		@filecontent = <FD_READ>;
		close FD_READ;
		for($i = $#filecontent; $i >= 0; $i--){
			if($filecontent[$i] =~ m/^TOTALFILES/){
				@split_totalFiles = split(' ',$filecontent[$#filecontent],2);
				$totalFiles = $split_totalFiles[1];
			}
		}
		if($totalFiles == 0){
			traceLog("Unable to find total file count from info file.", __FILE__, __LINE__);
		}
	} 
	
	if(-s $retryinfo > 0 and $retrycount < MAX_RETRY and -e $processIdFile and $exitStatus == 0){
		$failedfiles_index = 0;
		if(!updateStatusFile($failedfiles_index)){
			return;
		}
		rename $retryinfo, $info_file;
		open FD_WRITE, ">>", $info_file or ($errStr = "Could not open file $info_file to read in retry case, Reason:$!" and traceLog($errStr, __FILE__, __LINE__));
		if($errStr ne ""){
			return;
		}
		print FD_WRITE "TOTALFILES $totalFiles";
		close FD_WRITE;
		
		if($retrycount == MAX_RETRY - 1){
			$failedfiles_index = -1;
			if(!updateStatusFile($failedfiles_index)){
				return;
			}
		}
		if("" ne $errorFilePath){
			`rm -rf $errorFilePath`;
		}
		mkdir $errorFilePath;
		chmod $permissionVal, $errorFilePath;
		updateRetryCount(FAILED_COUNT_FILES_INDEX);
		goto START;
	}	
}

#****************************************************************************************************
# Subroutine Name         : generateRestoresetFiles.
# Objective               : Generating restore set file/files based on user's restore set file
#							content. Check for file/folder type based on that, if entry element of 
#							restore set file is folder then execute search command to get the list of 
#							files associated with that folder. Count number for files considered for 
#							restore. Write the required data to info_file.
# Added By                : Avinash Kumar.
#*****************************************************************************************************/
sub generateRestoresetFiles()
{
	# Read restore set display file to get information about file or folder.
	if(!open RESTORESETFORDAISPLAY_HANDLE, "<", $restoreDisplayPath){
		$errStr = "\n Cannot open file $restoreDisplayPath, Reason: $!\n";
		traceLog($errStr, __FILE__, __LINE__);
		goto ERROR;
	}
	
	my @RestoreDispArray = <RESTORESETFORDAISPLAY_HANDLE>;
	close RESTORESETFORDAISPLAY_HANDLE;
	chomp(@RestoreDispArray);
		
	$filesonlycount = 0;
	my $idx = 0;
	
	# check for version restore.
	if($RestoreDispArray[0] =~ m/_IBVER+\d$/){
		print RESTORE_FILE $RestoreDispArray[0].$lineFeed;
		$filesonlycount++;
		$totalFiles++;
		goto LAST;
	}
	
	for ($idx = 1; $idx <= $#RestoreDispArray; $idx +=2 ){
		if(!-e $processIdFile){
			last;
		}
		if($RestoreDispArray[$idx - 1] =~ m/^$/ or $RestoreDispArray[$idx] =~ m/^$/){
			next;
		}
		
		# check from restore display file that it is folder.
		if($RestoreDispArray[$idx] eq FOLDER){
			if($relative == 0){
				$Restorefilecount = 0;
				$noRelIndex++;
				$RestoreFile = $RestoresetFile_norelative."$noRelIndex";
				$filecount = 0;
				$sourceIdx = rindex ($RestoreDispArray[$idx - 1], '/');
				$source[$noRelIndex] = substr($RestoreDispArray[$idx - 1], 0, $sourceIdx);
				if($source[$noRelIndex] eq ""){
					$source[$noRelIndex] = "/";
				}
				$current_source = $source[$noRelIndex];
				if(!open $filehandle, ">>", $RestoreFile){
					$errStr = "\nCannot open file $RestoreFile, Reason: $!.";
					traceLog($errStr, __FILE__, __LINE__);
					goto ERROR;
				}
			}
			my $resEnumerate = 0;
			$resEnumerate = enumerateRemote($RestoreDispArray[$idx - 1]);
			if(!$resEnumerate){
				goto ERROR;
			}
			elsif(REMOTE_SEARCH_CMD_ERROR == $resEnumerate){
				traceLog("Search failed for [".$RestoreDispArray[$idx - 1]."], Reason: syntax error", __FILE__, __LINE__);
				appendEnumerationError($RestoreDispArray[$idx - 1]);
			}
			elsif(REMOTE_SEARCH_FAIL == $resEnumerate){
				traceLog("Search failed for [".$RestoreDispArray[$idx - 1]."] ", __FILE__, __LINE__);
				appendEnumerationError($RestoreDispArray[$idx - 1]);
			}
			elsif(REMOTE_SEARCH_OUTPUT_PARSE_FAIL == $resEnumerate){
				traceLog("Search failed for [".$RestoreDispArray[$idx - 1]."], Reason: output parsing failed", __FILE__, __LINE__);
				appendEnumerationError($RestoreDispArray[$idx - 1]);
			}
			elsif(REMOTE_SEARCH_THOUSANDS_FILES_SET_ERROR == $resEnumerate){
				goto ERROR;
			}
						
			if($relative == 0 and $filecount > 0){
				#autoflush FD_WRITE;
				select((select(FD_WRITE), $| = 1)[0]);
				print FD_WRITE "$RestoreFile $relativeType $current_source\n";
			}
		}	
		else {
			print RESTORE_FILE $RestoreDispArray[$idx - 1].$lineFeed;
			$current_source = "/";
			
			if($relative == 0){
				$filesonlycount++;
				$filecount = $filesonlycount;
			}
			else {
				$filecount++;
			}
			$totalFiles++;
			if($filecount == FILE_MAX_COUNT){
				$filesonlycount = 0;
				if(!createRestoreSetFiles1k("FILESONLY")){
					goto ERROR;
				}
				
			}
		}
	}
	
LAST:
	if($relative == 1 and $filecount > 0){
		print FD_WRITE "$RestoreFile $relativeType $current_source \n";
	}
	elsif($filesonlycount >0){
		$current_source = "/";
		print FD_WRITE "$fileOnlySetName $noRelativeType $current_source\n";
	}
	
ERROR:
	print FD_WRITE "TOTALFILES $totalFiles";
	close FD_WRITE;
	if(tell(RESTORE_FILE) != -1){
		close RESTORE_FILE;
	}
}

#****************************************************************************************************
# Subroutine Name         : doRestoreOperation.
# Objective               : This subroutine performs the actual task of backing up files. It creates 
#							a child process which executes the restore command. It also creates a process
#							which continuously monitors the temporary output file. At the end of restore, 
#							it inspects the temporary error file if present. It then deletes the temporary 
#							output file, temporary error file and the temporary directory created by 
#							idevsutil binary.             
# Modified By             : Deepak Chaurasia, Avinash Kumar
#*****************************************************************************************************/
sub doRestoreOperation()
{ 
	$parameters = $_[0];
	@parameter_list = split / /,$parameters,SPLIT_LIMIT_INFO_LINE;
	$restoreUtfFile = getOperationFile($restoreOp,$parameter_list[0] ,$parameter_list[1] ,$parameter_list[2]);
	
	# EVS command to execute for restore
	$idevsutilCommandLine = $idevsutilBinaryPath.$whiteSpace.$idevsutilArgument.$assignmentOperator."\"$restoreUtfFile\"";
	
	$pid = fork();
	if(!defined $pid){
		$errStr = "Unable to start restore operation.";
		traceLog("Unable to fork() child process, Reason: $!", __FILE__, __LINE__);
		return 0;
	}
	
	if($pid == 0){	
		if(-e $processIdFile){
			exec($idevsutilCommandLine);
			if(open(EXECERRORFILE, ">> $exec_errorfile")){
				close EXECERRORFILE;
				chmod $permissionVal, $exec_errorfile;
			}
			else {
				traceLog("Unable to open file $exec_errorfile, Reason:$!", __FILE__, __LINE__);
			}
		}
		exit 0;
	}

	$pid_OutputProcess = fork();
	if(!defined $pid_OutputProcess){
		$errStr = "Unable to start child process to write log message.\n";
		traceLog("Unable to fork() child process, Reason:$!", __FILE__, __LINE__);
		return 0;
	}
	
	if($pid_OutputProcess == 0){
		if(-e $processIdFile){
			# restore child process for output file parsing 
			$fileChildProcessPath = "$baseDir/$webDir/$APPDIR/.scripts/Restore_Script_ChildProcess.pl"; 
			# fix for source which contains special characters like "", '' etc.
			my $quoted_source = quotemeta($parameter_list[2]);
			exec("$perlPath $fileChildProcessPath \"$outputFilePath\" \"$parameter_list[0]\" \"$parameter_list[1]\" $quoted_source \"$filesonly\"");
			if(open(EXECERRORFILE, ">> $exec_errorfile")){
				close EXECERRORFILE;
				chmod $permissionVal, $exec_errorfile;
			}
			else {
				traceLog("Unable to open file $exec_errorfile, Reason:$!", __FILE__, __LINE__);
			}
		}
		exit 0;
	}

	waitpid($pid,0);
	
	# update server address if cmd failed due to wrong evs server address
	checkErrorAndUpdateServerAddr($OutErrorFilePaths[1]);

	if(open OFH, ">>", $OutErrorFilePaths[0]){
		print OFH "CHILD_PROCESS_COMPLETED\n";
		close OFH;
	}
	else {
		traceLog("Unable to open file $OutErrorFilePaths[0], Reason: $!", __FILE__, __LINE__);
		return 0;
	}
		
	if(-e $exec_errorfile){
		$errStr = "\nUnable to proceed the restore operation. Reason : Couldn't execute evs command.\n";
	}
	
	waitpid($pid_OutputProcess, 0);
	
	if(-e $exec_errorfile){
		if($errStr eq ""){
			$errStr = "Unable to proceed the restore operation. Reason : Child process launch failed.\n";
		}
		return 0;
	}
	
	return RESTORE_SUCCESS;
}

#****************************************************************************************************
# Subroutine Name         : enumerateRemote.
# Objective               : Take remote folder as argument and execute serach on that. Create set of 1k 
#							files. Count number of files considered for restore.
# Added By                : Avinash Kumar.
#*****************************************************************************************************/
sub enumerateRemote
{	
	my $remoteFolder  = $_[0];
	my $searchForRestore = 1;
   
    # remove / from begining for folder to avoid // while creating utf8 file.
	$remoteFolder = substr($remoteFolder, 1);
	
	# final EVS command to execute
	if(!-d SEARCH){
		if(!mkdir(SEARCH, 0777)){
			$errStr = "Cannot create search directory, Reason: $!\n";
			return 0;
		}
	}
	
	# get utf8 file for EVS search command execute.
	my $searchUtfFile = getOperationFile($searchOp, $remoteFolder, $searchForRestore);
	$searchUtfFile = quotemeta($searchUtfFile);	
	
	if(!chdir(SEARCH)){
		$errStr = "Cannot change directory to search, Reason: $!\n";
		return 0;
	}
START:	
	$idevsutilCommandLine = $idevsutilBinaryPath.$whiteSpace.$idevsutilArgument.$assignmentOperator.$searchUtfFile;
	
	# EVS command execute
	$res = `$idevsutilCommandLine`;
	if("" ne $res){
		$errStr = "Search cmd syntax error found\n";
		return REMOTE_SEARCH_CMD_ERROR;
	}
	
	if(-e $processIdFile){
		return 0;
	}
	
	# update server address if cmd failed due to wrong evs server address
	if(checkErrorAndUpdateServerAddr($OutErrorFilePaths[1])){
		goto START;
	}
	
	if(-s $OutErrorFilePaths[1] > 0){
		$errStr = "Remote folder enumeration has failed.\n";
		return REMOTE_SEARCH_FAIL;
	}
	unlink($searchUtfFile);
	
	# parse serach output.
	open OUTFH, "<", $OutErrorFilePaths[0] or ($errStr = "Cannot open $OutErrorFilePaths[0] of search result for $remoteFolder, Reason: $!");
	if($errStr ne ""){
		traceLog($errStr, __FILE__, __LINE__);
		return REMOTE_SEARCH_OUTPUT_PARSE_FAIL;
	}
	if(!chdir("..")){
		$errStr = "Cannot change directory to job directory, Reason: $!\n";
		return 0;
	}
	
	while(<OUTFH>){
		if($filecount % 100 == 0 and !-e $processIdFile){
			last;
		}
		
		# split to get file name.
		@fileName = split(/\] \[/, $_, SPLIT_LIMIT_OUTPUT_PARSE);
		
		if($#fileName != 5){
			next;
		}
		# remove last character as ']'.
		chop($fileName[5]);
		chop($fileName[5]);
		$temp = $fileName[5];
		my $quoted_remoteFolder = quotemeta($_[0]);
		my $quoted_current_source = quotemeta($current_source);
		$quoted_remoteFolder = $quoted_remoteFolder."/";
		if($temp =~ m/^$quoted_remoteFolder/){
		if($relative == 0){
			if($current_source ne "/"){
					if($temp =~ s/^$quoted_current_source//){
						print $filehandle $temp.$lineFeed;
						$totalFiles++;
						$filecount++;
			}
				}
				else {
			print $filehandle $temp.$lineFeed;
					$totalFiles++;
					$filecount++;
				}
		}
		else {
			$current_source = "/";
			print RESTORE_FILE $temp.$lineFeed;
		$totalFiles++;
		$filecount++;	
				}
		}
		if($filecount == FILE_MAX_COUNT){
			if(!createRestoreSetFiles1k()){
				traceLog($errStr, __FILE__, __LINE__);
				return REMOTE_SEARCH_THOUSANDS_FILES_SET_ERROR;
			}
		}	
	}
	
	return REMOTE_SEARCH_SUCCESS;
}
#****************************************************************************************************
# Subroutine Name         : createRestoreSetFiles1k.
# Objective               : Construct the restore set file/files based on relative or no relative.
# Added By                : Pooja Havaldar
# Modified By			  : Avinash Kumar
#*****************************************************************************************************/
sub createRestoreSetFiles1k
{
	my $filesOnly_flag = $_[0];
	
	$Restorefilecount++;
	if($relative == 0){
		if($filesOnly_flag eq "FILESONLY"){
			$filesonly = 1;
			$filesOnlyFile_count++;
			print FD_WRITE "$fileOnlySetName $noRelativeType $current_source\n";
			$fileOnlySetName = $RestoresetFile_filesOnly."_".$filesOnlyFile_count;
			close RESTORE_FILE;
			if(!open RESTORE_FILE, ">>", $$fileOnlySetName){
				traceLog("Unable to open file $fileOnlySetName, Reason: $!", __FILE__, __LINE__);
				return 0;
			}
		}
		else {
			print FD_WRITE "$RestoreFile $relativeType $current_source\n";
			$RestoreFile = $RestoresetFile_norelative."$noRelIndex"."_$Restorefilecount";
			close $filehandle;
			if(!open $filehandle, ">", $RestoreFile){
				traceLog("Unable to open file $RestoreFile, Reason: $!", __FILE__, __LINE__);
				return 0;
			}	
		}
	}
	else {
		print FD_WRITE "$RestoreFile $relativeType $current_source\n";
		$RestoreFile = $RestoresetFile_relative."_$Restorefilecount";
		close RESTORE_FILE;
		if(!open RESTORE_FILE, ">>", $RestoreFile){
			traceLog("Unable to open file $RestoreFile, Reason: $!", __FILE__, __LINE__);
			return 0;
		}
	}

	#autoflush FD_WRITE;
	select((select(FD_WRITE), $| = 1)[0]);
	$filecount = 0;
	return CREATE_THOUSANDS_FILES_SET_SUCCESS;
}

#****************************************************************************************************
# Subroutine Name         : process_term.
# Objective               : The signal handler invoked when SIGINT or SIGTERM signal is received by the script                 
# Added By				  : Arnab Gupta
#*****************************************************************************************************/
sub process_term()
{
  $cancelFlag = true;		# need to discuss this assignment is with production code. keep or remove?
  cancelSubRoutine();
}

#****************************************************************************************************
# Subroutine Name         : cancelSubRoutine
# Objective               : This subroutine gets call if user cancel the execution of script. It will do
#							all require cleanup before exiting.
# Added By				  : Arnab Gupta
#*****************************************************************************************************/
sub cancelSubRoutine()
{
	kill SIGTERM, $pid_OutputProcess;
	waitpid($pid_OutputProcess, 0);
	copyTempErrorFile();
	unlink($OutErrorFilePaths[0]);
	copyError2Trace(\$OutErrorFilePaths[1],RESTORE_ERRORFILE);
	unlink($OutErrorFilePaths[1]);
	$errStr = readFromUserCancel();
	traceLog($errStr, __FILE__, __LINE__);
	exit_cleanup();
	exit 0;
}

#****************************************************************************************************
# Subroutine Name         : exit_cleanup.
# Objective               : This function will execute the major functions required at the time of exit 
# Added By                : Deepak Chaurasia
# Modified By			  : Avinash Kumar
#*****************************************************************************************************/
sub exit_cleanup()
{
	getParameterValueFromStatusFile(\$statusFileArray[RESTORE_COUNT_FILES_INDEX],\$successFiles);
	getParameterValueFromStatusFile(\$statusFileArray[SYNC_COUNT_FILES_INDEX],\$syncedFiles);
	getParameterValueFromStatusFile(\$statusFileArray[FAILED_COUNT_FILES_INDEX],\$failedFiles);
	getParameterValueFromStatusFile(\$statusFileArray[RESTORE_TERMINATION_INDEX],\$retryRestoreCancel);
	
	if(-e $processIdFile){
		unlink($processIdFile);
		if("" ne $evsTempDirPath){
			`rm -rf $evsTempDirPath`;
		}
	}
	else {
		# In childprocess, if we exit due to some exit scenario, then this exit_flag will be true with error msg
		@exit = split("-",$retryRestoreCancel,2);
		$cancelFlag = true;
		if(!$exit[0]){
			$errStr = readFromUserCancel();		
		}else{
			if($exit[1] ne ""){
				$errStr = $exit[1];
			}
		}
		traceLog($errStr, __FILE__, __LINE__);
	}
	
	writeOperationSummary($restoreOp);
	unlink $errorFilePath;
	unlink $jobrunningDir."/error.txt";
	unlink($StatusFilePath);
	getOperationStatus();
	updateLogFileName();
	sendMail();
	unlink($restoreUtfFile);
	unlink($OutErrorFilePaths[0]);
	removeRestoreTempFiles();
	close FHSPID;
	unlink($startPid);
	unlink($userCancel); 
}

#******************************************************************************************************************
# Subroutine Name         : writeLogHeader.
# Objective               : This subroutine construct log header message and return constructed message.
# Added By                : Avinash Kumar
#******************************************************************************************************************/
sub writeLogHeader()
{
	my $msg = "";
	# require to open log file to show job in progress as well as to log exclude details
	if(open(OUTFILE, ">", $outputFilePath)){
		# As log file is opened so create logpid file as well
		if(open(FH, ">", $logPidPath)){ 
			print FH $outputFilePath;
			close FH;
			chmod $permissionVal, $logPidPath;
		}
		else {
			$errStr = "Unable to open file $logPidPath, Reason:$!";
			goto ERROR;
		}
		chmod $permissionVal,$outputFilePath;
	}
	else {
		$errStr = "Failed to create $outputFilePath, Reason:$!";
		goto ERROR;
	}
		
	$headerMsg = "Restore Start Time: $whiteSpace".localtime()."$lineFeed";
	$logheader = "$headerMsg$lineFeed"."User name: $username $lineFeed";
	
	$headerMsg .= getHeaderMsg();
	$headerMsg .= 	"Restore Location: $hostName$lineFeed";	
	
	$logheader .= getHeaderMsg();
	$logheader .= 	"Restore Location: $hostName$lineFeed$lineFeed";	
					  
	# write log header.
	#autoflush OUTFILE;
	select((select(OUTFILE), $| = 1)[0]);
	print OUTFILE $logheader;
	
ERROR:
	if(tell(OUTFILE) != -1){
		close OUTFILE;
	}
}

#******************************************************************************************************************
# Subroutine Name         : removeRestoreTempFiles.
# Objective               : This subroutine romeve temporary files and folder. Also cleanup condition based files 
# 							and folder e.g local search etc.
# Added By                : Avinash Kumar
#******************************************************************************************************************/
sub removeRestoreTempFiles()
{
	# cleanup local search data.
	if($successFiles > 0){
		$localSearchPath = "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/Backup/.+searchList/*";
		`/bin/rm -rf $localSearchPath`;
	}

	# cleanup intermediate files and folder.
	`rm -rf $RestoresetFile_relative* $RestoresetFile_norelative* $RestoresetFile_filesOnly* $info_file $retryinfo $exec_errorfile \'$errorFilePath\' failedfiles.txt* search`;
}

#****************************************************************************************************
# Subroutine Name         : appendEnumerationError.
# Objective               : Enumeration of a folder from restore set file gets fail then write 
#							proper error message to log file.
# Added By                : Avinash Kumar.
#*****************************************************************************************************/
sub appendEnumerationError()
{
	my $searchErrMsg = "[".localtime()."]". "[".$_[0]."] Failed. Reason: Search has failed for the item.$lineFeed";
	# open log file to append serach failure message.
	if (!open(OUTFILE, ">> $outputFilePath")){ 
		traceLog("Unable to open file $outputFilePath, Reason:$!", __FILE__, __LINE__);
	}
	else {
		print OUTFILE $searchErrMsg;
		close OUTFILE
	}
}
