#!/bin/sh

appType="idrive";
EvsSynoArmBin="https://www.$appType.com/downloads/linux/download-options/synology_ARM.zip";
EvsSynoBin32_64="https://www.$appType.com/downloads/linux/download-options/synology_64bit.zip";
EvsSynoAlphine="https://www.$appType.com/downloads/linux/download-options/synology_Alphine.zip";
EvsSynoPpcQoriq="https://www.$appType.com/downloads/linux/download-options/synology_ppc_Qoriq.zip";
EvsSynoPpcQ853="https://www.$appType.com/downloads/linux/download-options/synology_Ppc_853x.zip";
EvsSynoPpcQ824="https://www.$appType.com/downloads/linux/download-options/synology_Ppc_824x.zip";
EvsBin32="https://www.$appType.com/downloads/linux/download-for-linux/idevsutil_linux.zip";
EvsBin64="https://www.$appType.com/downloads/linux/download-for-linux/idevsutil_linux64.zip";
EvsUnvBin="https://www.$appType.com/downloads/linux/download-for-linux/idevsutil_linux_universal.zip";
EvsQnapArmBin="https://www.$appType.com/downloads/linux/download-options/QNAP_ARM.zip";
EvsQnapBin64="https://www.$appType.com/downloads/linux/download-options/QNAP_Intel_Atom_64_bit.zip";
EvsQnapBin32="https://www.$appType.com/downloads/linux/download-options/QNAP_Intel_Atom_32_bit.zip";
EvsNetgArmBin="https://www.$appType.com/downloads/linux/download-options/Netgear_ARM.zip";
EvsNetgBin32_64="https://www.$appType.com/downloads/linux/download-options/Netgear_64bit.zip";
EvsSolaris32="https://www.$appType.com/downloads/linux/download-options/idevsutil_SOLARIS_x86.zip";

libLink="https://www.idrive.com/downloads/nas-servers/libpopt.so.0.0.0";

currentDir=$PWD;

#Get Machine type and get evs link sequence
machineType="$2";
if [ "$machineType" == "synology" ]; then
	# check machine type and create library link for evs if required
	unameOut=`uname -m`;

	if [ ! -e "/lib32/libpopt.so.0" ] && [ "$unameOut" == "x86_64" ]; then
		rm "/lib32/libpopt.so.0" 2>>/dev/null ;
		libFile=`echo "$libLink" | cut -d/ -f7`;
		pathSep="/";
		dum="${currentDir}${pathSep}${libFile}";
		rm "$dum" 2>>/dev/null;
		wget --no-check-certificate --no-proxy $libLink;
		cmd="ln -s $dum /lib32/libpopt.so.0";
		`$cmd`;
	fi
fi

MACHINE_ARCH=$(uname -m)

if [ "$machineType" == "synology" ] && [ `echo "${MACHINE_ARCH}" | grep -i 'armv'` ]; then
	arrayLinks="$EvsSynoArmBin $EvsSynoAlphine $EvsUnvBin $EvsQnapArmBin $EvsNetgArmBin";
elif [ "$machineType" == "synology" ] && [ "${MACHINE_ARCH}" == 'i686' ]; then
	arrayLinks="$EvsSynoBin32_64 $EvsBin32 $EvsUnvBin $EvsQnapBin32 $EvsNetgBin32_64 $EvsSolaris32";
elif [ "$machineType" == "synology" ] && [ "${MACHINE_ARCH}" == 'x86' ]; then
	arrayLinks="$EvsSynoBin32_64 $EvsBin32 $EvsUnvBin $EvsQnapBin32 $EvsNetgBin32_64 $EvsSolaris32";
elif [ "$machineType" == "synology" ] && [ "${MACHINE_ARCH}" == 'x86_64' ]; then
	arrayLinks="$EvsSynoBin32_64 $EvsBin32 $EvsBin64 $EvsUnvBin $EvsQnapBin64 $EvsNetgBin32_64 $EvsSolaris32";
elif [ "$machineType" == "synology" ]; then
	arrayLinks="$EvsSynoPpcQoriq $EvsSynoPpcQ853 $EvsSynoPpcQ824 $EvsUnvBin $EvsBin32 $EvsBin64 $EvsSynoArmBin $EvsSynoBin32_64 $EvsSynoAlphine $EvsQnapArmBin $EvsQnapBin64 $EvsNetgArmBin $EvsNetgBin32_64 $EvsSolaris32 $EvsQnapBin32";
elif [ "$machineType" == "qnap" ] && [ `echo "${MACHINE_ARCH}" | grep -i 'armv'` ]; then
	arrayLinks="$EvsQnapArmBin $EvsSynoArmBin $EvsSynoAlphine $EvsUnvBin $EvsNetgArmBin";
elif [ "$machineType" == "qnap" ] && [ "${MACHINE_ARCH}" == 'i686' ]; then
	arrayLinks="$EvsQnapBin32 $EvsSynoBin32_64 $EvsBin32 $EvsUnvBin $EvsNetgBin32_64 $EvsSolaris32";
elif [ "$machineType" == "qnap" ] && [ "${MACHINE_ARCH}" == 'x86' ]; then
	arrayLinks="$EvsQnapBin32 $EvsSynoBin32_64 $EvsBin32 $EvsUnvBin $EvsNetgBin32_64 $EvsSolaris32";
elif [ "$machineType" == "qnap" ] && [ "${MACHINE_ARCH}" == 'x86_64' ]; then
	arrayLinks="$EvsQnapBin64 $EvsQnapBin32 $EvsSynoBin32_64 $EvsBin32 $EvsBin64 $EvsUnvBin $EvsNetgBin32_64 $EvsSolaris32";
elif [ "$machineType" == "netgear" ] && [ `echo "${MACHINE_ARCH}" | grep -i 'armv'` ]; then
	arrayLinks="$EvsNetgArmBin $EvsSynoArmBin $EvsSynoAlphine $EvsUnvBin $EvsQnapArmBin";
elif [ "$machineType" == "netgear" ] && [ "${MACHINE_ARCH}" == 'x86_64' ]; then
	arrayLinks="$EvsNetgBin32_64 $EvsSynoBin32_64 $EvsBin32 $EvsBin64 $EvsUnvBin $EvsQnapBin64 $EvsQnapBin32 $EvsSolaris32";
elif [ "$machineType" == "netgear" ] && [ "${MACHINE_ARCH}" == 'i686' ]; then
	arrayLinks="$EvsNetgBin32_64 $EvsSynoBin32_64 $EvsBin32 $EvsBin64 $EvsUnvBin $EvsQnapBin64 $EvsQnapBin32 $EvsSolaris32";
elif [ "$machineType" == "netgear" ] && [ "${MACHINE_ARCH}" == 'x86' ]; then
	arrayLinks="$EvsNetgBin32_64 $EvsSynoBin32_64 $EvsBin32 $EvsBin64 $EvsUnvBin $EvsQnapBin64 $EvsQnapBin32 $EvsSolaris32";	
elif [ "$machineType" == "Asustor" ] && [ "${MACHINE_ARCH}" == 'i686' ]; then
	arrayLinks="$EvsBin32 $EvsSynoBin32_64 $EvsQnapBin32 $EvsNetgBin32_64 $EvsUnvBin $EvsSolaris32";
elif [ "$machineType" == "Asustor" ] && [ "${MACHINE_ARCH}" == 'x86' ]; then
	arrayLinks="$EvsBin32 $EvsSynoBin32_64 $EvsQnapBin32 $EvsNetgBin32_64 $EvsUnvBin $EvsSolaris32";
elif [ "$machineType" == "Asustor" ] && [ "${MACHINE_ARCH}" == 'x86_64' ]; then
	arrayLinks="$EvsBin64 $EvsBin32 $EvsSynoBin32_64 $EvsQnapBin64 $EvsNetgBin32_64 $EvsUnvBin $EvsSolaris32";
else
	arrayLinks="$EvsUnvBin $EvsBin32 $EvsBin64 $EvsSynoArmBin $EvsSynoBin32_64 $EvsSynoAlphine $EvsQnapArmBin $EvsQnapBin64 $EvsNetgArmBin $EvsNetgBin32_64 $EvsSolaris32 $EvsQnapBin32 $EvsSynoPpcQoriq $EvsSynoPpcQ853 $EvsSynoPpcQ824";
fi

#Remove temp files of previous execution
if [ -e "checkEvs.txt" ]; then
	rmItem=`cat "checkEvs.txt"`;
	if  [ $rmItem != "" ] && [ $rmItem != "/" ] && [ -e $rmItem ]; then
		rm -rf "$rmItem"
	fi
fi

#Get zip/unzip type
sevenUnzip=`which 7z`;
if [ $sevenUnzip ]; then
       unzip="$sevenUnzip x";
else        
       unzip=`which unzip`;        
fi    

workStat=0;
for i in $arrayLinks
do
	zipName=`echo $i | cut -d/ -f7`;
	echo "$zipName" > "checkEvs.txt";
        wget --no-check-certificate --no-proxy $i;
        $unzip "$zipName";
        rm "$zipName";
        zipFullPath=`echo "$zipName" | cut -d. -f1`;
		evsDir="$currentDir/$zipFullPath";
        evs="$evsDir/idevsutil";
		echo "$evsDir" > "checkEvs.txt";
        chmod 0777 "$evs";
        evsHelpRes=`"$evs" -h`;
        evsHelpResLen=${#evsHelpRes};

		rm "checkEvs.txt"
        if [ $evsHelpResLen -gt 50 ]; then
			cp $evs "$1";
			workStat=1;	
        fi
		
		if [ $evsDir != "/" ]; then
			rm -rf "$evsDir";
		fi 
		
		if [ $workStat -eq 1 ]; then
			break;
		fi
done

echo "";
echo "";
echo "Send the below details to support:";
echo "------------------------------------";
echo "Machine Details: $machineType";
if [ $workStat -eq 1 ]; then
	echo "Working zip is $zipName";
elif [ $workStat -eq 0 ]; then
	echo "Unable to find compatible evs binary";
fi	
