#---------------------------------------------------------------------------------------------#
#							AUTHOR      : Deepak Chaurasia
#							Modified By : Avinash Kumar(02-JUN-2016)
#---------------------------------------------------------------------------------------------#
 
#need to put pid.txt check to exit if cancel is done

my $currentFilePath  = __FILE__;
require substr($currentFilePath, 0, rindex($currentFilePath, '/')) . '/fetchPath.pl';
use constant NO_SUCH_FILE_OR_DIRECTORY => "No such file or directory";
my $archieve_dir = ".";
my $OutErrorFilePath = "$archieve_dir/error.txt";
my $OutOutputFilePath = "$archieve_dir/output.txt";
my $resultFilePath = "$archieve_dir/result.txt";
my $countFilePath = "$archieve_dir/count.txt";
my $pidFilePath = "$archieve_dir/pid.txt";
my $fileOpened = 0;
my $countItem = 0;
my $commLine = 4;
my $fieldsInProgress = 6;
my $totalFileCount = 0;
my $notExistCount = 0;
my $filename="";
my $count = 0;
my $excludePartialPath = "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/ExcludeListPartial.txt";
my $hidden = "Enabled";
my @countArr;

my $curFile = `basename '$currentFilePath'`;

if(-e $excludePartialPath and 0 < -s $excludePartialPath) {
	if(open(EPF, $excludePartialPath)){
		@excludeParArray = <EPF>;
		close EPF;
		my $tmp = $excludeParArray[0];
		chomp($tmp);
		
		if($tmp eq '\/.'){ 
			$hidden = "Disabled";
		}
	}
	else {
		traceLog("Unable to open partial path exclude file $excludePartialPath, Reason:$!", __FILE__, __LINE__);
	}
}

use constant LIMIT => 2*1024;
my $errNo = 0;

# parsing output for search and finding list of missing files in local
open OUTPUTFILE, "<", $OutOutputFilePath and $fileOpened = 1;
if($fileOpened == 0){
	$errNo = 2;
	goto ERROR;
}

# create a file with item count of missing files locally
if(!-f $countFilePath){
	if(open(COUNTFD, ">$countFilePath")){
		chmod $permissionVal, $countFilePath;
		print COUNTFD "0\n";
		print COUNTFD "$filename\n";
		print COUNTFD "$totalFileCount\n";
		print COUNTFD "$notExistCount\n";
		close(COUNTFD);
	}
	else {
		traceLog("Unable to open file $countFilePath, Reason:$!", __FILE__, __LINE__);
		$errNo = 2;
		goto ERROR;
	}
}

# create a file with list of files missing locally
if(!open(RESULT, ">> $resultFilePath")){
	traceLog("Unable to open file $resultFilePath, Reason:$!", __FILE__, __LINE__);
	$errNo = 3;
	goto ERROR;
}

chmod $permissionVal, $resultFilePath;

if(open(COUNT_FILE, "< $countFilePath")){
	@countArr = <COUNT_FILE>;
	close(COUNT_FILE);
	$totalFileCount += $countArr[2];
	$notExistCount += $countArr[3];
}
else {
	traceLog("Unable to open file $countFilePath, Reason: $!", __FILE__, __LINE__);
	return;
}

while(1){
	my $byteRead = read(OUTPUTFILE, $buffer, LIMIT);
	if($byteRead == 0){
		if(-s $OutErrorFilePath){
			last;
		}
		
		if(!-e $pidFilePath){
			traceLog("$pidFilePath does not exist.", __FILE__, __LINE__);
			$errNo = 4;
			goto ERROR;
		}
		
		sleep(1);
		seek(OUTPUTFILE, 0, 1);		#to clear eof flag
		next;
	}
	
	#need to check appending partial record to packet or to first line of packet
	if("" ne $lastLine){
		$buffer = $lastLine . $buffer;
	}
	
	my @resultList = split /\n/, $buffer;
	my $bufIndex = @resultList;
	
	if($buffer !~ /\n$/)       #keep last line of buffer only when it not ends with newline.
	{
		$lastLine = $resultList[$#resultList];
		$bufIndex -= 1;
	}
	else
	{
		$lastLine = "";
	}
	
	my $flag = 0;
	if(0 == $countItem)
	{
					
		if($resultList[$bufIndex-1] =~ m/Total files found/){
			$flag = 1;
		}
							
		if($commLine > 0){
			if($bufIndex > $commLine){
				splice(@resultList, 0, $commLine);
				$bufIndex -= $commLine;
				$commLine = 0;
			}				
			elsif($bufIndex > 0){
				splice(@resultList, 0, $bufIndex);
				$commLine -= $bufIndex;
				$bufIndex = 0;
			}
			
			if($commLine > 0){
				if(!$flag){
					next;
				} else {
					last;
				}
			}
		}
	}

				
	if(0 < $bufIndex and $resultList[$bufIndex-1] =~ m/Total files found/){
		$flag = 1;
		$bufIndex -= 1;
	}
	
	$totalCount += $bufIndex;
						
	my $backupLocation = readBackupLocation();
	my $tmpbackupLocation = $backupLocation."/";
	my $len = length $tmpbackupLocation;
	
	for(my $index = 0; $index < $bufIndex; $index++){
		$count++;
		if(!($count%10) && !-e $pidFilePath){
			traceLog("$pidFilePath file does not exist.", __FILE__, __LINE__);
			$errNo = 4;
			$count = 0;
			goto ERROR;
		}
		
		$filename = "";	
		my @fields = split("\\] \\[",$resultList[$index],$fieldsInProgress);
							
		$fields[2] =~ s/^\s+//;
		if($fields[2] ne "0"){
			# remove backup location from beginning in string
			$fields[5] = substr($fields[5], $len - 1);
			
			# remove last character ] from last field
			$fields[5] =~ s/.$//;
			
			# remove spaces from beginning from required fields
			$fields[5] =~ s/^\s+//;
			$filename = $fields[5];
			
			# check for file existance 
			if($filename ne ""){
				
				if(($filename =~ m/\/\./) && ($hidden eq 'Disabled')){
					next;
				}
				
				$totalFileCount++;
				# initialize $! with null before check of existance 
				$! = "";
				if(!-e $filename){
					# check if filename is starts with "/" and check for non admin permission
					if($filename =~ m/^\// and NO_SUCH_FILE_OR_DIRECTORY eq $!){
						$notExistCount++;
						print RESULT "$backupLocation$filename\n";
					}
					else {
						traceLog("Unable to consider for archive. item name: $filename and backupLocation: $backupLocation", __FILE__, __LINE__);
					}
				}
				$countArr[1] = "$filename\n";
				$countArr[2] = "$totalFileCount\n";
				$countArr[3] = "$notExistCount\n";
				updateCountFile();
			}
		}
	}
	
	if(1 == $flag){
		last;
	}
}

ERROR:
if($errNo == 0){
	$errNo = 1;
}
	
$countArr[0] = "$errNo";
updateCountFile();
close(RESULT);
close(OUTPUTFILE);

sub updateCountFile()
{
	if(!open(COUNT_FILE, "> $countFilePath")){
		traceLog("Unable to open $countFilePath, Reason: $!", __FILE__, __LINE__);
		return;
	}
	chomp($countArr[0]);
	
	if($countArr[0] !~ /\n$/){
		$countArr[0] .= "\n";
	}
	print COUNT_FILE @countArr;
	close(COUNT_FILE);
}
