
##########################################
#To include the current file in Trace Log#
##########################################
use constant limit => 10*1024;
use constant noOfLines => 100;
use constant  waitfor => 2;
use constant retry => 10;

my $currentFilePath  = __FILE__;
require substr($currentFilePath, 0, rindex($currentFilePath, '/')) . '/fetchPath.pl';
my $searchDir = `pwd`;
chomp($searchDir);
my $searchPath = $searchDir."/.search.txt";
my $pagePath = "";
# Trace Log Entry #
my $curFile = `basename '$currentFilePath'`;
chomp($curFile);

if(!open(FH, "< $searchPath")){
	traceLog("Unable to open $searchPath, Reason: $!", __FILE__, __LINE__);
	exit;
}

my @searchContent = <FH>;
close FH;

chomp($searchContent[0]);
#check if item is empty and die
if("" eq $searchContent[0])
{
	traceLog("Search cannot complete, Reason: search item not found.", __FILE__, __LINE__);
	exit;
}

my $lastLine  = "";
my $pageCount = 0;
my $flag = 0;
my $buffer = "";
my $byteRead = 0;
my $count  = 0;
my $countChk  = 0;
my $len = 0;
my $toSearchStr = "";
my $type = "";
my $size = "";
my $dateTime = "";
my $item = "";
my $patten = "";
my $isOpened = 0;
my $initialFlag = 0;
my $pidPath = $searchDir."/pid.txt";

$pid = fork();
if(!defined $pid){
	traceLog("Unable to fork() child process for saerch, Reason:$!", __FILE__, __LINE__);
	unlink($pidPath);
	die;
}
elsif($pid == 0){
	getSearchResult(\@searchContent,$searchDir);
	
	if(-e $searchDir."/output.txt"){
		if(!open(FH, ">> $searchDir/output.txt")){
			traceLog("Unable to open $searchDir/output.txt, Reason:$!", __FILE__, __LINE__);
			exit;
		}
		print FH "FIND_END\n";
		close FH;
		chmod 0777, $searchDir."/output.txt";
	}
	exit;
}
else {	
	while(! -s $searchDir."/output.txt"){		
		if(!($countChk % 10) and ! -e $pidPath){
			goto USER_CANCEL;
		}
		sleep(waitfor);
		$countChk++;
	}
	
	if(!open(OFH, "< $searchDir/output.txt")){
		traceLog("Unable to open $searchDir/output.txt Reason : $!", __FILE__, __LINE__);
		goto USER_CANCEL;
	}
	
	while(1){
		if(!($countChk % 10) and ! -e $pidPath){
			goto USER_CANCEL;
		}
		$countChk++;
		$byteRead = read(OFH, $buffer, limit);
		if($byteRead == 0){
			sleep(waitfor);
			seek(OFH, 0, 1);		#to clear eof flag
			next;
		}
	
		if("" ne $lastLine){			# need to check appending partial record to packet or to first line of packet
			$buffer = $lastLine . $buffer;
		}
		
		my @resultList = split /\n/, $buffer;
		my $resIndex = $#resultList;
		if($buffer !~ /\n$/){ 			#keep last line of buffer only when it does not ends with newline.
			$lastLine = $resultList[$resIndex];
			$resIndex -= 1;
		}
		else {
			$lastLine = "";
		}
		
		if("FIND_END" eq $resultList[$resIndex]){
			$flag = 1;
			$resIndex -= 1;
		}
		
		for(my $index = 0; $index <= $resIndex; $index++){
			if(0 == $isOpened){
				$pageCount++;
				close SFH;
				if(!open(SFH, "> $searchDir/page$pageCount")){
					traceLog("Unable to open $searchDir/page$pageCount, Reason: $!", __FILE__, __LINE__);
					goto USER_CANCEL;
				}
				chmod 0777, "$searchDir/page$pageCount";
				$isOpened = 1;
			}
			
			my $line = $resultList[$index];
			my $type = "";

			# Stat output:
			# 7 => total size of file, in bytes
			# 9 => last modify time in seconds since the epoch.
			@statRes = stat($line);
			if(0 < $#statRes) {
				if (-f $line) {
					$type = "F";
				}
				elsif (-d $line) {
					$type = "D";
				}
				
				if("" ne $type){
					($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($statRes[9]);
					$year += 1900;
					$mon += 1;
					$mday	= (($mday < 10)? "0" . $mday : $mday);
					$mon	= (($mon < 10)? "0" . $mon : $mon);
					$dateTime = "$year/$mon/$mday $hour:$min:$sec";
					$size = convertFileSize($statRes[7]);
					select((select(SFH), $| = 1)[0]);
					print SFH $line."\n".$size."\n".$dateTime."\n".$type."\n";
					
					$count++;
					if(0 == $count % noOfLines){
						$isOpened = 0;
					}
				}
			}
				
			if(!($countChk % 10) and ! -e $pidPath){
				goto USER_CANCEL;
			}
			$countChk++;
		}
		
		if(1 == $flag){
			last;
		}			
	}

USER_CANCEL:	
	close SFH;
	close OFH;
	
	if(-e $pidPath){
		unlink($pidPath);
	}
	else{
		$searchDir =~ s/'/'\\''/g;
		$searchDir = "'".$searchDir;
		`rm -rf $searchDir/page'*`;
		$searchDir =~ s/^'//;
		$searchDir =~ s/'\\''/'/g;
	}
	
	if(-e $searchPath){
		unlink($searchPath);
	}
	
	$searchDirOutput = $searchDir."/output.txt";
	if(-e $searchDirOutput){
		unlink($searchDirOutput);
	}
	
	$searchDirError = $searchDir."/error.txt";
	if(-e $searchDirError){
		unlink($searchDirError);
	}
}
