#To include the current file in Trace Log#
 
my $currentFilePath  = __FILE__;
require substr($currentFilePath, 0, rindex($currentFilePath, '/')) . '/fetchPath.pl';

my $curFile = `basename '$currentFilePath'`;
my @linestemp_file;
my @linesCrontabConfigFile; 
my $cronData = "";
my $cur_path = "";
my $hrSchedule = -1;
my $minSchedule = -1;
my $scheduled = 0;
use constant NOT_EXIST => 0;
use constant EXIST => 1;
use constant NOT_CHECKED => 2;
use constant NO_SUCH_FILE_OR_DIRECTORY => "No such file or directory";

$output = operations();

#****************************************************************************************************
# Subroutine Name         : operations
# Objective               : Makes call to the respective function depending on operation
# Added By                : 
#*****************************************************************************************************/
sub operations()
{
	my $temp_file = "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/temp_operationsfile.txt";
	my ($contentFile) = @ARGV;
	if (defined $contentFile) {
		$temp_file = $contentFile;
	}
	if(!open(TEMP_FILE, "< $temp_file")){
		traceLog("Unable to open file $temp_file, Reason:$!", __FILE__, __LINE__);
		exit;
	}
	@linestemp_file = <TEMP_FILE>;
	close TEMP_FILE;
	unlink $temp_file;

	chomp($linestemp_file[0]);
	
	if($linestemp_file[0] eq 'updateCrontabEntry'){
		updateCrontabEntry();
		configureAndCommitCron();
	}
	elsif($linestemp_file[0] eq 'removeCrontabEntry'){
		removeCrontabEntry();
		configureAndCommitCron();
	}
	elsif($linestemp_file[0] eq 'dirRemove'){
		dirRemove();
	}
	elsif($linestemp_file[0] eq 'addCrontabEntry'){
		addCrontabEntry();
		configureAndCommitCron();
	}
	elsif($linestemp_file[0] eq 'commandExecution'){
		commandExecution();
	}
	elsif($linestemp_file[0] eq 'accountUsage'){
		accountUsage();
	}
	elsif($linestemp_file[0] eq 'update_App'){
		print update_App();
	}
	elsif($linestemp_file[0] eq 'validate_filelist'){
		print isItemExists();
	}
	else {
		traceLog("Invalid operation type.", __FILE__, __LINE__);
	}
}

#****************************************************************************************************
# Subroutine Name         : extra_backup_restore_entry
# Objective               : Updates the crontab file with extra backup entry
# Added By                : Pooja Havaldar
# Modified By			  : Avinash Kumar
#*****************************************************************************************************/
sub extra_backup_restore_entry
{
	my @tempArr;  
	@tempArr = split(/$cronSeparator/,$linestemp_file[$_[0]]);
	$hrSchedule = $tempArr[1];
	$minSchedule = $tempArr[0];
	
	if("*" eq $tempArr[2] or 28 >= $tempArr[2]){
		return;
	}
	
		if("29" eq $tempArr[2]){
			$tempArr[2] = '28';
			$tempArr[3] = 2;
		}
		elsif("30" eq $tempArr[2]){
			$tempArr[2] = '28-29';
			$tempArr[3] = 2;
		}
		elsif("31" eq $tempArr[2]){
			$tempArr[2] = '28-30';
			$tempArr[3] = '2,4,6,9,11';
		}

		$cronData = join($cronSeparator, @tempArr);
		push @linesCrontabConfigFile, $cronData." lastDay".$lineFeed;
}

#****************************************************************************************************
# Subroutine Name         : extra_jobtermination_entry
# Objective               : Updates the crontab file with extra jobtermination entry
# Added By                : Pooja Havaldar
# Modified By			  : Avinash Kumar
#*****************************************************************************************************/
sub extra_jobtermination_entry
{
	my @tempArr;  
	@tempArr = split(/$cronSeparator/,$linestemp_file[$_[0]]);
	
	if("*" eq $tempArr[2] or 28 >= $tempArr[2]){
		return;
	}
	
	if($tempArr[1] > $hrSchedule) {					# when cut off hour is more than scheduler hour
		if("29" eq $tempArr[2]){
			$tempArr[2] = '28';
			$tempArr[3] = 2;
		}
		elsif("30" eq $tempArr[2]){
			$tempArr[2] = '28-29';
			$tempArr[3] = 2;
		}
		elsif("31" eq $tempArr[2]){
			$tempArr[2] = '28-30';
			$tempArr[3] = '2,4,6,9,11';
		}
	}
	elsif($tempArr[1] < $hrSchedule){				# when scheduler hour is more than cut off hour  
		if("29" eq $tempArr[2] or "30" eq $tempArr[2]){
			$tempArr[2] = '1';
			$tempArr[3] = 3;
		}
		elsif("31" eq $tempArr[2]){
			$tempArr[2] = '1';
			$tempArr[3] = '3,5,7,10,12';
		}
	}
	elsif($tempArr[1] == $hrSchedule){				# when scheduler hour is equal to cut off hour  
		if($tempArr[0] > $minSchedule){				# when cut off minutes are more than scheduler minutes
			if("29" eq $tempArr[2]){
				$tempArr[2] = '28';
				$tempArr[3] = 2;
			}
			elsif("30" eq $tempArr[2]){
				$tempArr[2] = '28-29';
				$tempArr[3] = 2;
			}
			elsif("31" eq $tempArr[2]){
				$tempArr[2] = '28-30';
				$tempArr[3] = '2,4,6,9,11';
			}
		}
		elsif($tempArr[0] <= $minSchedule){			# when cut off minutes are equal or less than scheduler minutes
			if("29" eq $tempArr[2] or "30" eq $tempArr[2]){
				$tempArr[2] = '1';
				$tempArr[3] = 3;
			}
			elsif("31" eq $tempArr[2]){
				$tempArr[2] = '1';
				$tempArr[3] = '3,5,7,10,12';
			}
		}
	}
	$cronData = join($cronSeparator, @tempArr);
	push @linesCrontabConfigFile, $cronData." lastDay".$lineFeed;
}
#****************************************************************************************************
# Subroutine Name         : updateCrontabEntry
# Objective               : Updates the crontab file with new entry
# Added By                : Pooja Havaldar
#*****************************************************************************************************/
sub updateCrontabEntry()
{	
	if(!open(CRONTAB_CONFIG_FILE, "+< $cronCat")){
		traceLog("Unable to open file $cronCat, Reason:$!", __FILE__, __LINE__);
		return;
	}
	
	@linesCrontabConfigFile = <CRONTAB_CONFIG_FILE>;
	chomp($linestemp_file[1]);
		
	@linesCrontabConfigFile = grep !/$linestemp_file[1];/, @linesCrontabConfigFile;
	my $len = $#linestemp_file;
	for(my $i = 2; $i<=$len; $i++){
		chomp($linestemp_file[$i]);
		if(($linestemp_file[$i] =~ m\Backup_Script_IDrive\) or ($linestemp_file[$i] =~ m\Restore_Script_IDrive\)){
			$scheduled = 1;
			extra_backup_restore_entry($i);
		}
		else {
			#To check for start immediately with cut off and pass parameter to Job Termination script
			if($linestemp_file[$i] ne "" and $linestemp_file[$i] =~ m\Job_Termination_Script\){
				$linestemp_file[$i] =~ s\Job_Termination_Script.pl\Job_Termination_Script.pl $scheduled\;
			}
			elsif($linestemp_file[$i] =~ m\Job_Termination_Script\){
				extra_jobtermination_entry($i);
			}
		}
		push @linesCrontabConfigFile, $linestemp_file[$i].$lineFeed;
	}
	seek(CRONTAB_CONFIG_FILE,0,SEEK_SET);
	print CRONTAB_CONFIG_FILE @linesCrontabConfigFile;		
	truncate(CRONTAB_CONFIG_FILE,tell(CRONTAB_CONFIG_FILE));		
	close CRONTAB_CONFIG_FILE;
}

#****************************************************************************************************
# Subroutine Name         : removeCrontabEntry
# Objective               : Removes the selected job entry from crontab file
# Added By                : 
#*****************************************************************************************************/
sub removeCrontabEntry()
{
	my @linesCrontabConfigFile = ();
	
	if(!open(CRONTAB_CONFIG_FILE, "< $cronCat")){
		traceLog("Unable to open file $cronCat, Reason:$!", __FILE__, __LINE__);
		return;
	}

	@linesCrontabConfigFile = <CRONTAB_CONFIG_FILE>;
	close CRONTAB_CONFIG_FILE;
	chomp($linestemp_file[1]);
	@linesCrontabConfigFile = grep !/$linestemp_file[1];/, @linesCrontabConfigFile;

	if(!open(CRONTAB_CONFIG_FILE, "> $cronCat")){
		traceLog("Unable to open file $cronCat, Reason:$!", __FILE__, __LINE__);
		return;
	}
	
	print CRONTAB_CONFIG_FILE @linesCrontabConfigFile;
	close CRONTAB_CONFIG_FILE;
	chomp($linestemp_file[2]);
	if("Delete" eq $linestemp_file[2]){
		`rm -rf $linestemp_file[1]`;		
	} 
}

#*************************************************************************************************************
# Subroutine Name         : dirRemove
# Objective               : Removes the files/folders under root level along with local and remote search path
# Added By                : 
#**************************************************************************************************************/
sub dirRemove()
{
	$rListPath = "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/.RestoreList/";
	$localSearchPath = "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/Backup/.+searchList/";
	$remoteSearchPath = "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/Restore/.+searchList/";

	`rm -rf $localSearchPath $remoteSearchPath $rListPath`;
	print 1;
}

#*************************************************************************************************************
# Subroutine Name         : addCrontabEntry
# Objective               : To enter the new job details in crontab file
# Added By                : 
#**************************************************************************************************************/
sub addCrontabEntry()
{
	my $cronData = "";

	@tempArr;  
	@tempArr = split(/$cronSeparator/,$linestemp_file[1]);
	
	if(!open(CRONTAB_CONFIG_FILE, ">> $cronCat")){
		traceLog("Unable to open $cronCat, Reason: $!", __FILE__, __LINE__);
		return;
	}

	print CRONTAB_CONFIG_FILE $linestemp_file[1].$lineFeed;

	if("*" ne $tempArr[2] and 29 <= $tempArr[2]){
		if("29" eq $tempArr[2] or "30" eq $tempArr[2]){
			$tempArr[2] = '28-29';
			$tempArr[3] = 2;
		}
		elsif("31" eq $tempArr[2]){
			$tempArr[2] = '28-30';
			$tempArr[3] = '2,4,6,9,11';
		}

		$tempArr[5] .= $cronSeparator.'[ "$(date +%d -d tomorrow)" = "01" ] &&';
		$cronData = join($cronSeparator, @tempArr);
		print CRONTAB_CONFIG_FILE $cronData.$lineFeed;
	}

	close CRONTAB_CONFIG_FILE;
}

#*************************************************************************************************************
# Subroutine Name         : commandExecution
# Objective               : 
# Added By                : 
#**************************************************************************************************************/
sub commandExecution()
{
	my $result = "";
		
	for(my $i =1; $i<=$#linestemp_file;$i++){
		$result = `$linestemp_file[$i]`;
	}
	print $result;
}

#*************************************************************************************************************
# Subroutine Name         : accountUsage
# Objective               : To calculate the quota usage 
# Added By                : 
#**************************************************************************************************************/
sub accountUsage()
{
	my $getQuotaUtfFile = getOperationFile($getQuotaOp);
	$idevsutilCommandLine = $idevsutilBinaryPath.$whiteSpace.$idevsutilArgument.$assignmentOperator."\"$getQuotaUtfFile\"".	$whiteSpace.$errorRedirection.$lineFeed;  	
	$commandOutput = `$idevsutilCommandLine`;
	
	unlink($getQuotaUtfFile);
	
	my $errorPath = $OutErrorFilePaths[1];
	###########################################
	# handling wrong server address error msg #
	##########################################
	$tempErrorFileSize = -s $errorPath;
	if($tempErrorFileSize > 0){
		my $errorPattern = "unauthorized user";
		my $errorPatternPwd = "password mismatch";
		
		if(!open(ERROR_PATH, "+< $errorPath")){
			traceLog("Unable to open $errorPath : $!", __FILE__, __LINE__);
			exit;
		}
		
		my @array = <ERROR_PATH>;
		close(ERROR_PATH);
		my $size =  $#array + 1;
		for(my $index = 0; $index < $size; $index++){
			if($array[$index] =~ m/$errorPattern/){
				updateServerAddr();
				last;
			}
			elsif($array[$index] =~ m/$errorPatternPwd/){
				traceLog("get-quota failed, Reason: $errorPatternPwd", __FILE__, __LINE__);
				last;
			}
		}
		copyError2Trace(\$errorPath);
		unlink($errorPath);
		exit;	
	}       
		  
	copyError2Trace(\$errorPath);
	unlink($errorPath);
	my $totalquota = undef;
	my $usedquota = undef;
	my $quotaUsed = undef;

	parseXMLOutput(\$commandOutput, \$totalquota, \"totalquota"); 
	parseXMLOutput(\$commandOutput, \$usedquota, \"usedquota");    
	parseXMLOutput(\$commandOutput, \$quotaUsed, \"quota_used");
	if($quotaUsed != ""){
		$quotaUsed =~ s/ Bytes//g;
	}

	if(defined $totalquota and $totalquota ne ""){
		if(defined $usedquota and $usedquota ne ""){
			if($totalquota != 0){
				my $percentQuotaUsed = ($usedquota/$totalquota) * 100;
				$percentQuotaUsed = int($percentQuotaUsed);
				$totalquota = $totalquota/(1024*1024*1024);
				$usedquota  = $usedquota/(1024*1024*1024);
				$usedquota  = sprintf("%.2f",$usedquota);
				print "$percentQuotaUsed $totalquota $usedquota";
			}
			else {
				print "0 0";
			}
		}
		else{
			print "0 0";
		}
	}
	elsif($quotaUsed != 0){ 
		$quotaUsed  = $quotaUsed/(1024*1024*1024);
		$quotaUsed  = sprintf("%.2f",$quotaUsed);			
		print "0 0 $quotaUsed";
	}
	else {
		print "0 0";
	}
}

#*************************************************************************************************************
# Subroutine Name         : update_App
# Objective               : To upgrade the present package 
# Added By                : Pooja Havaldar
#**************************************************************************************************************/
sub update_App()
{
	$status = "FAILURE";
	$proxySetting = "";
	$proxy = "";
	$cur_path = `pwd`;
	chomp($cur_path);
	$pckgPath = "";
	$cur_path =~ s/\/.config//;
	$wgetPath = $cur_path."/../../bin/wget";
	$packageName = $cur_path;
	$backupPackageName = $cur_path."_bak";
	
	$url = 'https://www.idrive.com/downloads/nas-servers/IDriveVaultCloudBackupApp.zip';

	if(!-e $wgetPath){
		traceLog("Failed to update, Reason: Wget is unavailable.", __FILE__, __LINE__);
		return $status;
	}
	getParameterValueFromAccountSettingsFile(\"PROXY",\$proxySetting);
	chomp($proxySetting);
	
	if($proxySetting ne ""){
		my $i = 0;
		$i = rindex($proxySetting,"@");
		
		if($i > 0){
			$user_pass = substr($proxySetting,0,$i);
			$ip_port = substr($proxySetting,$i+1);
		}
		
		if($ip_port ne ""){
			my $index = 0;
			$index = rindex($ip_port,":");
			if($index > 0){
				$ip = substr($ip_port,0,$index);
				$port = substr($ip_port,$index+1);
			}
		}
		
		if($user_pass ne "" and $user_pass ne ':'){
			my $pos = 0;
			$pos = rindex($user_pass,":");
			if($pos > 0){
				$user = substr($user_pass,0,$pos);
				$pass = substr($user_pass,$pos+1);
			}	
		}
		
		if($user eq "" and $ip ne "") {
			$proxy = 'http://'.$ip.':'.$port;
		} else {
			$proxy = 'http://'.$user.':'.$pass.'@'.$ip.':'.$port;
		}
	}
	
	if($proxy ne ""){
		$wgetCmd = "$wgetPath --no-check-certificate --tries=5 -e http_proxy = $proxy $url";
	}
	else{
		$wgetCmd = "$wgetPath --no-check-certificate $url";
	}
	
	$result  = system($wgetCmd);

	if($result != 0){
		traceLog("Failed to execute command : $wgetCmd", __FILE__, __LINE__);
	}else {
		`unzip IDriveVaultCloudBackupApp.zip  -d /tmp`;
	 	$tmp = "/tmp/IDriveVaultCloudBackupApp/IDrive";
		if(!-e $tmp){
			traceLog("File does not exist : $tmp", __FILE__, __LINE__);
		}
		else {
			$res = rename $packageName, $backupPackageName;
			if($res == 1){
				$res = 0;
				$res = rename $tmp, $packageName;
				if($res == 1){
					`rm -rf $backupPackageName`;
					chmod $permissionVal, $packageName;
					$status = "SUCCESS";
				}
				else {
					if(! rename($backupPackageName, $packageName)){
						traceLog("Unable to rename $backupPackageName to $packageName, Reason: $!", __FILE__, __LINE__);
					}
				}
			}
		}
	}
	$tmpzip = $cur_path."/IDriveVaultCloudBackupApp.zip";
	$tmp = "/tmp/IDriveVaultCloudBackupApp";
	`rm -rf $tmp $tmpzip`;
	return $status;
}

#*************************************************************************************************************
# Subroutine Name         : isItemExists.
# Objective               : Check existance of all items and return the result.
# Added By                : Avinash Kumar
#**************************************************************************************************************/
sub isItemExists()
{		
	my @contentsArr;
	my $idx = 0;
	my $j = 0;

	my $response = 'status[]=true';

	chomp($linestemp_file[1]);	
	my $jobPath = $linestemp_file[1];
	my $item = $linestemp_file[2]."/";
	# get contents of display file $jobPath.
	if(!open(DPHD, "< $jobPath")){
		traceLog("Unable to open $jobPath, Reason: $!", __FILE__, __LINE__);
		return $response;
	}
	@contentsArr = <DPHD>;
	close DPHD;
	
	for( $idx = 0, $j = 0; $idx <= $#contentsArr; $idx +=2, $j++ ){
		chomp($contentsArr[$idx]);
		chomp($contentsArr[$idx + 1]);
		my $temp = $contentsArr[$idx]."/";

		my $fileName = $contentsArr[$idx];
		$fileName =~ s/&/%26/g;
		$response .= ('&fileNames[]=' . $fileName);
		$response .= ('&fileTypes[]=' . $contentsArr[$idx + 1]);

		#$! = "";
		if(('//' eq $item) or ($temp =~ m/^$item/)){
			# initialize $! with null before check of existance 
			if(("folder" eq $contentsArr[$idx + 1] and -d $contentsArr[$idx]) or ("file" eq $contentsArr[$idx + 1] and -f $contentsArr[$idx])){
				$response .= ('&fileInfos[]=' . EXIST);
			}
			#elsif((("folder" eq $contentsArr[$idx + 1]) or ("file" eq $contentsArr[$idx + 1])) and !-e $contentsArr[$idx] and ($! ne NO_SUCH_FILE_OR_DIRECTORY)){
			#	$response .= ('&fileInfos[]=' . EXIST);
			#}
			else{
				$response .= ('&fileInfos[]=' . NOT_EXIST);
			}
		}
		else{
			$response .= ('&fileInfos[]=' . NOT_CHECKED);
		}
		
	}	
	return $response;
}
