#!/usr/bin/perl
# To find, is this DSM 6.

use constant APPDIR  => "IDrive";
use constant SERVICE  => "idriveIt";
use constant ASUSTOR => "Asustor";

my $appDir =  APPDIR;
my $servicePath = SERVICE;
my $machine_type = $ARGV[0];

sub isDSM6 {
	my $dsmVersionCmdOut = `cat /etc.defaults/VERSION`;
	my @dsmVersionArr    = split("\n", $dsmVersionCmdOut);
	chomp($dsmVersionArr[0]);

	if ($dsmVersionArr[0] =~ m/\"6\"$/) {
	    return 1;
	}
    return 0;
}

sub dsmVersion {
	my $dsmVersionCmdOut = `cat /etc.defaults/VERSION | grep "majorversion" | cut -d '"' -f 2`;
	my @dsmVersionArr    = split("\n", $dsmVersionCmdOut);
	chomp($dsmVersionArr[0]);
	return $dsmVersionArr[0];
}

# To get the php conf.d path
sub getPHPConfdPath {
	my $isDSM6 = shift;
	my @phpFpmConfPath = ();
	my $psPath = "ps -wwwww";

	if($isDSM6 or $machine_type eq ASUSTOR){
	    $psPath = "ps -elf";
	}

	my $phpFpmPath    = `$psPath | grep 'php-fpm' | grep 'master process'`;
	
	my @match = $phpFpmPath =~ /\/php(\d+)\//g;
	my %hash  = map { 'php' . $_ => 1 } @match;
	@match = keys %hash;
	my @phpNames = ('php');
	if (@match) {
		@phpNames = @match;
	}
	if (grep $_ eq 'php', @phpNames) {
		#Nothing
	} else {
		push @phpNames, 'php';
	}
	
	foreach my $phpName (@phpNames) {
		my $pathToPhpBinary = `which $phpName`;
		chomp($pathToPhpBinary);
		
		if ($pathToPhpBinary ne '') {
			my $phpIniInfo = `$pathToPhpBinary --ini`;
			my @output  = split(/\n/, $phpIniInfo);
			foreach my $value (@output) {
				if ($value =~ /^Scan for additional .ini files in:/) {
					$value          =~ s/Scan for additional .ini files in://;
					$value          =~ s/^\s+//;
					push @phpFpmConfPath, $value;
					break;
				}
			}
		}
	}
	return (\@phpFpmConfPath, \@phpNames);
}

# Restart php-fpm & httpd servers.
sub doCleanup {
	my $isDSM6 = shift;
	
	# This is still a guess, we will try to find the actual path to it.
	my ($phpFpmConfPath, $phpversions)   = getPHPConfdPath($isDSM6);
	my @phpFpmConfPath = @$phpFpmConfPath;
	my @phpversions = @$phpversions;
	
	foreach my $additionalConfPath (@phpFpmConfPath) {
		my $orgIni = '';
		my $newIni = '';
		if($machine_type eq ASUSTOR){
			$orgIni = "/usr/local/AppCentral/".$appDir."/www/.scripts/".$appDir.".ini";
			$newIni = "$additionalConfPath/".$appDir.".ini";
		}
		else{
			$orgIni = "/var/packages/".$appDir."/target/".$appDir.".ini";
			$newIni = "$additionalConfPath/".$appDir.".ini";
		}
		
		unlink $newIni;
		`ln -s $orgIni $newIni`;
	}
	
	if($machine_type eq ASUSTOR){
		`/usr/builtin/sbin/apache2 -k restart`;
	}
	elsif ($isDSM6) {
		foreach my $phpversion (@phpversions) {
			if ($phpversion eq "php") {
				 `initctl restart $phpversion-fpm`;
			}
			else {
				`initctl restart pkg-$phpversion-fpm`;
			}
		}
		`/usr/sbin/initctl restart pkg-apache22`;
	}
	else {
		`/sbin/initctl stop httpd-user`;
		`/sbin/initctl start httpd-user`;
	}
}

#Conflict service path changes
if($ARGV[1] eq ""){
START:
	#my $machine_type = $ARGV[0];
	my $path = "";

	if($machine_type eq "synology"){
		$path = "/var/services/web/$servicePath/";
	}
	elsif($machine_type eq "qnap"){
		$path = "/share/Web/$servicePath/";
	}
	elsif($machine_type eq "netgear"){
		$path = "/apps/idrive/web/$servicePath/";
	}
	elsif($machine_type eq "twotier"){
		$path = "/usr/local/www/$servicePath/";
	}
	elsif($machine_type eq ASUSTOR){
		doCleanup(0);
		$binaryPath = "/usr/local/www/IDrive";
		#Checking the validity of idevsutil binary
		my $lines = `$binaryPath/idevsutil_IDrive -h 2>>/dev/null | wc -l`;
		if($lines < 50){
			system("sh $binaryPath/.scripts/binaryChk.sh $binaryPath/idevsutil_IDrive Asustor");
		}
		exit;
	}
	

	my $find_command_restorelocation = "find $path -name restore_location.txt";
	my @result1 = `$find_command_restorelocation`;
	chomp(@result1);

	my $find_command_excludeList = "find $path -name ExcludeList.txt";
	my @result2 = `$find_command_excludeList`;
	chomp(@result2);

	my @filearray;
	my @split_line;
	my @split;
	my $fileline = "";
	
	#Updating restore location file for all users for new service path
	for (my $i =0; $i<=$#result1; $i++){
		$result1[$i] =~ s/^\s+|\s+$//g;
		if(!open(FH, "< $result1[$i]")){
			exit;
		}
		
		$fileline = <FH>;	
		close FH;
		chomp($fileline);
		$fileline =~ s/^\s+|\s+$//g;
		
		if($fileline =~ m/\/idrive\/user_profile/){
			$fileline =~ s/\/idrive\/user_profile/\/$servicePath\/user_profile/;
			if(!open(FH, "> $result1[$i]")){
				exit;
			}
			print FH $fileline;	
			close FH;
		}
		
		if(!-e $fileline){
			unlink($result1[$i]);
		}
	}

	if($machine_type ne 'netgear'){
		for (my $i =0; $i <= $#result2; $i++){
			$result2[$i] =~ s/^\s+|\s+$//g;
			
			if(!open(RESULT, "+< $result2[$i]")){
				exit;
			}
			
			my @filearray = <RESULT>;
			chomp($filearray[0]);
			$filearray[0] =~ s/^\s+|\s+$//g;
			
			@split_line = split('/', $filearray[0]);
			if($split_line[$#split_line] eq 'idrive'){
				$filearray[0] =~ s/\/idrive/\/$servicePath/;
			}
			seek(RESULT, 0, 0);
			print RESULT @filearray;
			close(RESULT);
		}
	}
}
else {
	# check existance of below files and delte it if exist
	my $filename1 = "/etc/php/fpm.d/".$appDir.".conf";
	my $filename2 = "/etc/httpd/sites-enabled-user/".$appDir.".conf";
	my $sysFile1 = "/usr/local".$filename1;
	my $sysFile2 = "/usr/local".$filename2;
	
	if(-e $sysFile1){
		unlink($sysFile1);
	}
	
	if(-e $sysFile2){
		unlink($sysFile2);
	}

	# check machine type and create library link for evs if required
	$unameOut = `uname -m`;
	chomp($unameOut);
	my $orgLib = "/var/services/web/$appDir/.config/libpopt.so.0.0.0";
	if("x86_64" eq $unameOut and !-e "/lib32/libpopt.so.0"){
		`ln -s $orgLib /lib32/libpopt.so.0`;
	}
	elsif(!-e "/lib/libpopt.so.0"){
		`ln -s $orgLib /lib/libpopt.so.0`;
	}
		
	my $dsmVersion6 = isDSM6();
	my $dsmVersion = dsmVersion();

	if($dsmVersion>=5){
		my $update_file = "/etc/httpd/conf/extra/mod_fastcgi.conf";
		my $file = "/etc/init/php-fpm.conf"; 
		if(!-e $file or !-e $update_file or !-s $update_file){
			if($ARGV[2] ne ""){
				goto START;
			}
			doCleanup($dsmVersion6);
			exit;
		}
		
		# Updating /etc/init/php-fpm.conf file 
		my $pattern = "exec /usr/bin/php-fpm --nodaemonize --pid /run/php-fpm/php-fpm.pid";
		my $quotemeta_pattern = quotemeta($pattern);
		$quotemeta_pattern =~ s/\//\\\//g;
		
		if(!open(FH, "< $file")){
			doCleanup($dsmVersion6);
			exit;
		}
		my @file_array = <FH>;
		close FH;
		
		my $new_line = "exec /usr/bin/php-fpm --nodaemonize --allow-to-run-as-root --pid /run/php-fpm/php-fpm.pid";
		my $quotemeta_newline = quotemeta($new_line);
		$quotemeta_newline =~ s/\//\\\//g;
		
		@res1_pattern = grep (/$pattern/, @file_array);

		if($#res1_pattern >= 0){
			my $sed = "sed -i s/$quotemeta_pattern/$quotemeta_newline/ $file";
			`$sed`;
		}
		else{
			my @res2_new_line = grep (/$new_line/,@file_array);
			if($#res2_new_line < 0){
				if(open(FH, ">> $file")){
					print FH "\n".$new_line."\n";
					close FH;
				}
			}
		}
		
		# Creating /etc/php/fpm.d/IDrive.conf file if it does not exist
		my $file_creation1 = 'cat > /etc/php/fpm.d/'.$appDir.'.conf <<EOF
		['.$appDir.']
		user = root
		group = root
		
		listen = /run/php-fpm/'.$appDir.'.sock
		listen.owner = http
		listen.group = http
		listen.mode = 0660
		pm = dynamic
		pm.max_children = 5
		pm.start_servers = 2
		pm.min_spare_servers = 1
		pm.max_spare_servers = 3
		pm.process_idle_timeout = 900s
		request_terminate_timeout = 900	
		env[HOSTNAME] = "IDrive Synology"
		env[PATH] = ' . $ENV{'PATH'} . '
		php_flag[display_errors] = off
		php_admin_value[error_log] = /var/log/SNSD-Taeyeon-YoonA.log
		php_admin_flag[log_errors] = on';   
			
		if(-e $filename1){
			unlink($filename1);
		}
		else {
			@pathArr1 = split('\/', $filename1);
			pop(@pathArr1);
			shift(@pathArr1);
			if(! -d "/$pathArr1[0]/$pathArr1[1]"){
				if(! mkdir("/$pathArr1[0]/$pathArr1[1]", 0755)){
					doCleanup($dsmVersion6);
					exit;
				}
			}
			if(! -d "/$pathArr1[0]/$pathArr1[1]/$pathArr1[2]"){
				if(! mkdir("/$pathArr1[0]1/$pathArr1[1]/$pathArr1[2]", 0755)){
					doCleanup($dsmVersion6);
					exit;
				}
			}
		}
		
		`$file_creation1`;
		
		
		# Creating /etc/httpd/sites-enabled-user/IDrive.conf if it does not exist
		my $file_creation2 = 'cat > /etc/httpd/sites-enabled-user/'.$appDir.' <<EOF
		<Directory "/var/services/web/'.$appDir.'">
		AddHandler php5-fastcgi-'.$appDir.' .php .php3 .php4 .php5 .phtml
		Action php5-fastcgi-'.$appDir.' /php-fpm-'.$appDir.'-handler.fcgi
		</Directory>';
		
		if(-e $filename2){
			unlink($filename2);
		}
		else {
			@pathArr2 = split('\/', $filename2);
			pop(@pathArr2);
			shift(@pathArr2);
			if(! -d "/$pathArr2[0]/$pathArr2[1]"){
				if(! mkdir("/$pathArr2[0]/$pathArr2[1]", 0755)){
					doCleanup($dsmVersion6);
					exit;
				}
			}
			if(! -d "/$pathArr2[0]/$pathArr2[1]/$pathArr2[2]"){
				if(! mkdir("/$pathArr2[0]/$pathArr2[1]/$pathArr2[2]", 0755)){
					doCleanup($dsmVersion6);
					exit;
				}
			}
		}
		
		`$file_creation2`;
		
		# Updating /etc/httpd/conf/extra/mod_fastcgi.conf file
		my $extra_lines1 = "FastCgiExternalServer /php-fpm-".$appDir."-handler -socket /run/php-fpm/".$appDir.".sock -idle-timeout 3600";
		my $extra_lines2 = "ScriptAlias /php-fpm-".$appDir."-handler.fcgi /php-fpm-".$appDir."-handler";
		
		my $lastline = "</IfModule>";
		my $index1 = -1;
		my $index2 = -1;
		
		if(open(FH, "< $update_file")){
			while(<FH>){
				chomp($_);
				$_ =~ s/^\s+|\s+$//g;
				
				if($_ eq $extra_lines1){
					$index1 = 0;
				}
				
				if($_ eq $extra_lines2){
					$index2 = 0;
				}
				
				if($index1 == 0 and $index2 == 0){
					last;
				}
			}
			close FH;
		}
		
		if(open(UPDATE_FILE, "+< $update_file")){
			my @filelines = <UPDATE_FILE>;
			my $size = $#filelines;
			if($index1 == -1){
				$filelines[$size] = $extra_lines1;
				$size++;
			}
			
			if($index2 == -1){
				$filelines[$size] = $extra_lines2;
				$size++;
			}
			
			if($index1 == -1 or $index2 == -1){
				$filelines[$size] = $lastline;	
			}
			seek(UPDATE_FILE, 0, 0);
			print UPDATE_FILE @filelines;
			close(UPDATE_FILE);
		}
	}
	
	if($ARGV[2] ne ""){
		goto START;
	}
	doCleanup($dsmVersion6);
}
